<?php
/*
 * Created on 2006.08.10.
 */

/**
 * _ticket_admin_unit_form:
 * @param $def - unit form default erteki
 */
function _ticket_admin_unit_form($def = array()) {
	$form['name'] = array(
		'#type' => 'textfield',
		'#title' => t('Unit name'),
		'#default_value' => $def['unit_name'],
		'#size' => 60,
		'#maxlength' => 255,
		'#required' => true,
	);

	$form['desc'] = array(
		'#type' => 'textarea',
		'#title' => t('Description'),
		'#default_value' => $def['description'],
		'#required' => false,
	);

	for ($i= -10 ;$i <= 10;$i++) {
		$weight[$i] = $i;
	}

	$form['weight'] = array(
		'#type' => 'select',
		'#title' => t('Weight'),
		'#default_value' => $def['weight'],
		'#options' => $weight,
	);

	$form['active'] = array(
		'#type' => 'select',
		'#title' => t('Active'),
		'#default_value' => $def['active'],
		'#options' => array(
			'1' => t('Yes'),
			'0' => t('No'),
		),
	);
	return $form;
}

/**
 * _ticket_admin_group_form:
 * @param $def - group form default erteki
 */
function _ticket_admin_group_form($def = array()) {
	$form['name'] = array(
		'#type' => 'textfield',
		'#title' => t('Group name'),
		'#default_value' => $def['group_name'],
		'#size' => 60,
		'#maxlength' => 255,
		'#required' => true,
	);

	$form['desc'] = array(
		'#type' => 'textarea',
		'#title' => t('Description'),
		'#default_value' => $def['description'],
		'#required' => false,
	);

	for ($i= -10 ;$i <= 10;$i++) {
		$weight[$i] = $i;
	}

	$form['weight'] = array(
		'#type' => 'select',
		'#title' => t('Weight'),
		'#default_value' => $def['weight'],
		'#options' => $weight,
	);

	$form['active'] = array(
		'#type' => 'select',
		'#title' => t('Active'),
		'#default_value' => $def['active'],
		'#options' => array(
			'1' => t('Yes'),
			'0' => t('No'),
		),
	);

	return $form;
}

/**
 * _ticket_admin_email_form:
 * @param $def - group form default erteki
 */
function _ticket_admin_email_form($def = array()) {
	$form['mailto'] = array(
		'#type' => 'textfield',
		'#title' => t('Group e-mail address'),
		'#description' => t('Mails sent to the following address will be transferred to the Group Collector Queue. Depending on the Incoming Mail pattern mail having been sent to this address is either transformed to a ticket or produce a Queue Element. The address given here is also the sender address of ticket update mails.'),
		'#default_value' => $def['mailto'],
		'#size' => 60,
		'#maxlength' => 255,
		'#required' => false,
	);

	$form['mailfrom'] = array(
		'#type' => 'textfield',
		'#title' => t('Incoming e-mail pattern'),
		'#description' => t("Sender e-mail pattern. If the sender's e-mail fits the pattern here, the mail will be automatically transferred to a ticket. Otherwise, the mail will be converted as a Queue Element. Global '*' can be used here"),
		'#default_value' => $def['mailfrom'],
		'#size' => 60,
		'#maxlength' => 255,
		'#required' => false,
	);

	$form['ticket'] = array(
		'#type' => 'fieldset',
		'#title' => t('Ticket').':',
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	$form['ticket']['tsubject'] = array(
		'#type' => 'textfield',
		'#title' => t('Ticket e-mail subject'),
		'#description' => t("Format of outgoing mail subject. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: <b>%tid</b> - Ticket id, <b>%g</b> - Group, <b>%tc</b> - Ticket creator, <b>%pri</b> - Priority, <b>%type</b> - Type, <b>%st</b> - Status, <b>%sc</b> - Scope, <b>%si</b> - Site, <b>%fixer</b> - Fixer, <b>%assigned</b> - Assigned to, <b>%ps</b> - Problem start, <b>%ss</b> - Short summary."),
		'#default_value' => $def['tsubject'],
		'#size' => 60,
		'#maxlength' => 50,
		'#required' => true,
	);

	$form['ticket']['tt_header'] = array(
		'#type' => 'textarea',
		'#title' => t('Ticket header template'),
		'#default_value' => $def['tt_header'],
		'#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in the case of mail subject, plus: <b>%pl</b> - Problem length, <b>%pf</b> - Problem finish, <b>%detail</b> - Detail, <b>%affected</b> - Affected, <b>%actions</b> - Actions, <b>%ttf</b> - Time to fix, <b>%fix</b> - Fix."),
		'#rows' => '8',
		'#required' => false,
	);

	$form['ticket']['tt_body'] = array(
		'#type' => 'textarea',
		'#title' => t('Ticket body template'),
		'#default_value' => $def['tt_body'],
		'#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail header."),
		'#rows' => '8',
		'#required' => false,
	);

	$form['ticket']['tt_footer'] = array(
		'#type' => 'textarea',
		'#title' => t('Ticket footer template'),
		'#default_value' => $def['tt_footer'],
		'#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail header."),
		'#rows' => '8',
		'#required' => false,
	);

	$form['event'] = array(
		'#type' => 'fieldset',
		'#title' => t('Events').':',
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	$event_pos = array(
		t('Before body'),
		t('After body'),
	);

	$form['event']['e_pos'] = array(
		'#type' => 'select',
		'#title' => t('Event placement'),
		'#options' => $event_pos,
		'#default_value' => $def['e_pos'],
		'#description' => t("Event's position relative to Ticket Body."),
	);

	$form['event']['sep'] = array(
		'#type' => 'textfield',
		'#title' => t('Event separator'),
		'#description' => t('Character string to separate Events from Ticket Body. (max. 80 character).'),
		'#default_value' => $def['sep'],
		'#size' => 60,
		'#maxlength' => 80,
		'#required' => false,
	);

	$form['event']['esubject'] = array(
		'#type' => 'textfield',
		'#title' => t('Event e-mail subject'),
		'#description' => t("Subject format of the outgoing mails. If left void, then the value given in 'Ticket e-mail subject' will be used. Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of mail subject, plus: <b>%eid</b> - Event ID, <b>%st</b> - Status, <b>%ra</b> - Re-assigned."),
		'#default_value' => $def['esubject'],
		'#size' => 60,
		'#maxlength' => 50,
	);

	$form['event']['etemplate'] = array(
		'#type' => 'textarea',
		'#title' => t('Event template'),
		'#default_value' => $def['etemplate'],
		'#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: the same as in case of ticket templates, plus: <b>%ec</b> - Event creator, <b>%edate</b> - Event created, <b>%edesc</b> - Event description, <b>%eid</b> - Event ID, <b>%st</b> - Status, <b>%ra</b> - Re-assigned."),
		'#rows' => '4',
		'#required' => false,
	);

	$event_type = array(
		t('Ticket and events in ascending order'),
		t('Ticket and events in descending order'),
		t('Only events in acsending order'),
		t('Only events in descending order'),
		t('Only new event')
	);

	$form['event']['e_type'] = array(
		'#type' => 'select',
		'#title' => t('Content of event mail'),
		'#options' => $event_type,
		'#default_value' => $def['e_type'],
	);

	$form['unchanged'] = array(
		'#type' => 'fieldset',
		'#title' => t('Unchanged ticket warning').':',
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);
	$form['unchanged']['unchanged_day'] = array(
		'#type' => 'textfield',
		'#title' => t('Number of days since the ticket is unchanged'),
//		'#description' => t(""),
		'#default_value' => $def['unchanged_day'],
		'#size' => 10,
		'#maxlength' => 3,
		'#required' => true,
	);
	$form['unchanged']['usubject'] = array(
		'#type' => 'textfield',
		'#title' => t('Unchanged ticket e-mail subject'),
//		'#description' => t(""),
		'#default_value' => $def['usubject'],
		'#size' => 60,
		'#maxlength' => 80,
	);
	$form['unchanged']['utemplate'] = array(
		'#type' => 'textarea',
		'#title' => t('Unchanged ticket e-mail template'),
		'#default_value' => $def['utemplate'],
		'#description' => t("Characters to use: <b>a-z A-Z 0-9 ,.-+*/%[]{}()</b> Special macros: <b>%tid</b> - Ticket id, <b>%g</b> - Group, <b>%tc</b> - Ticket creator, <b>%pri</b> - Priority, <b>%type</b> - Type, <b>%st</b> - Status, <b>%sc</b> - Scope, <b>%si</b> - Site, <b>%fixer</b> - Fixer, <b>%assigned</b> - Assigned, <b>%ps</b> - Problem start, <b>%pl</b> - Problem length, <b>%lm</b> - Last modification, <b>%ss</b> - Short summary."),
		'#rows' => '2',
		'#required' => false,
	);

	return $form;
}

/**
 * _ticket_admin_access_form:
 * @param $def - access form default erteki
 */
function _ticket_admin_access_form($var, $def = array()) {
	$form['name'] = array(
		'#type' => 'textfield',
		'#title' => t('Name'),
		'#default_value' => $def['name'],
		'#maxlength' => '32',
		'#size' => '30',
	);

	$ticket_access = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');
	foreach ($ticket_access as $ta) {
		$ta_list[$ta] = t($ta);
	}

	$form['perm'] = array(
		'#type' => 'checkboxes',
		'#title' => t('Access'),
		'#options' => $ta_list,
		'#default_value' => $def['perm'],
	);

	$form['role'] = array(
		'#type' => 'select',
		'#title' => t('Scope'),
		'#options' => $var['role'],
		'#default_value' => $def['role'],
	);
	// felhasznalok listaja
	$result = db_query("SELECT uid, name FROM {users} WHERE uid > 0");
	while ($row = db_fetch_array($result)) {
		$users[$row['uid']] = $row['name'];
	}

	$ur = db_query("SELECT uid FROM {users_roles} WHERE rid = %d ORDER BY uid", $def['role_id']);
	while ($urow = db_fetch_array($ur)) {
		$def_user[] = $urow['uid'];
	}

	$form['users'] = array(
		'#type' => 'fieldset',
		'#title' => t('Users').':',
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);
	$form['users']['user'] = array(
		'#type' => 'checkboxes',
		'#options' => $users,
		'#default_value' => $def_user,
		'#prefix' => '<div class="ticket-chb-scroll">',
		'#suffix' => '</div>',
	);
	return $form;
}

/**
 * _ticket_admin_group_add_extension: csoporthoz tartozo tulajdonsagok letrehozasa alapertelmezett ertekekkel.
 * @param: $gid - group id 
 */
function _ticket_admin_group_add_extension($gid) {
	global $ticket_conf;

	$SQL = 'INSERT INTO {ticket_template} (gid, mailto, mailfrom, tsubject, esubject, usubject, sep, e_type, e_pos';
	$SQL .= ", tt_header, tt_body, tt_footer, etemplate, utemplate)";
	$SQL .= " VALUES (%d, '%s', '%s', '%s', '%s', '%s', '%s', %d, %d, '%s', '%s', '%s', '%s', '%s')";
	db_query($SQL, $gid, $ticket_conf['def']['template']['mailto'], $ticket_conf['def']['template']['mailfrom'], $ticket_conf['def']['template']['tsubject'], $ticket_conf['def']['template']['esubject'], $ticket_conf['def']['template']['usubject'], $ticket_conf['def']['template']['sep'], $ticket_conf['def']['template']['e_type'], $ticket_conf['def']['template']['e_pos'], $ticket_conf['def']['template']['tt_header'], $ticket_conf['def']['template']['tt_body'], $ticket_conf['def']['template']['tt_footer'], $ticket_conf['def']['template']['etemplate'], $ticket_conf['def']['template']['utemplate']);

	$SQL = 'INSERT INTO {ticket_status} (gid, status_id, status_name, weight, closed, def, active)';
	$SQL .= " VALUES (%d, %d, '%s', %d, %d, %d, %d)";
	foreach ($ticket_conf['def']['status']['open'] as $def) {
		db_query($SQL, $gid, db_next_id('{ticket_status}_status_id'), $def['name'], $def['weight'], 0, $def['def'], 1);
	}

	foreach ($ticket_conf['def']['status']['closed'] as $def) {
		db_query($SQL, $gid, db_next_id('{ticket_status}_status_id'), $def['name'], $def['weight'], 1, $def['def'], 1);
	}

	$tables = array('priority', 'type', 'fixer', 'site', 'scope');
	foreach ($tables as $table) {
		if ( ( is_array($ticket_conf['def'][$table]) ) && ( count($ticket_conf['def'][$table]) ) ) {
			$SQL = 'INSERT INTO {ticket_'.$table.'} (gid, '.$table.'_id, '.$table.'_name, weight, def, active)';
			$SQL .= " VALUES (%d, %d, '%s', %d, %d, %d)";
			foreach ($ticket_conf['def'][$table] as $def) {
				db_query($SQL, $gid, db_next_id('{ticket_'.$table.'}_'.$table.'_id'), $def['name'], $def['weight'], $def['def'], 1);
			}
		}
	}
	_ticket_admin_chk_db_default($gid);
}

/**
 * _ticket_admin_chk_db_default: az alapertelemzett ertek megletet ellenorzi, ha
 * nincs akkor beallit egyett.
 * @param: $gid - group id 
 */
function _ticket_admin_chk_db_default($gid, $table = NULL) {
	if ( isset($table) ) {
		$tables[] = $table;
	} else {
		$tables = array('status', 'priority', 'type', 'fixer', 'site', 'scope');
	}
	foreach ( $tables as $table) {
		$SQL = "SELECT * FROM {ticket_".$table."} WHERE gid = %d";

		if ( $table == 'status' ) {
			for ($i = 0; $i <= 1 ; $i++) {
				$result = db_query_range("SELECT ".$table."_id FROM {ticket_".$table."} WHERE gid = %d AND closed = %d", $gid, $i, 0, 1);
				if ( db_num_rows($result) ) {
					$rs = db_query_range("SELECT ".$table."_id FROM {ticket_".$table."} WHERE gid = %d AND def = 1 AND closed = %d", $gid, $i, 0, 1);
					if ( !db_num_rows($rs) ) {
						$row = db_fetch_array($result);
						db_query("UPDATE {ticket_".$table."} SET def = 1 WHERE ".$table."_id = %d", $row[$table.'_id']);
					}
				}
			}
		} else {
			$result = db_query_range("SELECT ".$table."_id FROM {ticket_".$table."} WHERE gid = %d ", $gid, 0, 1);
			if ( db_num_rows($result) ) {
				$rs = db_query_range("SELECT ".$table."_id FROM {ticket_".$table."} WHERE gid = %d AND def = 1", $gid, 0, 1);
				if ( !db_num_rows($rs) ) {
					$row = db_fetch_array($result);
					db_query("UPDATE {ticket_".$table."} SET def = 1 WHERE ".$table."_id = %d", $row[$table.'_id']);
				}
			}
		}
	}
	
}

/**
 * _ticket_admin_group_edit_menu: csoport szerkesztesekor megjeleno menu
 * @param: $gid - group id 
 * @param: $active - active menu name 
 */
function _ticket_admin_group_edit_menu($gid, $active = 'group') {
	$output = '';

	$menus[] = array('action' => 'group', 'name' => t('edit group'), 'link' => 'admin/ticket/edit/group/'.$gid);
	$menus[] = array('action' => 'e-mail', 'name' => t('e-mail template'), 'link' => 'admin/ticket/edit/template/'.$gid);
	$menus[] = array('action' => 'fixer', 'name' => t('set fixer'), 'link' => 'admin/ticket/set/fixer/'.$gid);
	$menus[] = array('action' => 'mail', 'name' => t('set mail'), 'link' => 'admin/ticket/set/mail/'.$gid);
	$menus[] = array('action' => 'priority', 'name' => t('set priority'), 'link' => 'admin/ticket/set/priority/'.$gid);
	$menus[] = array('action' => 'scope', 'name' => t('set scope'), 'link' => 'admin/ticket/set/scope/'.$gid);
	$menus[] = array('action' => 'site', 'name' => t('set site'), 'link' => 'admin/ticket/set/site/'.$gid);
	$menus[] = array('action' => 'status', 'name' => t('set status'), 'link' => 'admin/ticket/set/status/'.$gid);
	$menus[] = array('action' => 'type', 'name' => t('set type'), 'link' => 'admin/ticket/set/type/'.$gid);
	$menus[] = array('action' => 'help', 'name' => t('help'), 'link' => 'admin/ticket/edit/help/'.$gid);

	$output = _ticket_secondary_menu($menus, $active);
	return $output;
}

/**
 * Settings for the ticket module
 * @return form contents for this module
 */
function ticket_admin() {
	/** unitok listaja */
	$result = db_query("SELECT u_id, unit_name FROM {ticket_unit} ORDER BY active DESC, weight ASC, unit_name ASC");
	while ($row = db_fetch_array($result)) {
		$output .= $row['unit_name'].'<br>';

		/** unit es group adminisztrator szamara link keszites */
		if ( ticket_access('ticket administer', $row['u_id'], '*') ) {
			$row['unit_name'] = l($row['unit_name'], 'admin/ticket/'.$row['u_id']);
			$row['unit_groups'] = l(t('list groups'), 'admin/ticket/'.$row['u_id']);
		} else {
			$row['unit_groups'] = t('list groups');
		}

		/** unit adminisztrator szamara link keszites */
		if ( ticket_access('ticket administer', $row['u_id'], 0) ) {
			$row['unit_edit'] = l(t('edit unit'), 'admin/ticket/edit/unit/'.$row['u_id']);
		} else {
			$row['unit_edit'] = t('edit unit');
		}

		/** Tablazat sorai */
		$rows[] = array(
			array('data' => $row['unit_name'], 'class' => 'unit_name'),
			array('data' => $row['unit_edit'], 'class' => 'unit_edit'),
			array('data' => $row['unit_groups'], 'class' => 'unit_groups'),
		);
	}
	return theme("ticket_admin", $rows);
}

/**
 * theme_ticket_admin:
 * @param: $rows - tablazat sorai
 */
function theme_ticket_admin($rows) {
	$header = array(
		array('data' => t('Name')),
		array('data' => t('Operations'), 'colspan' => '2'),
	);
	$output .= theme('table', $header, $rows);
	return $output;
}

/**
 * ticket_admin_help: help
 * @param: $gid - group id
 */
function ticket_admin_help($gid) {
	$output = _ticket_admin_group_edit_menu($gid, 'help');
	$output .= t("<h1>E-mail example:</h1>\r\n<dl>\r\n<dt><b>Group e-mail address:</b></dt>\r\n  <dd>Depending on settings mails sent to the the following address will either directly transformed to a trouble ticket or will be put on a temporal collector queue. This address is also used as the From-address of the outgoing mails. If this field is left void, the mail sending/receiving subsystem will be turned off.</dd>\r\n<dt><b>Incoming e-mail address example:</b></dt>\r\n  <dd>Sender example expression. Those tickets for that the sender matches the expression will be automatically converted to trouble tickets, otherwise they will be put on a temporary collector queue. Those mails that do not match to the expression will be transformed to a temporary Queue Element. Global symbol '*' can be used. If this field is left void, the mail receiving subsystem will be turned off. </dd>\r\n</dl>\r\n\r\n<h2>Trouble ticket:</h2> The mail format when creating a ticket is given here. <br />\r\n<dl>\r\n<dt><b>Subject of mail ticket:</b></dt>\r\n  <dd>Outgoing mail subject format. Valid expressions are shown in the table below: </dd>\r\n<dt><b>Ticket header example:</b></dt>\r\n  <dd>This is shown in the upper body of all outgoing mail tickets. Valid expressions are shown in the table below.</dd>\r\n<dt><b>Ticket body example:</b></dt>\r\n  <dd>Its appearance is dependent on \"Event-mail content\" setting. In any case it is positioned between the mail header and footer. Valid expressions are shown in the table below.</dd>\r\n<dt><b>Ticket footer example:</b></dt>\r\n  <dd>It appears at the bottom part of all outgoing mail. Valid expressions are shown in the table below.</dd>\r\n</dl>\r\n<h2>Events:</h2>  Format of updated mail tickets  is defined here. <br />\r\n<dl>\r\n<dt><b>Event position:</b></dt>\r\n  <dd>It determines the placement of \"Event example\".</dd>\r\n<dt><b>Event separator:</b></dt>\r\n  <dd>The string given here will be inserted among events in mail tickets.</dd>\r\n<dt><b>Event e-mail subject:</b></dt>\r\n  <dd>Format of outgoing mail subject. If left void, it uses the value of \"Ticket e-mail subject\". Valid expressions are shown in the table below.</dd>\r\n<dt><b>Event example:</b></dt>\r\n  <dd>Its function and placement are the same as in case of \"Ticket body example\". Valid expressions are shown in the table below.</dd>\r\n<dt><b>Event mail content:</b></dt>\r\n  <dd>Event content elements and their sequence can be given here.</dd>\r\n</dl>\r\n<dl>\r\n<dt><b>Unmodified ticket warning:</b></dt>\r\n  <dd>In this section a warning message can be configured for those tickets that have not been modified for a while.</dd>\r\n<dt><b>Unmodified since:</b></dt>\r\n  <dd>A warning message will be sent on behalf of those open tickets that have not been modified since the time given. If this value is \"0\", no warning message will be sent.</dd>\r\n<dt><b>Unmodified ticket warning mail subject:</b></dt>\r\n  <dd>The subject of warning mail.</dd>\r\n<dt><b>Unmodified ticket mail template:</b></dt>\r\n  <dd>Content of mail periodically sent on behalf of the unmodified ticket.</dd>\r\n</dl>\r\n<h2>Valid expressions (more info on e-mail example page):</h2>\r\n<ul>\r\n<li> a-z A-Z 0-9 ,.-+*/%[]{}() </li>\r\n<li> %actions: Actions </li>\r\n<li> %affected: Affected </li>\r\n<li> %assigned: Assigned to </li>\r\n<li> %detail: Details </li>\r\n<li> %ec: Event updated by </li>\r\n<li> %edate: Event time </li>\r\n<li> %edesc: Event description </li>\r\n<li> %eid: Event identifier </li>\r\n<li> %fix: Fix </li>\r\n<li> %fixer: Fixer </li>\r\n<li> %g: Group </li>\r\n<li> %pf: Problem ended </li>\r\n<li> %pl: Problem duration </li>\r\n<li> %pri: Priority </li>\r\n<li> %ps: Problem started </li>\r\n<li> %ra: Re-assigned to </li>\r\n<li> %sc: Scope </li>\r\n<li> %si: Site </li>\r\n<li> %ss: Summary </li>\r\n<li> %st: Status </li>\r\n<li> %tc: Created by </li>\r\n<li> %tid: Ticket identifier </li>\r\n<li> %ttf: Time to fix </li>\r\n<li> %type: Type </li>\r\n</ul>");

	$output .= t("<h1>Status settings:</h1>\r\n<dl>\r\n<dt><b>Status:</b></dt>\r\n  <dd>Status name. <br />\r\n<dt><b>Closed:</b></dt>\r\n  <dd>If it is of closed type, it can be selected when closing a ticket. Otherwise, it can be the status of the update event.</dd>\r\n<dt><b>Permitted:</b></dt>\r\n  <dd>To preserve the integrity of the ticketing system it cannot be deleted. If the property is not permitted, the system treats it as deleted.</dd>\r\n<dt><b>Weight:</b></dt>\r\n  <dd>It determines the sequence of elements, as in other cases in Dupal.</dd>\r\n<dt><b>Level:</b></dt>\r\n  <dd>Its primary purpose is to allow distinguishing tickets being in different status.</dd>\r\n</dl>");
	return $output;
}

/******************************************************************
 *************************** ADMIN UNIT ***************************
 *****************************************************************/

/**
 * ticket_admin_add_unit: unit hozzaadas
 */
function ticket_admin_add_unit() {
	$form = _ticket_admin_unit_form(array('weight' => 0));
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Save')
	);
	$output = drupal_get_form('ticket_admin_add_unit', $form);
	return $output;
}

/**
 * ticket_admin_add_unit_validate: add unit formrol erkezo adatok ellenorzese 
 */
function ticket_admin_add_unit_validate($form_id, $form) {
	/** azonos nevu unit nem johet letre */
	$result = db_query("SELECT count(u_id) as num FROM {ticket_unit} WHERE unit_name = '%s'", $form['name']);
	$row = db_fetch_array($result);

	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this unit of settings.'));
	}
}

/**
 * ticket_admin_add_unit_submit: unit hozzaadas
 */
function ticket_admin_add_unit_submit($form_id, $form) {
	/** unit hozzaadasa */
	$SQL = "INSERT INTO {ticket_unit} (u_id, unit_name, description, weight, active) VALUES (%d, '%s', '%s', %d, %d)";
	db_query($SQL, db_next_id('{ticket_unit}_u_id'), $form['name'], $form['desc'], $form['weight'], $form['active']);
}

/**
 * ticket_admin_edit_unit: unit szerkesztes
 * @param: $u_id - unit id
 */
function ticket_admin_edit_unit($u_id) {
	/** unit lekerdezese, a vissza adott ertekek atadasa a formnak */
	$result = db_query("SELECT * FROM {ticket_unit} WHERE u_id = %d", $u_id);
	$def = db_fetch_array($result);

	$form = _ticket_admin_unit_form($def);
	$form['u_id'] = array(
		'#type' => 'value',
		'#value' => $u_id,
	);
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Save')
	);
	$output = drupal_get_form('ticket_admin_edit_unit', $form);
	return $output;
}

/**
 * ticket_admin_edit_unit_validate: edit unit formrol erkezo adatok ellenorzese
 */
function ticket_admin_edit_unit_validate($form_id, $form) {
	/** azonos nevu unit nem johet letre */
	$result = db_query("SELECT count(u_id) as num FROM {ticket_unit} WHERE u_id != %d AND unit_name = '%s'", $form['u_id'],$form['name']);
	$row = db_fetch_array($result);

	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this unit of settings.'));
	}
}

/**
 * ticket_admin_edit_unit_submit: unit modositas
 */
function ticket_admin_edit_unit_submit($form_id, $form) {
	/** unit szerkesztese */
	$SQL = "UPDATE {ticket_unit} SET unit_name = '%s', description = '%s', weight = %d, active = %d WHERE u_id = %d";
	db_query($SQL, $form['name'], $form['desc'], $form['weight'], $form['active'], $form['u_id']);
	drupal_goto('admin/ticket');
}

/*******************************************************************
 *************************** ADMIN GROUP ***************************
 ******************************************************************/

/**
 * ticket_admin_list_groups: unithoz tartozo csoportok listaja
 * @param: $u_id - unit id
 */
function ticket_admin_list_groups($u_id) {
	/** unithoz tartozo csoportok listaja */
	$result = db_query("SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d ORDER BY active DESC, weight ASC, group_name ASC", $u_id);
	while ($row = db_fetch_array($result)) {
		$output .= $row['group_name'].'<br>';

		/** csoport adminisztrator szamara link keszites */
		if ( ticket_access('ticket administer', $u_id, $row['gid']) ) {
			$row['group_edit'] = l(t('edit group'), 'admin/ticket/edit/group/'.$row['gid']);
		} else {
			$row['group_edit'] = t('edit group');
		}

		/** tablazat sorai */
		$rows[] = array(
			array('data' => $row['group_name'], 'class' => 'group_name'),
			array('data' => $row['group_edit'], 'class' => 'group_edit'),
		);
	}
	return theme("ticket_admin_list_groups", $rows);
}

/**
 * theme_ticket_admin_list_groups: theme hook
 * @param: $rows - tablazat sorai
 */
function theme_ticket_admin_list_groups($rows) {
	$header = array(
		array('data' => t('Name')),
		array('data' => t('Operations')),
	);
	$output .= theme('table', $header, $rows);
	return $output;
}

/**
 * ticket_admin_add_group: csoport letrehozasa
 * @param: $u_id - unit id
 */
function ticket_admin_add_group($u_id) {
	$def['weight'] = 0;
	$form = _ticket_admin_group_form($def);
	$form['u_id'] = array(
		'#type' => 'value',
		'#value' => $u_id,
	);
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Save')
	);
	$output = drupal_get_form('ticket_admin_add_group', $form);
	return $output;
}

/**
 * ticket_admin_add_group_validate: add group formrol erkezo adatok ellenorzese 
 */
function ticket_admin_add_group_validate($form_id, $form) {
	/** azonos nevu csoport egy uniton belul nem johet letre */
	$result = db_query("SELECT count(u_id) as num FROM {ticket_group} WHERE u_id = %d AND group_name = '%s'", $form['u_id'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this group of settings.'));
	}
}

/**
 * ticket_admin_add_group_submit: csoport hozzaadas
 */
function ticket_admin_add_group_submit($form_id, $form) {
	/** group hozzaadasa */
	$SQL = "INSERT INTO {ticket_group} (gid, u_id, group_name, description, weight, active) VALUES (%d, %d, '%s', '%s', %d, %d)";
	$gid = db_next_id('{ticket_group}_gid');
	db_query($SQL, $gid, $form['u_id'], $form['name'], $form['desc'], $form['weight'], $form['active']);
	_ticket_admin_group_add_extension($gid);
	drupal_goto('admin/ticket/edit/group/'.$gid);
}

/**
 * ticket_admin_edit_group: group szerkesztes
 * @param: $gid - group id
 */
function ticket_admin_edit_group($gid) {
	/** csoport lekerdezese, a vissza adott ertekek atadasa a formnak */

	$result = db_query("SELECT * FROM {ticket_group} WHERE gid = %d", $gid);
	$def = db_fetch_array($result);

	$form = _ticket_admin_group_form($def);
	$form['gid'] = array(
		'#type' => 'value',
		'#value' => $gid,
	);
	$form['u_id'] = array(
		'#type' => 'value',
		'#value' => $def['u_id'],
	);
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Save')
	);
	_ticket_breadcrumb('admin/ticket/'.$def['u_id'], array('admin/ticket/'.$def['u_id'] => t('list groups')));
	drupal_set_title($def['group_name']);

	$output = _ticket_admin_group_edit_menu($gid, 'group');
	$output .= drupal_get_form('ticket_admin_edit_group', $form);
	return $output;
}

/**
 * ticket_admin_edit_group_validate: edit group formrol erkezo adatok ellenorzese
 */
function ticket_admin_edit_group_validate($form_id, $form) {
	/** azonos nevu csoport egy uniton belul nem johet letre */
	$result = db_query("SELECT count(u_id) as num FROM {ticket_group} WHERE gid != %d AND group_name = '%s'", $form['gid'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this group of settings.'));
	}
}

/**
 * ticket_admin_edit_group_submit: csoport modositas
 */
function ticket_admin_edit_group_submit($form_id, $form) {
	/** csoport szerkesztese */
	$SQL = "UPDATE {ticket_group} SET group_name = '%s', description = '%s', weight = %d, active = %d WHERE gid = %d";
	db_query($SQL, $form['name'], $form['desc'], $form['weight'], $form['active'], $form['gid']);

	$result = db_query("SELECT u_id FROM {ticket_group} WHERE gid = %d", $form['gid']);
	$row = db_fetch_array($result);
	drupal_goto('admin/ticket/'.$row['u_id']);
}

/******************************************************************
 ************************* ADMIN TEMPLATE *************************
 *****************************************************************/

/**
 * ticket_admin_edit_template: template szerkesztes
 * @param: $gid - group id
 */
function ticket_admin_edit_template($gid) {
	/** csoport lekerdezese, a vissza adott ertekek atadasa a formnak */
	$result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $gid);
	$def = db_fetch_array($result);

	$result = db_query("SELECT * FROM {ticket_group} WHERE gid = %d", $gid);
	$row = db_fetch_array($result);

	$form = _ticket_admin_email_form($def);
	$form['gid'] = array(
		'#type' => 'value',
		'#value' => $gid,
	);
	$form['u_id'] = array(
		'#type' => 'value',
		'#value' => $row['u_id'],
	);
	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Save')
	);
	_ticket_breadcrumb('admin/ticket/'.$row['u_id'], array('admin/ticket/'.$row['u_id'] => t('list groups')));
	drupal_set_title($row['group_name']);

	$output = _ticket_admin_group_edit_menu($gid, 'e-mail');
	$output .= drupal_get_form('ticket_admin_edit_template', $form);
	return $output;
}

/**
 * ticket_admin_edit_template_validate: template ellenorzes
 */
function ticket_admin_edit_template_validate($form_id, $form) {
	/** e-mail cim ellenorzes */
	if ($form['mailto'] != '') {
		if (!valid_email_address($form['mailto']) ) {
			form_set_error('mailto', t('Faulty e-mail address!'));
		} else {
			$result = db_query("SELECT count(*) AS num FROM {ticket_template} WHERE gid != %d AND mailto = '%s'", $form['gid'], $form['mailto']);
			$row = db_fetch_array($result);
			if ( $row['num'] ) {
				form_set_error('mailto', t('Another group is using this e-mail address.'));
			}
		}
	}
}

/**
 * ticket_admin_edit_template_submit: template jellemzok modositasa
 */
function ticket_admin_edit_template_submit($form_id, $form) {
	/** e-mail jellemzok szerkesztese */
	$SQL = "UPDATE {ticket_template} SET mailto = '%s', mailfrom = '%s', tsubject = '%s', esubject = '%s', usubject = '%s',";
	$SQL .= " sep = '%s', e_type = %d, e_pos = %d, unchanged_day = %d, tt_header = '%s', tt_body = '%s', tt_footer = '%s',";
	$SQL .= " etemplate = '%s', utemplate = '%s' WHERE gid = %d";
	db_query($SQL, $form['mailto'], $form['mailfrom'], $form['tsubject'], $form['esubject'], $form['usubject'], $form['sep'], $form['e_type'], $form['e_pos'], $form['unchanged_day'], $form['tt_header'], $form['tt_body'], $form['tt_footer'], $form['etemplate'], $form['utemplate'], $form['gid']);

	drupal_goto('admin/ticket/edit/template/'.$form['gid']);
}

/******************************************************************
 ********************** ADMIN ALL SET IN ONE **********************
 *****************************************************************/

/**
 * ticket_admin_set: beallitasok
 * @param: $action - set name
 * @param: $gid - group id
 */
function ticket_admin_set($action, $gid) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	$output = _ticket_admin_group_edit_menu($gid, $action);

	/** Csoport nev lekerdezese */
	$result = db_query("SELECT group_name FROM {ticket_group} WHERE gid = %d", $gid);
	$group = db_fetch_array($result);
	drupal_set_title($group['group_name']);

	switch ($action) {
		case 'fixer':
		case 'priority':
		case 'scope':
		case 'site':
		case 'type':
			/** Csoporthoz tartozo $action lista lekerdezese */
			$result = db_query('SELECT * FROM {ticket_'.$action.'} WHERE gid = %d  ORDER BY active DESC, weight ASC, '.$action.'_name ASC', $gid);

			if ( db_num_rows($result) ) {
				/** weight ertekeinek elokeszitese */
				for ($i= -10 ;$i <= 10;$i++) {
					$weight[$i] = $i;
				}
				/** active ertekeinek elokeszitese */
//				$active = array('1' => t('Yes'), '0' => t('No'), );
				/** tree form struktura bekapcsolasa */
				$form['#tree'] = TRUE;
				/** lekerdezes feldolgozasa */
				while ($row = db_fetch_array($result)) {
					/** set $action form generalasa */
					$form[$row[$action.'_id']]['name'] = array('#type' => 'textfield', '#default_value' => $row[$action.'_name'],
						'#size' => 40, '#maxlength' => 255,);
					$form[$row[$action.'_id']]['weight'] = array('#type' => 'select', '#options' => $weight, '#default_value' => $row['weight'],);
//					$form[$row[$action.'_id']]['active'] = array('#type' => 'select', '#options' => $active, '#default_value' => $row['active'],);
					$form[$row[$action.'_id']]['active'] = array('#type' => 'checkbox', '#default_value' => $row['active']);
					/** default ertekek elokeszitese */
					if ($row['active']) {
						$def[$row[$action.'_id']] = $row[$action.'_name'];
						if ($row['def']) {
							$def_def = $row[$action.'_id'];
						}
					}
				}

				$form['gid'] = array('#type' => 'value', '#value' => $gid,);
				$form['reset'] = array('#type' => 'submit', '#value' => t('Reset'));
				$form['submit'] = array('#type' => 'submit', '#value' => t('Save'));

				/** set $action form elkeszitese */
				$output .= drupal_get_form('ticket_admin_set_form', $form);
				if ( count($def) ) {
					/** default $action form elkeszitese */
					$form_def['default'] = array(
						'#type' => 'fieldset',
						'#title' => t('Default '.$action).':',
						'#collapsible' => TRUE,
						'#collapsed' => false,
					);

					$form_def['default']['def'] = array(
						'#type' => 'select',
						'#options' => $def,
						'#default_value' => $def_def,
					);

					$form_def['default']['gid'] = array(
						'#type' => 'value',
						'#value' => $gid,
					);
	
					$form_def['default']['submit'] = array(
						'#type' => 'submit',
						'#value' => t('Save')
					);

					$output .= drupal_get_form('ticket_admin_set_def_form', $form_def);
				}
			}

			/** add $action form elkeszitese */
			$form_add['add'] = array(
				'#type' => 'fieldset',
				'#title' => t('Add '.$action).':',
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_add['add']['name'] = array(
				'#type' => 'textfield',
				'#title' => t(ucfirst($action).' name'),
				'#size' => 60,
				'#maxlength' => 255,
				'#required' => true,
			);

			for ($i= -10 ;$i <= 10;$i++) {
				$weight[$i] = $i;
			}

			$form_add['add']['weight'] = array(
				'#type' => 'select',
				'#title' => t('Weight'),
				'#default_value' => array('weight' => 0),
				'#options' => $weight,
			);

			$form_add['add']['active'] = array(
				'#type' => 'select',
				'#title' => t('Active'),
				'#options' => array(
					'1' => t('Yes'),
					'0' => t('No'),
				),
			);

			$form_add['add']['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_add['add']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save')
			);

			$output .= drupal_get_form('ticket_admin_add_set', $form_add, $action);
		break;
		case 'mail':
			/** Csoporthoz tartozo e-mail lista lekerdezese */
			$result = db_query("SELECT * FROM {ticket_mail} WHERE gid = %d  ORDER BY active DESC, mail_name ASC", $gid);

			if ( db_num_rows($result) ) {
				/** active ertekeinek elokeszitese */
		//		$active = array('1' => t('Yes'), '0' => t('No'), );
				/** tree form struktura bekapcsolasa */
				$form['#tree'] = TRUE;
				/** lekerdezes feldolgozasa */
				while ($row = db_fetch_array($result)) {
					/** set mail form generalasa */
					$form[$row['mail_id']]['def'] = array('#type' => 'checkbox', '#default_value' => $row['def']);
					$form[$row['mail_id']]['name'] = array('#type' => 'textfield', '#default_value' => $row['mail_name'],
						'#size' => 30, '#maxlength' => 255,);
					$form[$row['mail_id']]['mailto'] = array('#type' => 'textfield', '#default_value' => $row['mailto'],
						'#size' => 30, '#maxlength' => 255,);
		//			$form[$row['fixer_id']]['active'] = array('#type' => 'select', '#options' => $active, '#default_value' => $row['active'],);
					$form[$row['mail_id']]['active'] = array('#type' => 'checkbox', '#default_value' => $row['active']);
				}

				$form['gid'] = array('#type' => 'value', '#value' => $gid,);
				$form['reset'] = array('#type' => 'submit', '#value' => t('Reset'));
				$form['submit'] = array('#type' => 'submit', '#value' => t('Save'));

				/** set mail form elkeszitese */
				$output .= drupal_get_form('ticket_admin_set_mail_form', $form);
			}

			/** add mail form elkeszitese */
			$form_add['add'] = array(
				'#type' => 'fieldset',
				'#title' => t('Add e-mail address').':',
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_add['add']['name'] = array(
				'#type' => 'textfield',
				'#title' => t('E-mail name'),
				'#size' => 60,
				'#maxlength' => 255,
				'#required' => true,
			);

			$form_add['add']['mailto'] = array(
				'#type' => 'textfield',
				'#title' => t('E-mail address'),
				'#size' => 60,
				'#maxlength' => 255,
				'#required' => true,
			);

			$form_add['add']['def'] = array(
				'#type' => 'select',
				'#title' => t('Default'),
				'#default_value' => 0,
				'#options' => array(
					'1' => t('Yes'),
					'0' => t('No'),
				),
			);

			$form_add['add']['active'] = array(
				'#type' => 'select',
				'#title' => t('Active'),
				'#options' => array(
					'1' => t('Yes'),
					'0' => t('No'),
				),
			);

			$form_add['add']['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_add['add']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save')
			);

			$output .= drupal_get_form('ticket_admin_add_mail', $form_add);
		break;
		case 'status':
			global $ticket_conf;
			/** Csoporthoz tartozo status lista lekerdezese */
			$result = db_query('SELECT * FROM {ticket_status} WHERE gid = %d  ORDER BY active DESC, closed ASC, weight ASC, status_name ASC', $gid);

			if ( db_num_rows($result) ) {
				/** weight ertekeinek elokeszitese */
				for ($i= -10 ;$i <= 10;$i++) {
					$weight[$i] = $i;
				}
				/** active ertekeinek elokeszitese */
//				$active = array('1' => t('Yes'), '0' => t('No'), );
				/** tree form struktura bekapcsolasa */
				$form['#tree'] = TRUE;
				$stage = array();
				foreach ($ticket_conf['stage'] as $key => $value) {
					$stage[$key] = 'stage-'.$key;
				}
				/** lekerdezes feldolgozasa */
				while ($row = db_fetch_array($result)) {
					/** set status form generalasa */
					$form[$row[$action.'_id']]['name'] = array('#type' => 'textfield', '#default_value' => $row[$action.'_name'],
						'#size' => 40, '#maxlength' => 255,);
					$form[$row[$action.'_id']]['closed'] = array('#type' => 'select', '#options' => array('1' => t('Yes'), '0' => t('No'), ), '#default_value' => $row['closed'],);
					$form[$row[$action.'_id']]['active'] = array('#type' => 'checkbox', '#default_value' => $row['active']);
					$form[$row[$action.'_id']]['weight'] = array('#type' => 'select', '#options' => $weight, '#default_value' => $row['weight'],);
					$form[$row[$action.'_id']]['stage'] = array('#input' => TRUE, '#type' => 'selectcolor', '#options' => $ticket_conf['stage'], '#class' => $stage, '#default_value' => $row['stage'],);
					
					/** default ertekek elokeszitese */
					if ($row['active']) {
						$def[$row['closed']][$row['status_id']] = $row['status_name'];
						if ($row['def']) {
							$def_def[$row['closed']] = $row['status_id'];
						}
					}
				}

				$form['gid'] = array('#type' => 'value', '#value' => $gid,);
				$form['reset'] = array('#type' => 'submit', '#value' => t('Reset'));
				$form['submit'] = array('#type' => 'submit', '#value' => t('Save'));

				/** set status form elkeszitese */
				$output .= drupal_get_form('ticket_admin_set_status_form', $form);

				/** default open status form elkeszitese */
				if ( count($def[0]) ) {
					$form_def['default'] = array(
						'#type' => 'fieldset',
						'#title' => t('Default open status').':',
						'#collapsible' => TRUE,
						'#collapsed' => false,
					);

					$form_def['default']['def'] = array(
						'#type' => 'select',
						'#options' => $def[0],
						'#default_value' => $def_def[0],
					);

					$form_def['default']['gid'] = array(
						'#type' => 'value',
						'#value' => $gid,
					);

					$form_def['default']['submit'] = array(
						'#type' => 'submit',
						'#value' => t('Save')
					);

					$output .= drupal_get_form('ticket_admin_open_status_def_form', $form_def);
				}
				/** default closed status form elkeszitese */
				if ( count($def[1]) ) {
					$form_def_c['default'] = array(
						'#type' => 'fieldset',
						'#title' => t('Default closed status').':',
						'#collapsible' => TRUE,
						'#collapsed' => false,
					);

					$form_def_c['default']['def'] = array(
						'#type' => 'select',
						'#options' => $def[1],
						'#default_value' => $def_def[1],
					);

					$form_def_c['default']['gid'] = array(
						'#type' => 'value',
						'#value' => $gid,
					);

					$form_def_c['default']['submit'] = array(
						'#type' => 'submit',
						'#value' => t('Save')
					);

					$output .= drupal_get_form('ticket_admin_closed_status_def_form', $form_def_c);
				}
			}

			/** add status form elkeszitese */
			$form_add['add'] = array(
				'#type' => 'fieldset',
				'#title' => t('Add status').':',
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_add['add']['name'] = array(
				'#type' => 'textfield',
				'#title' => t('Status name'),
				'#size' => 60,
				'#maxlength' => 255,
				'#required' => true,
			);

			for ($i= -10 ;$i <= 10;$i++) {
				$weight[$i] = $i;
			}

			$form_add['add']['weight'] = array(
				'#type' => 'select',
				'#title' => t('Weight'),
				'#default_value' => 0,
				'#options' => $weight,
			);

			$form_add['add']['stage'] = array(
				'#input' => TRUE,
				'#type' => 'selectcolor',
				'#title' => t('Stage'),
				'#options' => $ticket_conf['stage'],
				'#class' => $stage,
				'#default_value' => '',
			);

			$form_add['add']['closed'] = array(
				'#type' => 'select',
				'#title' => t('Closed'),
				'#default_value' => 0,
				'#options' => array(
					'1' => t('Yes'),
					'0' => t('No'),
				),
			);

			$form_add['add']['active'] = array(
				'#type' => 'select',
				'#title' => t('Active'),
				'#options' => array(
					'1' => t('Yes'),
					'0' => t('No'),
				),
			);

			$form_add['add']['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_add['add']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save')
			);

			$output .= drupal_get_form('ticket_admin_add_status', $form_add, $action);
		break;
	}

	/** szep breadcrumb keszites */
	$result = db_query("SELECT u_id FROM {ticket_group} WHERE gid = %d", $gid);
	$group = db_fetch_array($result);
	_ticket_breadcrumb('admin/ticket/'.$group['u_id'], array('admin/ticket/'.$group['u_id'] => t('list groups')));

	return $output;
}

/**
 * theme_ticket_admin_set_form: tablazat alaku form keszites
 */
function theme_ticket_admin_set_form($form) {
	$output = '';
	foreach (element_children($form) as $i) {
		if (is_array($form[$i]['name'])) {
			// Generate table row
			$rows[] = array(
				form_render($form[$i]['name']),
				form_render($form[$i]['active']),
				form_render($form[$i]['weight']),
			);
		}
	}
	// Finish table

	$header = array(t(ucfirst(arg(3))), t('Enabled'), t('Weight'));

	$output .= '<fieldset class="collapsible"><legend>'.t('List '.ucfirst(arg(3))).':</legend>';
	$output .= theme('table', $header, $rows);
	$output .= '<div class="ticket-button-line">';
	$output .= form_render($form['gid']);
	$output .= form_render($form['reset']);
	$output .= form_render($form['submit']);
	$output .= '</div>';
	$output .= form_render($form['form_id']);
	$output .= '</fieldset>';
	$output .= form_render($form['form_id']);
	$output .= form_render($form['form_token']);

	return $output;
}

/**
 * ticket_admin_set_form_validate: set formrol erkezo adatok ellenorzese 
 */
function ticket_admin_set_form_validate($form_id, $form) {
	/** ures mezo es azonos nevu arg(3) nem lehet */
	if ( $_POST['op'] != t('Reset') ) {
		if ( (arg(3) == 'priority') || (arg(3) == 'type') ) {
			$active = 0;
			foreach ($form as $array) {
				if ( is_array($array) ) {
					$active += $array['active'];
				}
			}
			if (!$active) {
				form_set_error('', t('One element should remain active!'));
			}
		}

		while (!is_null($key = key($form) ) ) {
			if ( (isset($form[$key]['name'])) && (is_numeric($key)) ) {
				if (trim($form[$key]['name']) == '') {
					form_set_error($key.'][name', t('%name field is required.', array('%name' => t(arg(3)) ) ) );
				} else {
					$SQL = "SELECT count(gid) as num FROM {ticket_".arg(3)."} WHERE gid = %d AND ".arg(3)."_id != %d AND ".arg(3)."_name = '%s'";
					$result = db_query($SQL, $form['gid'], $key, $form[$key]['name']);
					$row = db_fetch_array($result);

					if ( $row['num'] ) {
						form_set_error('', t('You must select a name for this '.arg(3).' of settings.'));
					}
				}
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_set_form_submit: arg(3) beallitas
 */
function ticket_admin_set_form_submit($form_id, $form) {
	/** arg(3) settings */
	if ( $_POST['op'] != t('Reset') ) {
		while (!is_null($key = key($form) ) ) {
			$SQL_extra = '';
			if ( !isset($form[$key]['active']) || $form[$key]['active'] == 0 ) {
				$form[$key]['active'] = 0;
				$SQL_extra = ', def = 0';
			}
			if ( is_numeric($key) ) {
				$SQL = "UPDATE {ticket_".arg(3)."} SET ".arg(3)."_name = '%s', weight = %d, active = %d".$SQL_extra." WHERE ".arg(3)."_id = %d";
				db_query($SQL, $form[$key]['name'], $form[$key]['weight'], $form[$key]['active'], $key);
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_set_def_form_submit: arg(3) default beallitas
 */
function ticket_admin_set_def_form_submit($form_id, $form) {
	/** arg(3) settings */
	db_query('UPDATE {ticket_'.arg(3).'} SET def = 0 WHERE gid = %d', $form['gid']);
	db_query('UPDATE {ticket_'.arg(3).'} SET def = 1 WHERE '.arg(3).'_id = %d', $form['def']);
}

/**
 * ticket_admin_add_set_validate: add set formrol erkezo adatok ellenorzese 
 */
function ticket_admin_add_set_validate($form_id, $form) {
	/** azonos nevu $action egy csoporton belul nem johet letre */
	$result = db_query("SELECT count(gid) as num FROM {ticket_".arg(3)."} WHERE gid = %d AND ".arg(3)."_name = '%s'", $form['gid'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this '.arg(3).' of settings.'));
	}
}

/**
 * ticket_admin_add_set_submit: [fixer|priority] hozzaadas
 */
function ticket_admin_add_set_submit($form_id, $form) {
	/** arg(3) hozzaadasa */
	$SQL = "INSERT INTO {ticket_".arg(3)."} (gid, ".arg(3)."_id, ".arg(3)."_name, weight, active) VALUES (%d, %d, '%s', %d, %d)";
	db_query($SQL, $form['gid'], db_next_id('{ticket_'.arg(3).'}_'.arg(3).'_id'), $form['name'], $form['weight'], $form['active']);
	_ticket_admin_chk_db_default($form['gid'], arg(3));
}

/******************************************************************
 *************************** ADMIN MAIL ***************************
 *****************************************************************/

/**
 * theme_ticket_admin_set_mail_form: tablazat alaku form keszites
 */
function theme_ticket_admin_set_mail_form($form) {
	$output = '';
	foreach (element_children($form) as $i) {
		if (is_array($form[$i]['name'])) {
			// Generate mail row
			$rows[] = array(
				form_render($form[$i]['def']),
				form_render($form[$i]['name']),
				form_render($form[$i]['mailto']),
				form_render($form[$i]['active']),
			);
		}
	}
	// Finish table
	$header = array(t('Default'), t('E-mail name'), t('E-mail address'), t('Enabled'));

	$output .= '<fieldset class="collapsible"><legend>'.t('List e-mails').':</legend>';
	$output .= theme('table', $header, $rows);
	$output .= '<div class="ticket-button-line">';
	$output .= form_render($form['gid']);
	$output .= form_render($form['reset']);
	$output .= form_render($form['submit']);
	$output .= '</div>';
	$output .= form_render($form['form_id']);
	$output .= '</fieldset>';
	$output .= form_render($form['form_token']);

	return $output;
}

/**
 * ticket_admin_set_mail_form_validate: set mail formrol erkezo adatok ellenorzese 
 */
function ticket_admin_set_mail_form_validate($form_id, $form) {
	/** ures mezo es azonos nevu mail name nem lehet */
	if ( $_POST['op'] != t('Reset') ) {
		while (!is_null($key = key($form) ) ) {
			if ( (isset($form[$key]['name'])) && (is_numeric($key)) ) {
				if ($form[$key]['name'] == '') {
					form_set_error($key.'][name', t('%name field is required.', array('%name' => t('E-mail name') ) ) );
				} elseif ($form[$key]['mailto'] == '') {
					form_set_error($key.'][mailto', t('%name field is required.', array('%name' => t('E-mail address') ) ) );
				} else {
					$SQL = "SELECT count(gid) as num FROM {ticket_mail} WHERE gid = %d AND mail_id != %d AND mail_name = '%s'";
					$result = db_query($SQL, $form['gid'], $key, $form[$key]['name']);
					$row = db_fetch_array($result);

					if ( !valid_email_address($form[$key]['mailto']) ) {
						form_set_error($key.'][mailto', t('Faulty e-mail address!'));
					}

					if ( $row['num'] ) {
						form_set_error('', t('You must select a name for this mail of settings.'));
					}
				}
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_set_mail_form_submit: mail beallitas
 */
function ticket_admin_set_mail_form_submit($form_id, $form) {
	/** mail settings */
	if ( $_POST['op'] != t('Reset') ) {
		while (!is_null($key = key($form) ) ) {
			if ( !isset($form[$key]['active']) || $form[$key]['active'] == 0) {
				$form[$key]['active'] = 0;
				$form[$key]['def'] = 0;
			}
			if ( !isset($form[$key]['def']) ) {
				$form[$key]['def'] = 0;
			}
			if ( is_numeric($key) ) {
				$SQL = "UPDATE {ticket_mail} SET mail_name = '%s', mailto = '%s', def = %d, active = %d WHERE mail_id = %d";
				db_query($SQL, $form[$key]['name'], $form[$key]['mailto'], $form[$key]['def'], $form[$key]['active'], $key);
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_add_mail_validate: add mail formrol erkezo adatok ellenorzese 
 */
function ticket_admin_add_mail_validate($form_id, $form) {
	/** azonos nevu mail egy csoporton belul nem johet letre */
	$result = db_query("SELECT count(gid) as num FROM {ticket_mail} WHERE gid = %d AND mail_name = '%s'", $form['gid'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this mail of settings.'));
	}
	if ( !valid_email_address($form['mailto']) ) {
		form_set_error('mailto', t('Faulty e-mail address!'));
	}
}

/**
 * ticket_admin_add_mail_submit: mail hozzaadas
 */
function ticket_admin_add_mail_submit($form_id, $form) {
	/** mail hozzaadasa */
	$SQL = 'INSERT INTO {ticket_mail} (gid, mail_id, mail_name, mailto, def, active)';
	$SQL .= " VALUES (%d, %d, '%s', '%s', %d, %d)";
	db_query($SQL, $form['gid'], db_next_id('{ticket_mail}_mail_id'), $form['name'], $form['mailto'], $form['def'], $form['active']);
}

/******************************************************************
 ************************** ADMIN STATUS **************************
 *****************************************************************/

/**
 * theme_ticket_admin_set_status_form: tablazat alaku form keszites
 */
function theme_ticket_admin_set_status_form($form) {
	$output = '';
	foreach (element_children($form) as $i) {
		if (is_array($form[$i]['name'])) {
			// Generate status row
			$rows[] = array(
				form_render($form[$i]['name']),
				form_render($form[$i]['closed']),
				form_render($form[$i]['active']),
				form_render($form[$i]['weight']),
				form_render($form[$i]['stage']),
			);
		}
	}
	// Finish table

	$header = array(t(ucfirst(arg(3))), t('Closed'), t('Enabled'), t('Weight'), t('Stage'));

	$output .= '<fieldset class="collapsible"><legend>'.t('List status').':</legend>';
	$output .= theme('table', $header, $rows);
	$output .= '<div class="ticket-button-line">';
	$output .= form_render($form['gid']);
	$output .= form_render($form['reset']);
	$output .= form_render($form['submit']);
	$output .= '</div>';
	$output .= form_render($form['form_id']);
	$output .= '</fieldset>';
	$output .= form_render($form['form_token']);

	return $output;
}

/**
 * ticket_admin_set_status_form_validate: status formrol erkezo adatok ellenorzese 
 */
function ticket_admin_set_status_form_validate($form_id, $form) {
	/** ures mezo es azonos nevu status nem lehet */
	if ( $_POST['op'] != t('Reset') ) {

		$active['0'] = $active['1'] = 0;
		foreach ($form as $array) {
			if ( is_array($array) ) {
				$active[$array['closed']] += $array['active'];
			}
		}
		if (!$active['0']) {
			form_set_error('', t('At least one non-closed type element should remain active!'));
		}
		if (!$active['1']) {
			form_set_error(' ', t('At least one closed type element should remain active!'));
		}

		while (!is_null($key = key($form) ) ) {
			if ( (isset($form[$key]['name'])) && (is_numeric($key)) ) {
				if (trim($form[$key]['name']) == '') {
					form_set_error($key.'][name', t('%name field is required.', array('%name' => t('status') ) ) );
				} else {
					$SQL = "SELECT count(gid) as num FROM {ticket_status} WHERE gid = %d AND status_id != %d AND status_name = '%s'";
					$result = db_query($SQL, $form['gid'], $key, $form[$key]['name']);
					$row = db_fetch_array($result);

					if ( $row['num'] ) {
						form_set_error('', t('You must select a name for this status of settings.'));
					}
				}
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_set_status_form_submit: status beallitas
 */
function ticket_admin_set_status_form_submit($form_id, $form) {
	/** status settings */
	if ( $_POST['op'] != t('Reset') ) {
		while (!is_null($key = key($form) ) ) {
			$SQL_extra = '';
			if ( !isset($form[$key]['active']) || $form[$key]['active'] == 0 ) {
				$form[$key]['active'] = 0;
				$SQL_extra = ', def = 0';
			}
			if ( is_numeric($key) ) {
				$SQL = "UPDATE {ticket_status} SET status_name = '%s', weight = %d, closed = %d, stage = %d, active = %d".$SQL_extra." WHERE status_id = %d";
				db_query($SQL, $form[$key]['name'], $form[$key]['weight'], $form[$key]['closed'], $form[$key]['stage'], $form[$key]['active'], $key);
			}
			next($form);
		}
	}
}

/**
 * ticket_admin_open_status_def_form_submit: status default beallitas
 */
function ticket_admin_open_status_def_form_submit($form_id, $form) {
	/** status settings */
	db_query('UPDATE {ticket_status} SET def = 0 WHERE closed = 0 AND gid = %d', $form['gid']);
	db_query('UPDATE {ticket_status} SET def = 1 WHERE status_id = %d', $form['def']);
}

/**
 * ticket_admin_closed_status_def_form_submit: status default beallitas
 */
function ticket_admin_closed_status_def_form_submit($form_id, $form) {
	/** status settings */
	db_query('UPDATE {ticket_status} SET def = 0 WHERE closed = 1 AND gid = %d', $form['gid']);
	db_query('UPDATE {ticket_status} SET def = 1 WHERE status_id = %d', $form['def']);
}

/**
 * ticket_admin_add_status_validate: add status formrol erkezo adatok ellenorzese 
 */
function ticket_admin_add_status_validate($form_id, $form) {
	/** azonos nevu status egy csoporton belul nem johet letre */
	$result = db_query("SELECT count(gid) as num FROM {ticket_status} WHERE gid = %d AND status_name = '%s'", $form['gid'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('', t('You must select a name for this status of settings.'));
	}
}

/**
 * ticket_admin_add_status_submit: status hozzaadas
 */
function ticket_admin_add_status_submit($form_id, $form) {
	/** status hozzaadasa */
	$SQL = "INSERT INTO {ticket_status} (gid, status_id, status_name, weight, stage, closed, active) VALUES (%d, %d, '%s', %d, %d, %d, %d)";
	db_query($SQL, $form['gid'], db_next_id('{ticket_status}_status_id'), $form['name'], $form['weight'], $form['stage'], $form['closed'], $form['active']);
	_ticket_admin_chk_db_default($form['gid'], 'status');
}

/*******************************************************************
 ************************** TICKET ACCESS **************************
 ******************************************************************/

/**
 * ticket_admin_access: ticket hozzaferes adminisztralasa
 */
function ticket_admin_access() {
	global $user;
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

	if( !(ticket_access('ticket administer', '*', '*')) ) {
		drupal_access_denied();
		return;
	}

	// ticket admin jogosultsag listazasa
	$SQL = "SELECT tp.role_id, tp.u_id, tp.gid";
	$SQL .= " FROM {ticket_permission} tp INNER JOIN {permission} p ON tp.role_id = p.rid AND role_id IN (%s)";
	$SQL .= " WHERE perm LIKE '%%%s%' ORDER BY tp.u_id, tp.gid";
	$result = db_query($SQL, implode(',', array_keys($user->roles)), 'ticket administer');

	// ticket jogosultsagok tombbe mentese
	$roles = array();
	while ($row = db_fetch_array($result)) {
		if ( (!isset($roles[0][0])) || !($roles[0][0]) ) {
			if ( (!isset($roles[$row['u_id']][0])) || !($roles[$row['u_id']][0]) ) {
				$roles[$row['u_id']][$row['gid']] = 1;
			}
		}
	}

	// unit es csoport nevek kigyujtese
	$names = array();
	$last_unit = '';
	$names[0][0]['name'] = t('All');
	$result = db_query('SELECT tu.u_id, tg.gid, tu.unit_name, tg.group_name FROM {ticket_unit} tu, {ticket_group} tg WHERE tu.u_id = tg.u_id ORDER BY tu.unit_name, tg.group_name');
	while ($row = db_fetch_array($result)) {
		if ($last_unit != $row['unit_name']) {
			$names[$row['u_id']][0]['name'] = $row['unit_name'];
			$last_unit = $row['unit_name'];
		}
		$names[$row['u_id']][$row['gid']]['name'] = $row['group_name'];
	}

	// a nevek kiegeszitese jogosultsagokkal
	$SQL = 'SELECT tp.role_id, tp.u_id, tp.gid, r.name FROM {role} r, {permission} p, {ticket_permission} tp';
	$SQL .= ' WHERE r.rid = tp.role_id AND r.rid = p.rid ORDER BY r.name';
	$result = db_query($SQL);
	while ($row = db_fetch_array($result)) {
		if ( ( $roles[0][0] ) || ( $roles[$row['u_id']][0] ) || ( $roles[$row['u_id']][$row['gid']] ) ) {
			$names[$row['u_id']][$row['gid']]['role'][$row['role_id']] = $row['name'];
		}
	}
	return theme('ticket_admin_access', $names);
}

/**
 * theme_ticket_admin_access: ticket hozzaferes adminisztralasa theme hook
 */
function theme_ticket_admin_access($names) {
	$header = array(
		array('data' => t('Name')),
		array('data' => t('Operations'), 'colspan' => '2'),
	);

	$output = '<ul>';
	// unit nevek listaba irasa
	while (!is_null($key = key($names) ) ) {
		$sub_output = '<li>'.$names[$key][0]['name'];
		// unithoz tartozo csoportok listaba irasa
		while (!is_null($sub_key = key($names[$key]) ) ) {
			// csak akkor kerul listaba ha tartozik hozza jogosultsag
			if (isset($names[$key][$sub_key]['role'])) {
				// ha nem unithoz tartozo jogosultsag
				if ($sub_key) {
					$sub_output .= '<ul><li>'.$names[$key][$sub_key]['name'];
				}
				$sub_output .= '<ul>';
				$rows = array();
				// tablazat elkeszitese
				while (!is_null($role_key = key($names[$key][$sub_key]['role']) ) ) {
					$rows[] = array(
						array('data' => $names[$key][$sub_key]['role'][$role_key]),
						array('data' => l(t('edit'), 'admin/ticket/access/edit/'.$role_key) ),
						array('data' => l(t('delete'), 'admin/ticket/access/delete/'.$role_key) ),
					);
					next($names[$key][$sub_key]['role']);
				}
				// tablazat hozza fuzese a listahoz
				$sub_output .= '<li class = "li_ticket_table">';
				$sub_output .= theme('table', $header, $rows);
				$sub_output .= '</li>'."\n";
				// ha nem unithoz tartozo jogosultsag
				if ($sub_key) {
					$sub_output .= '</ul></li>';
				}
				$sub_output .= '</ul>';
			}
			next($names[$key]);
		}
		$sub_output .= '</li>';
		// ha nem tartozik jogosultsag a unithoz akkor nem kerul kiirasra
		if ($sub_output != '<li>'.$names[$key][0]['name'].'</li>') {
			$output .= $sub_output;
		}
		next($names);
	}
	$output .= '</ul>';

	return $output;
}
/********************************************************************
 ********************** TICKET ACCESS ADD/EDIT **********************
 *******************************************************************/

/**
 * ticket_admin_access_add_edit: ticket access hozzaadas, szerkesztes 
 */
function ticket_admin_access_add_edit($aid = '') {
	global $user;

	// Jogosultsag ellenorzes
	if ( $aid != '' ) {
		$result = db_query("SELECT u_id, gid FROM {ticket_permission} WHERE role_id = %d", $aid);
		$row = db_fetch_array($result);
		if ( !ticket_access('ticket administer', $row['u_id'], $row['gid']) ) {
			drupal_access_denied();
			return;
		}
	} elseif( !(ticket_access('ticket administer', '*', '*')) ) {
		drupal_access_denied();
		return;
	}

	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

	$ug_list = _ticket_unit_group_list('ticket administer', '-', 1, 0);

	// lehetseges ticket hozzaferesek
	$ticket_access = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');

	if ($aid != '') {
		// azoknak a csoportoknak a lekerdezese amiket adminisztralhat
		$SQL = "SELECT tp.role_id, tp.u_id, tp.gid, r.name, p.perm FROM {role} r, {permission} p, {ticket_permission} tp";
		$SQL .= " WHERE r.rid = %d AND r.rid = tp.role_id AND r.rid = p.rid ";
		$SQL .= " ORDER BY r.name, tp.u_id, tp.gid";
		$result = db_query($SQL, $aid);

		if ($row = db_fetch_array($result)) {
			$row['perm'] = explode(', ', $row['perm']);
			$row['perm'] = array_intersect($row['perm'], $ticket_access);

			$row['role'] = $row['u_id'].'-'.$row['gid'];
			$var['role'] = $ug_list;

			$form = _ticket_admin_access_form(array('role' => $ug_list), $row);
			$form['role_id'] = array(
				'#type' => 'value',
				'#value' => $row['role_id'],
			);
			$form['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save'),
			);
			$output .= drupal_get_form('ticket_admin_access_edit', $form);
			_ticket_breadcrumb('admin/ticket/access');
			drupal_set_title(t('Edit access: %name', array('%name' => $row['name'])));
		}
	} else {
		$form = _ticket_admin_access_form(array('role' => $ug_list));
		$form['submit'] = array(
			'#type' => 'submit',
			'#value' => t('Save'),
		);
		$output .= drupal_get_form('ticket_admin_access_add', $form);
	}
	return $output;
}

/**
 * ticket_admin_access_edit_validate: access edit formrol erkezo adatok ellenorzese 
 */
function ticket_admin_access_edit_validate($form_id, $form) {
	/** azonos nevu role nem johet letre */
	$result = db_query("SELECT count(rid) as num FROM {role} WHERE rid != %d AND name = '%s'", $form['role_id'], $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('name', t('You must select a name for this role of settings.'));
	} else {
		$form['perm'] = array_diff($form['perm'], array(0));
		if ( !count($form['perm']) ) {
			form_set_error('perm', t('At least one access-credential must be chosen.'));
		}
	}
}

/**
 * ticket_admin_access_edit_submit: access modositasa
 */
function ticket_admin_access_edit_submit($form_id, $form) {
	$perms['access'] = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');
	$form['perm'] = array_diff($form['perm'], array(0));

	// jogosultsag atnevezese
	$result = db_query("UPDATE {role} SET name='%s' WHERE rid = %d", $form['name'], $form['role_id']);

	// meglevo jogosultsagok lekerdezese
	$result = db_query("SELECT perm FROM {permission} WHERE rid = %d", $form['role_id']);
	$row = db_fetch_array($result);

	// tombositese
	$perms['db'] = explode(', ', $row['perm']);
	// ticket jogosultsagok torlese
	$perms['db'] = array_diff($perms['db'], $perms['access']);
	// uj jogosultsagok hozza adasa
	$perms['db'] = array_merge($perms['db'], $form['perm']);
	$result = db_query("UPDATE {permission} SET perm='%s' WHERE rid = %d",  implode(', ', $perms['db']), $form['role_id']);

	// jogkor modositasa
	list($u_id, $gid) = explode('-', $form['role']);
	db_query("UPDATE {ticket_permission} SET u_id=%d, gid=%d WHERE role_id = %d", $u_id, $gid, $form['role_id']);

	// felhasznalok csoporthoz valo hozza rendelese
	$form['user'] = array_diff($form['user'], array(0));
	db_query('DELETE FROM {users_roles} WHERE rid = %d', $form['role_id']);
	foreach ($form['user'] as $user_id) {
		db_query('INSERT INTO {users_roles} (uid, rid) VALUES (%d, %d)', $user_id, $form['role_id']);
	}
	drupal_goto('admin/ticket/access');
}

/**
 * ticket_admin_access_add_validate: access add formrol erkezo adatok ellenorzese 
 */
function ticket_admin_access_add_validate($form_id, $form) {
	/** azonos nevu role nem johet letre */
	$result = db_query("SELECT count(r.rid) as num FROM {role} r, {ticket_permission} tp WHERE r.rid = tp.role_id AND r.name = '%s'", $form['name']);
	$row = db_fetch_array($result);
	if ( $row['num'] ) {
		form_set_error('name', t('You must select a name for this role of settings.'));
	} else {
		$form['perm'] = array_diff($form['perm'], array(0));
		if ( !count($form['perm']) ) {
			form_set_error('perm', t('At least one access-credential must be chosen.'));
		}
	}
}

/**
 * ticket_admin_access_add_submit: access modositasa
 */
function ticket_admin_access_add_submit($form_id, $form) {
	$perms['access'] = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');
	$form['perm'] = array_diff($form['perm'], array(0));

	// ha mar letezik a csoport, csak ticket jogosultsag nincs hozza kapcsolva
	$result = db_query("SELECT rid FROM {role} WHERE name = '%s'", $form['name']);
	if ( db_num_rows($result) ) {
		$row = db_fetch_array($result);

		// meglevo jogosultsagok lekerdezese
		$result_perm = db_query("SELECT perm FROM {permission} WHERE rid = %d", $row['rid']);
		if ( db_num_rows($result) ) {
			$row_perm = db_fetch_array($result_perm);
			// ticket jogosultsagok kiszurese
			$perms['access'] = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');
			// tombositese
			$row_perm['perm'] = explode(', ', $row_perm['perm']);
			// ticket jogosultsagok torlese
			if ( count($row_perm['perm']) ) {
				$row_perm['perm'] = array_diff($row_perm['perm'], $perms['access']);
			}
			// jogosultsagok osszefuzese
			if ( count($row_perm['perm']) ) {
				$perm = implode(', ', $row_perm['perm']).', '.implode(', ', $form['perm']);
			} else {
				$perm = implode(', ', $form['perm']);
			}

			// jogosultsagok frissitese
			db_query("UPDATE {permission} SET perm='%s' WHERE rid = %d", $perm, $row['rid']);
		} else {
			// jogosultsagok hozza adasa
			db_query("INSERT INTO {permission} (rid, perm, tid) VALUES (%d, '%s', 0)", $row['rid'], implode(', ', $form['perm']));
		}
	} else {
		// jogosultsag csoport hozza adasa
		db_query("INSERT INTO {role} (name) VALUES ('%s')", $form['name']);
		$result = db_query("SELECT rid FROM {role} WHERE name = '%s'", $form['name']);
		$row = db_fetch_array($result);
	
		// jogosultsagok hozza adasa
		db_query("INSERT INTO {permission} (rid, perm, tid) VALUES (%d, '%s', 0)", $row['rid'], implode(', ', $form['perm']));
	}

	// jogkor letrehozasa
	list($u_id, $gid) = explode('-', $form['role']);
	db_query("INSERT INTO {ticket_permission} (role_id, u_id, gid) VALUES (%d, %d, %d)", $row['rid'], $u_id, $gid);

	// felhasznalok csoporthoz valo hozza rendelese
	if ($row['rid'] > 2) {
		$form['user'] = array_diff($form['user'], array(0));
		db_query('DELETE FROM {users_roles} WHERE rid = %d', $row['rid']);
		foreach ($form['user'] as $user_id) {
			db_query('INSERT INTO {users_roles} (uid, rid) VALUES (%d, %d)', $user_id, $row['rid']);
		}
	}
}

/*******************************************************************
 ********************** TICKET ACCESS DELETED **********************
 ******************************************************************/

/**
 * ticket_admin_access_delete_confirm: access torles megerosites
 */
function ticket_admin_access_delete_confirm($rid) {
	// jogosultsag ellenorzes
	$result = db_query("SELECT u_id, gid FROM {ticket_permission} WHERE role_id = %d", $rid);
	$row = db_fetch_array($result);
	if ( !ticket_access('ticket administer', $row['u_id'], $row['gid']) ) {
		drupal_access_denied();
		return;
	}

	// megerosites
	$result = db_query("SELECT name FROM {role} WHERE rid = %d", $rid);
	if ($row = db_fetch_array($result)) {
		$form['rid'] = array('#type' => 'value', '#value' => $rid);
	    $output = confirm_form('ticket_admin_access_delete_confirm', $form,
			t('Are you sure you want to delete %title?', array('%title' => theme('placeholder', $row['name']))),
			$_GET['destination'] ? $_GET['destination'] : 'admin/ticket/access', t('This action cannot be undone.'),
			t('Delete'), t('Cancel')  );
	} else {
		drupal_access_denied();
	}
	return $output;
}

/**
 * ticket_admin_access_delete_confirm_submit: access torles
 */
function ticket_admin_access_delete_confirm_submit($form_id, $form) {
	// jogosultsag ellenorzes
	$result = db_query("SELECT u_id, gid FROM {ticket_permission} WHERE role_id = %d", $form['rid']);
	$row = db_fetch_array($result);
	if ( !ticket_access('ticket administer', $row['u_id'], $row['gid']) ) {
		drupal_access_denied();
		return;
	}

	// torles!!!
	if ($form['confirm']) {
		// jogosultsag lekerdezes
		$result = db_query('SELECT perm FROM {permission} WHERE rid=%d', $form['rid']);
		if ($row = db_fetch_array($result)) {
			// ticket permission torles
			db_query('DELETE FROM {ticket_permission} WHERE role_id=%d', $form['rid']);

			// ticket jogosultsagok kiszurese
			$perms['access'] = array('ticket reader', 'ticket outsider', 'ticket manager', 'ticket administer');
			// tombositese
			$row['perm'] = explode(', ', $row['perm']);
			// ticket jogosultsagok torlese
			$row['perm'] = array_diff($row['perm'], $perms['access']);
			if ( !count($row['perm']) ) {
			// ha csak ticket jogosultsagok voltak torolni kell mindenhonnan
				db_query('DELETE FROM {role} WHERE rid = %d AND rid > 2', $form['rid']);
				db_query('DELETE FROM {users_roles} WHERE rid = %d', $form['rid']);
				db_query('DELETE FROM {permission} WHERE rid = %d', $form['rid']);
			} else {
			// ha nem csak ticket jogosultsagok voltak akkor csak a ticket jogosultsagokat kell torolni
				db_query("UPDATE {permission} SET perm='%s' WHERE rid = %d",  implode(', ', $row['perm']), $form['rid']);
			}
		}
		drupal_goto('admin/ticket/access');
	}
}

/********************************************************************
 *********************** TICKET ACCESS USERS ************************
 *******************************************************************/

/**
 * ticket_admin_access_users: ticket csoport felhasznalohoz rendelese
 */
function ticket_admin_access_users($uid = 0) {
	global $user;

	// Jogosultsag ellenorzes
	if( !(ticket_access('ticket administer', '*', '*')) ) {
		drupal_access_denied();
		return;
	}

	if ( (arg(4) == 0) && (arg(4) != NULL) ) {
		drupal_goto('admin/ticket/access/users');
	} else {
		// szukseges js es css betoltese
		drupal_add_js('modules/ticket/ticket.js');
		theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

		// felhasznalok listaja
		$result = db_query('SELECT uid, name FROM {users}');
		while ($row = db_fetch_array($result)) {
			$users[$row['uid']] = $row['name'];
		}
		$form['user'] = array(
			'#type' => 'select',
			'#title' => t('User'),
			'#default_value' => $uid,
			'#options' => $users,
		);

		// ticket admin jogosultsag listazasa
		$SQL = "SELECT tp.role_id, tp.u_id, tp.gid FROM {ticket_permission} tp INNER JOIN {permission} p ON tp.role_id = p.rid AND role_id IN (%s)  WHERE perm LIKE '%%%s%' ORDER BY tp.u_id, tp.gid";
		$result = db_query($SQL, implode(',', array_keys($user->roles)), 'ticket administer');

		// ticket jogosultsagok tombbe mentese
		$roles = array();
		while ($row = db_fetch_array($result)) {
			if ( (!isset($roles[0][0])) || !($roles[0][0]) ) {
				if ( (!isset($roles[$row['u_id']][0])) || !($roles[$row['u_id']][0]) ) {
					$roles[$row['u_id']][$row['gid']] = 1;
				}
			}
		}
		// u/gid_list = u/gid azonositok ide kerulnek
		$uid_list = array();
		$gid_list = array();
		if ( (!isset($roles[0][0])) || !($roles[0][0]) ) {
			$SQL_extra = '0';
		} else {
			$SQL_extra = '1';
		}

		// global admin eseten erre semmi szukseg 
		$u_keys = array_keys($roles);
		if ($u_keys[0] != 0) {
			foreach ($u_keys as $uid) {
				$g_keys = array_keys($roles[$uid]);
				// u_id kigyujtese unit adminnal
				if ($g_keys[0] == 0) {
					$uid_list[] = $uid;
				} else {
				// gid kigyujtese group adminnal
					$gid_list = array_merge($gid_list, $g_keys);
				}
			}

			// SELECT modositas az admin jogoknak megfeleloen
			if (count($uid_list)) {
				$uid_list = implode(',', $uid_list);
				$SQL_extra = 'tp.u_id IN (%s)';
				if (count($gid_list)) {
					$gid_list = implode(',', $gid_list);
					$SQL_extra .= ' OR tp.gid IN (%s)';
				}
			} elseif(count($gid_list)) {
				$uid_list = implode(',', $gid_list);
				$gid_list = array();
				$SQL_extra = 'tp.gid IN (%s)';
			}
		}
		$header = array(
			array('data' => t('Name')),
			array('data' => t('Operations'), 'colspan' => '2'),
		);

		// azoknak a csoportoknak a lekerdezese amiket adminisztralhat
		$SQL = "SELECT tp.role_id, r.name FROM {role} r, {ticket_permission} tp";
		$SQL .= " WHERE (".$SQL_extra.") AND r.rid = tp.role_id";
		$SQL .= " ORDER BY r.name";
		$result = db_query($SQL, $uid_list, $gid_list);
		while ($row = db_fetch_array($result)) {
			$role[$row['role_id']] = $row['name'];
		}

		// felhasznalohoz 
		$uroles = array();
		$result = db_query("SELECT rid FROM {users_roles} WHERE uid = %d", $uid);
		while ($row = db_fetch_array($result)) {
			$uroles[] = $row['rid'];
		}
		$uroles = array_intersect($uroles, array_keys($role));

		// csoport tickethez kotheto csoport lista
		$form['roles'] = array(
			'#type' => 'checkboxes',
			'#options' => $role,
			'#default_value' => $uroles,
			'#prefix' => '<div class="ticket-chb-scroll">',
			'#suffix' => '</div>',
		);

		$form['submit'] = array(
			'#type' => 'submit',
			'#value' => t('Save'),
		);
		$output .= drupal_get_form('ticket_admin_access_users', $form);
		return $output;
	}
}

/**
 * ticket_admin_access_users_submit: ticket csoport felhasznalohoz rendeles submit
 */
function ticket_admin_access_users_submit($form_id, $form) {
	// felhasznalo csoport listaja
	$result = db_query('SELECT rid FROM {users_roles} WHERE uid = %d', $form['user']);
	while ($row = db_fetch_array($result)) {
		$roles[] = $row['rid'];
	}
	// ticket csoportok eltavolitasa a listabol
	$roles = array_diff($roles, array_keys($form['roles']));
	// formrol erkezo csoportlistabol kiszurjuk a ki nem valasztott csoportokat
	$form['roles'] = array_diff($form['roles'], array(0));
	// az altalanos csoportok es a ticket csoportok osszefesulese
	$roles = array_merge($roles, $form['roles']);

	// adatbazis muveletek elvegzese
	db_query('DELETE FROM {users_roles} WHERE uid = %d', $form['user']);
	foreach ($roles as $role) {
		db_query('INSERT INTO {users_roles} (uid, rid) VALUES (%d, %d)', $form['user'], $role);
	}

	drupal_goto('admin/ticket/access/users');
}
?>