<?php
/*
 * Created on 2006.08.10.
 */

/**
 * _ticket_list_table: ticket lekerdezesek kiratasa.
 * @param $u_id - unit id
 * @param $gid - group id
 */
function _ticket_list_table($u_id, $gid) {
	global $ticket_conf;
	// tablazat fejlece
	$header = array(
		array('data' => t('Ticket ID'), 'field' => 't.tid', 'sort' => 'DESC'),
		array('data' => t('Summary'), 'field' => 't.summary'),
		array('data' => t('Type'), 'field' => 'tt.type_name'),
		array('data' => t('Status'), 'field' => 'ts.status_name'),
		array('data' => t('Opened by'), 'field' => 'u.name'),
		array('data' => t('Priority'), 'field' => 'tp.weight'),
		array('data' => t('Problem started'), 'field' => 't.start'),
		array('data' => t('Date updateed'), 'field' => 'e.created'),
		array('data' => t('Updates'), 'field' => 'tmp.num'),
	);

	// az oldal legeneralasa, lapozhatora
	$SQL = "SELECT count(*) FROM {tmp_table} t";
	$result = pager_query($SQL, $ticket_conf['limit']);

	// a tablazat adatainak lekerdezese
	$SQL = "SELECT tg.u_id, t.gid, t.tid, t.summary, tt.type_name, ts.status_name, ts.stage, t.uid, tp.weight, tp.priority_name, t.start, e.created, tmp.num, e.uid AS e_uid";
	$SQL .= " FROM {ticket_ticket} t, {ticket_event} e, {ticket_status} ts, {ticket_priority} tp, {ticket_type} tt, {ticket_group} tg, {tmp_table} tmp";
	$SQL .= " WHERE tg.gid = t.gid AND t.tid = e.tid AND t.tid=tmp.tid AND tmp.created = e.created AND e.status_id = ts.status_id AND t.priority_id = tp.priority_id";
	$SQL .= " AND t.type_id = tt.type_id";
	// rendezes megadasa
	$SQL .= tablesort_sql($header, '');
	$result = db_query_range($SQL, $_GET['page'] * $ticket_conf['limit'], $ticket_conf['limit']);

	$rows = array();
	// tablazat sorainak elkeszitese
	while ($row = db_fetch_array($result)) {
		$row['summary'] = l(htmlspecialchars($row['summary'], ENT_QUOTES, 'UTF-8'), 'ticket/'.$row['u_id'].'/'.$row['gid'].'/'.$row['tid']);
		$row['tid'] = l($row['tid'], 'ticket/'.$row['u_id'].'/'.$row['gid'].'/'.$row['tid']);
		if ($row['e_uid'] == 0) {
			$row['num'] = 0;
		}
		$row['name'] = _ticket_get_user($row['uid']);

		$rows[] = array(
			array('data' => $row['tid']),
			array('data' => $row['summary']),
			array('data' => $row['type_name']),
			array('data' => $row['status_name'], 'class' => 'stage-'.$row['stage']),
			array('data' => $row['name']),
			array('data' => $row['priority_name'], 'class' => 'priority-'.$row['weight']),
			array('data' => format_date($row['start'], 'small'), 'class' => 'date'),
			array('data' => format_date($row['created'], 'small'), 'class' => 'date'),
			array('data' => $row['num']),
		);
	}

	// tablazat
	$table = theme('ticket_table_list', $header, $rows);
	// ha tobb oldalra fer csak ki a lista akkor ennek segitsegevel lehet navigalni. 
	$pager = theme('pager', NULL, $ticket_conf['limit']);
	return array($table, $pager);
}

/**
 * theme_ticket_table_list: theme hook
 * @param: $header - tablazat fejlece
 * @param: $rows - tablazat sorai
 */
function theme_ticket_table_list($header, $rows) {
	$output = '<div id="ticket">';
	$output .= theme('table', $header, $rows);
	$output .= '</div>';
	return $output;
}

/********************************************************************
 *********************** TICKET MAIL TEMPLATE ***********************
 *******************************************************************/
/**
 * _ticket_mail_template_ticket: ticket adatok behelyetesitese a sablonba.
 * @param $gid - group id
 * @param $tid - ticket id
 * @param $template - mail template
 */
function _ticket_mail_template_ticket($gid, $tid, &$template) {
	// ticket lekerdezese
	$SQL = "SELECT t.tid, t.uid, t.assigned, tp.priority_name, tt.type_name, tsc.scope_name , tsi.site_name , tf.fixer_name ";
	$SQL .= ", tg.group_name , tu.unit_name, t.summary, t.created, t.start, t.finish, t.detail, t.affected, t.actions, t.time_to_fix, t.fix";
	$SQL .= " FROM {ticket_ticket} t, {ticket_priority} tp, {ticket_type} tt, {ticket_scope} tsc, {ticket_site} tsi, {ticket_fixer} tf,";
	$SQL .= " {ticket_unit} tu, {ticket_group} tg";
	$SQL .= " WHERE t.tid = %d AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id AND t.scope_id = tsc.scope_id";
	$SQL .= " AND t.site_id = tsi.site_id AND t.fixer_id = tf.fixer_id AND t.gid = tg.gid AND tg.u_id = tu.u_id";
	$result = db_query($SQL, $tid);
	$row = db_fetch_array($result);

	// ticket ertekeinek hozzarendelese a minta valtozoihoz 
	$template['var']['%tid'] = $row['tid'];
	$template['var']['%g'] = $row['group_name'];
	$template['var']['%u'] = $row['unit_name'];
	$template['var']['%pri'] = $row['priority_name'];
	$template['var']['%type'] = $row['type_name'];
	$template['var']['%sc'] = $row['scope_name'];
	$template['var']['%si'] = $row['site_name'];
	$template['var']['%fixer'] = $row['fixer_name'];
	$template['var']['%ss'] = $row['summary'];
	$template['var']['%ps'] = format_date($row['start'], 'small');
	$template['var']['%detail'] = $row['detail'];
	$template['var']['%affected'] = $row['affected'];
	$template['var']['%actions'] = $row['actions'];
	$template['var']['%ttf'] = $row['time_to_fix'];
	$template['var']['%fix'] = $row['fix'];

	$template['var']['%tc'] = _ticket_get_user($row['uid']);
	$template['var']['%assigned'] = _ticket_get_user($row['assigned']);
	if ( isset($row['finish']) ) {
		$finish = $row['finish'];
		$template['var']['%pf'] = format_date($row['finish'], 'small');
	} else {
		$finish = time();
		$template['var']['%pf'] = " ";
	}
	$template['var']['%pl'] = format_interval($finish - $row['start'], 3);

	$result = db_query_range("SELECT ts.status_name FROM {ticket_event} te, {ticket_status} ts WHERE te.tid = %d AND te.status_id = ts.status_id ORDER BY te.created DESC", $tid, 0, 1);
	$row = db_fetch_array($result);
	$template['var']['%st'] = $row['status_name'];

	// specialis minta helyetesites
	// ha a cserelendo minta mogott annyi ures hely van, hogy a minta erteke odafer akkor ez alapjan lesz lecserelve  
	$keys = array('%tid', '%g', '%u', '%pri', '%type', '%sc', '%si', '%fixer', '%ps', '%pf', '%tc', '%assigned', '%pl', '%st');
	foreach ($keys as $key) {
		$length['key'] = drupal_strlen($key);
		$length['var'] = drupal_strlen($template['var'][$key]);
		if ($length['key'] < $length['var']) {
			$var[str_pad($key, $length['var']+1)] = $template['var'][$key].' ';
		} elseif ($length['key'] != $length['var']) {
			$var[$key.'  '] = str_pad($template['var'][$key], $length['key']+2);
		}
	}

	// eloszor a specialis minta helyetesites fut le a ticket mintak mindegyikere
	$template['tt_header'] = strtr($template['tt_header'], $var);
	$template['tt_body'] = strtr($template['tt_body'], $var);
	$template['tt_footer'] = strtr($template['tt_footer'], $var);

	// majd a normal helyetesites, a specialis helyetesites a targy mezore nem fut le
	$template['tsubject'] = strtr($template['tsubject'], $template['var']);
	$template['tt_header'] = strtr($template['tt_header'], $template['var']);
	$template['tt_body'] = strtr($template['tt_body'], $template['var']);
	$template['tt_footer'] = strtr($template['tt_footer'], $template['var']);

	return $template;
}

/**
 * _ticket_mail_template_event: ticket event adatok behelyetesitese a sablonba.
 * @param $gid - group id
 * @param $tid - ticket id
 * @param $template - mail template
 */
function _ticket_mail_template_event($gid, $tid, &$template) {
	// specialis helyetesites elkeszitese az event mintahoz is a ticket ertekeibol
	$keys = array('%tid', '%g', '%u', '%pri', '%type', '%sc', '%si', '%fixer', '%ps', '%pf', '%tc', '%assigned', '%pl', '%st');
	foreach ($keys as $key) {
		$length['key'] = drupal_strlen($key);
		$length['var'] = drupal_strlen($template['var'][$key]);
		if ($length['key'] < $length['var']) {
			$var[str_pad($key, $length['var']+1)] = $template['var'][$key].' ';
		} elseif ($length['key'] != $length['var']) {
			$var[$key.'  '] = str_pad($template['var'][$key], $length['key']+2);
		}
	}
	
	if ($template['sep'] != "") {
		$template['sep'] .= "\n";
	}
	$template['sep'] .= "\n";

	// az esemenyek lekerdezese
	$SQL = 'SELECT te.eid, te.uid, te.reassigned, te.created, te.description, ts.status_name FROM {ticket_event} te, {ticket_status} ts';
	$SQL .= " WHERE te.tid = %d  AND te.status_id = ts.status_id ORDER BY created";
	switch ($template['e_type']) {
		// esemenyek novekvo sorrendben
		case 0:
		case 2:
			$result = db_query($SQL, $tid);
		break;

		// esemenyek csokkeno sorrendben
		case 1:
		case 3:
			$SQL .= " DESC";
			$result = db_query($SQL, $tid);
		break;

		// csak az utolso esemeny
		case 4:
			$SQL = 'SELECT te.eid, te.uid, te.reassigned, te.created, te.description, ts.status_name FROM {ticket_event} te, {ticket_status} ts';
			$SQL .= " WHERE te.tid = %d AND te.status_id = ts.status_id ORDER BY te.created DESC";
			$result = db_query_range($SQL, $tid, 0, 1);
		break;
	}

	// esemenyek egymas moge fuzese
	$template['event'] = '';
	while ($row = db_fetch_array($result)) {
		$tmp['%eid'] = $row['eid'];
		$tmp['%edate'] = format_date($row['created'], 'small');
		$tmp['%edesc'] = $row['description'];
		$tmp['%st'] = $row['status_name'];
		$tmp['%ec'] = _ticket_get_user($row['uid']);
		$tmp['%ra'] = _ticket_get_user($row['assigned']);
		// ha csokkeno sorrendben vannak rendezve az esemenyek akkor az elso elem adja a level targyat 
		if ( !($template['e_type'] % 2) ) {
			$template['esubject'] = strtr($template['esubject'], $tmp);
			$template['esubject'] = strtr($template['esubject'], $template['var']);
		}

		// specialis behelyetesites elokeszitese
		$keys = array('%eid', '%edate', '%st', '%ra', '%ec');
		foreach ($keys as $key) {
			$length['key'] = drupal_strlen($key);
			$length['var'] = drupal_strlen($template['var'][$key]);
			if ($length['key'] < $length['var']) {
				$evar[str_pad($key, $length['var']+1)] = $template['var'][$key].' ';
			} elseif ($length['key'] != $length['var']) {
				$evar[$key.'  '] = str_pad($template['var'][$key], $length['key']+2);
			}
		}

		// behelyetesitesek
		$event = strtr($template['etemplate'], $evar);
		$event = strtr($event, $tmp);
		$event = strtr($event, $var);
		$template['event'] .= strtr($event, $template['var']);
		$template['event'] .= "\n".$template['sep'];
	}
	// level targyaba itt helyetesitunk be, ha novekvo sorrend van kivalasztva
	$template['esubject'] = strtr($template['esubject'], $tmp);
	$template['esubject'] = strtr($template['esubject'], $template['var']);
}

/**
 * _ticket_mail_send: level kuldese
 * @param $gid - group id
 * @param $tid - ticket id
 * @param $type - mail type
 */
function _ticket_mail_send($gid, $tid, $type = 0) {
	// ticket csoporthoz tartozo minta lekerdezese
	$result = db_query("SELECT * FROM {ticket_template} WHERE gid = %d", $gid);
	$template = db_fetch_array($result);

	// ha nincs meg adva felado cim akkor nem kerul kikuldesre level.
	if ($template['mailto'] != '') {
		// $mail valtozoba kerul a felado cime
		$mail['mailfrom'] = $template['mailto'];

		// akik masolatot kapnak a levelrol
		$result = db_query("SELECT cc FROM {ticket_ticket} WHERE tid = %d", $tid);
		$row = db_fetch_array($result);
		$mail['cc'] = implode(', ', explode(' ', str_replace(', ', ' ', $row['cc']) ) );

		// akiknek kikuldesre kerul a level
		$SQL = "SELECT tm.mailto, tm.mail_name FROM {ticket_mail} tm, {ticket_rel_ticket_mail} trm WHERE trm.tid = %d AND trm.mail_id = tm.mail_id";
		$result = db_query($SQL, $tid);
		$mailto = array();
		while ($row = db_fetch_array($result)) {
			$mailto[] = $row['mail_name'].' <'.$row['mailto'].'>';
		}
		$mail['mailto'] = implode(', ', $mailto);

		// ticket minta kiertekelese
		_ticket_mail_template_ticket($gid, $tid, $template);
		// $type = 0 - ha uj ticket keszult
		// $type = 1 - ha uj esemeny kovetkezett be
		// $type = 2 - ha a ticket lezarasra kerult
		if ($type) {
			// esemeny minta kiertekelese
			_ticket_mail_template_event($gid, $tid, $template);

			if ( ($template['esubject'] == '') || ($type == 2)) {
				$mail['subject'] = $template['tsubject'];
			} else {
				$mail['subject'] = $template['esubject'];
			}
			// beallitasoknak megfeleloen osszeallitja a leveltartalmat 
			if ( ($template['e_type'] <= 1) || ($type == 2)) {
				if ($template['e_pos']) {
					$mail['message'] = $template['tt_header']."\n".$template['tt_body']."\n".$template['event']."\n".$template['tt_footer'];
				} else {
					$mail['message'] = $template['tt_header']."\n".$template['event']."\n".$template['tt_body']."\n".$template['tt_footer'];
				}

			} else {
				$mail['message'] = $template['tt_header']."\n".$template['event']."\n".$template['tt_footer'];
			}
		} else {
			$mail['subject'] = $template['tsubject'];
			$mail['message'] = $template['tt_header']."\n".$template['tt_body']."\n".$template['tt_footer'];
		}
		// a level szelesegenek beallitasa 
		$mail['message'] = wordwrap($mail['message'], 70);
		$mail['message'] = str_replace("\n.", "\n..", $mail['message']);

		// level fejlecenek elkeszitese
		$mail['header'] = "From: ".$mail['mailfrom']."\nReply-to: ".$mail['mailfrom']."\nX-Mailer: Drupal";
		if ($mail['cc'] != '') {
			$mail['header'] .= "\nCC: ".$mail['cc'];
		}
		// e-mail elkuldese
		#var_dump($template['tt_header']);
		user_mail($mail['mailto'], $mail['subject'], $mail['message'], $mail['header']);
	}
}

/**
 * _ticket_form:
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $def - form default erteki
 */
function _ticket_form($u_id, $gid, $def = array()) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	$table[] = '<table><tr><td>';
	$table[] = '</td>';
	$table[] = '<td class= "ticket-form-table">';
	$table[] = '</td></tr>';

	$table[] = '<tr><td>';
	$table[] = '</td>';
	$table[] = '<td class= "ticket-form-table">';
	$table[] = '</td></tr>';

	$table[] = '<tr><td>';
	$table[] = '</td>';
	$table[] = '<td class= "ticket-form-table">';
	$table[] = '</td></tr></table>';
	$i = 0;

	$SQL = 'SELECT type_id, type_name, def FROM {ticket_type} WHERE gid = %d AND active = 1 ORDER BY weight, type_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$type[$row['type_id']] = $row['type_name'];
		if ( ($row['def']) && ( !isset($def['type']) ) ) {
			$def['type_id'] = $row['type_id'];
		}
	}

	if ( count($type) ) {
		$form['type'] = array(
			'#type' => 'select',
			'#title' => t('Type'),
			'#options' => $type,
			'#default_value' => $def['type_id'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$SQL = 'SELECT priority_id, priority_name, weight, def FROM {ticket_priority} WHERE gid = %d AND active = 1 ORDER BY weight, priority_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$priority[$row['priority_id']] = $row['priority_name'];
		$priority_class[$row['priority_id']] = 'priority-'.$row['weight'];
		if ( ($row['def']) && ( !isset($def['priority_id']) ) ) {
			$def['priority_id'] = $row['priority_id'];
		}
	}

	if ( count($priority) ) {
		$form['priority'] = array(
			'#input' => TRUE,
			'#type' => 'selectcolor',
			'#title' => t('Priority'),
			'#options' => $priority,
			'#class' => $priority_class,
			'#default_value' => $def['priority_id'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$SQL = 'SELECT scope_id, scope_name, def FROM {ticket_scope} WHERE gid = %d AND active = 1 ORDER BY weight, scope_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$scope[$row['scope_id']] = $row['scope_name'];
		if ( ($row['def']) && ( !isset($def['scope_id']) ) ) {
			$def['scope_id'] = $row['scope_id'];
		}
	}
	if ( count($scope) ) {
		$form['scope'] = array(
			'#type' => 'select',
			'#title' => t('Scope'),
			'#options' => $scope,
			'#default_value' => $def['scope_id'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$SQL = 'SELECT site_id, site_name, def FROM {ticket_site} WHERE gid = %d AND active = 1 ORDER BY weight, site_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$site[$row['site_id']] = $row['site_name'];
		if ( ($row['def']) && ( !isset($def['site_id']) ) ) {
			$def['site_id'] = $row['site_id'];
		}
	}

	if ( count($site) ) {
		$form['site'] = array(
			'#type' => 'select',
			'#title' => t('Site'),
			'#options' => $site,
			'#default_value' => $def['site_id'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$SQL = 'SELECT fixer_id, fixer_name, def FROM {ticket_fixer} WHERE gid = %d AND active = 1 ORDER BY weight, fixer_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$fixer[$row['fixer_id']] = $row['fixer_name'];
		if ( ($row['def']) && ( !isset($def['fixer_id']) ) ) {
			$def['fixer_id'] = $row['fixer_id'];
		}
	}

	if ( count($fixer) ) {
		$form['fixer'] = array(
			'#type' => 'select',
			'#title' => t('Fixer'),
			'#options' => $fixer,
			'#default_value' => $def['fixer_id'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
	$SQL .= " WHERE ( ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0 ) OR tp.gid = %d) AND tp.role_id = p.rid AND p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
	$SQL .= ' ORDER BY u.name';
	$result = db_query($SQL, $u_id, $gid);

	if ( !$def['assigned'] ) {
		$assigned[$def['assigned']] = _ticket_get_user($def['assigned']);
	}
	while ($row = db_fetch_array($result)) {
		$assigned[$row['uid']] = $row['name'];
	}
	if ( count($assigned) ) {
		$form['assigned'] = array(
			'#type' => 'select',
			'#title' => t('Assigned to'),
			'#options' => $assigned,
			'#default_value' => $def['assigned'],
			'#prefix' => $table[$i].'<div class="ticket-form-line-select">',
			'#suffix' => '</div>'.$table[$i+1],
			'#required' => true,
		);
		$i += 2;
	}

	$close = '';
	if ($i < 11) {
		if ( ($i/2)%2 ) {
			$close = $table[10].$table[11];
		} else {
			$close = '</table>';
		}
	}

	$form['start'] = array(
		'#type' => 'textfield',
		'#title' => t('Problem started'),
		'#default_value' => $def['start'],
		'#maxlength' => '19', '#size' => '30',
		'#description' => t('Date format: year-month-day, year-month-day hour:minute'),
		'#prefix' => $close.'<div class="ticket-form-line">',
		'#suffix' => '</div>',
	);

	$form['finish'] = array(
		'#type' => 'textfield',
		'#title' => t('Problem fixed'),
		'#default_value' => $def['finish'],
		'#maxlength' => '19', '#size' => '30',
		'#description' => t('Date format: year-month-day, year-month-day hour:minute'),
		'#prefix' => '<div class="ticket-form-line">',
		'#suffix' => '</div>',
	);

	$SQL = 'SELECT mail_id, mailto, mail_name, def FROM {ticket_mail} WHERE gid = %d AND active = 1 ORDER BY mail_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$mail[$row['mail_id']] = $row['mail_name'];
		if ( ($row['def']) && ( !isset($def['mail_id']) ) ) {
			$def['mail_id'][] = $row['mail_id'];
		}
	}

	if ( count($mail) ) {
		$form['mail'] = array(
			'#input' => TRUE,
			'#process' => array('expand_checkbox_columns' => array()),
			'#tree' => TRUE,
			'#type' => 'checkbox_columns',
			'#title' => t('Mail group'),
			'#options' => $mail,
			'#default_value' => $def['mail_id'],
			'#columns' => 3,
			'#suffix' => '<br style="clear:both;"/>',
		);
	}

	$form['cc'] = array(
		'#type' => 'textfield',
		'#title' => t('CC'),
		'#default_value' => $def['cc'],
		'#maxlength' => '255', '#size' => '60',
		'#prefix' => '<div class="ticket-form-line">',
		'#suffix' => '</div>',
	);

	$form['summary'] = array(
		'#type' => 'textfield',
		'#title' => t('Short summary'),
		'#default_value' => $def['summary'],
		'#maxlength' => '255',
		'#size' => '60',
		'#prefix' => '<div class="ticket-form-line">',
		'#suffix' => '</div>',
		'#required' => true,
	);

	$form['detail'] = array(
		'#type' => 'textarea',
		'#title' => t('Detail'),
		'#default_value' => $def['detail'],
		'#rows' => '6',
		'#required' => true,
	);

	$form['affected'] = array(
		'#type' => 'textarea',
		'#title' => t('Affected'),
		'#default_value' => $def['affected'],
		'#rows' => '3',
	);

	$form['actions'] = array(
		'#type' => 'textarea',
		'#title' => t('Actions'),
		'#default_value' => $def['actions'],
		'#rows' => '3',
	);

	$form['time_to_fix'] = array(
		'#type' => 'textfield',
		'#title' => t('Time to fix'),
		'#default_value' => $def['time_to_fix'],
		'#maxlength' => '250', '#size' => '60',
	);

	$form['fix'] = array(
		'#type' => 'textarea',
		'#title' => t('Fix'),
		'#default_value' => $def['fix'],
		'#rows' => '3',
	);

	return $form;
}

/**
 * _ticket_queue_form:
 * @param $gid - group id
 * @param $def - form default erteki
 */
function _ticket_queue_form($gid, $def = array()) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

	$SQL = 'SELECT scope_id, scope_name, def FROM {ticket_scope} WHERE gid = %d AND active = 1 ORDER BY weight, scope_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$scope[$row['scope_id']] = $row['scope_name'];
		if ( ($row['def']) && ( !isset($def['scope_id']) ) ) {
			$def['scope_id'] = $row['scope_id'];
		}
	}
	if ( count($scope) ) {
		$form['scope'] = array(
			'#type' => 'select',
			'#title' => t('Scope'),
			'#options' => $scope,
			'#default_value' => $def['scope_id'],
			'#prefix' => '<div class="ticket-form-line-select">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	$SQL = 'SELECT site_id, site_name, def FROM {ticket_site} WHERE gid = %d AND active = 1 ORDER BY weight, site_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$site[$row['site_id']] = $row['site_name'];
		if ( ($row['def']) && ( !isset($def['site_id']) ) ) {
			$def['site_id'] = $row['site_id'];
		}
	}

	if ( count($site) ) {
		$form['site'] = array(
			'#type' => 'select',
			'#title' => t('Site'),
			'#options' => $site,
			'#default_value' => $def['site_id'],
			'#prefix' => '<div class="ticket-form-line-select">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	$SQL = 'SELECT priority_id, priority_name, def FROM {ticket_priority} WHERE gid = %d AND active = 1 ORDER BY weight, priority_name';
	$result = db_query($SQL, $gid);
	while ($row = db_fetch_array($result)) {
		$priority[$row['priority_id']] = $row['priority_name'];
		if ( ($row['def']) && ( !isset($def['priority_id']) ) ) {
			$def['priority_id'] = $row['priority_id'];
		}
	}

	if ( count($priority) ) {
		$form['priority'] = array(
			'#type' => 'select',
			'#title' => t('Priority'),
			'#options' => $priority,
			'#default_value' => $def['priority_id'],
			'#prefix' => '<div class="ticket-form-line-select">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	$form['summary'] = array(
		'#type' => 'textfield',
		'#title' => t('Short summary'),
		'#default_value' => $def['summary'],
		'#maxlength' => '255',
		'#size' => '60',
		'#prefix' => '<div class="ticket-form-line">',
		'#suffix' => '</div>',
		'#required' => true,
	);

	$form['detail'] = array(
		'#type' => 'textarea',
		'#title' => t('Detail'),
		'#default_value' => $def['detail'],
		'#rows' => '6',
		'#required' => true,
	);
	return $form;
}

/**
 * _ticket_search_base: hibajegy kereses lelke
 * @param $def - alapertelmezett keresesi ertekek
 * @param $links - url parameter
 * @param $u_id - unit id
 * @param $gid - group id
 */
function _ticket_search_base($def, $links, $u_id = NULL, $gid = NULL) {
	$form = array();
	if ( isset($u_id) ) {
		$form['u_id'] = array(
			'#type' => 'value',
			'#value' => $u_id,
		);
	} else {
		$def['unit'] = -1;
	}

	if ( isset($gid) ) {
		$form['gid'] = array(
			'#type' => 'value',
			'#value' => $gid,
		);
	} else {
		$def['group'] = -1;
	}

	unset($links[0], $links[1]);
	// ha tortent kereses
	if ( count($links) ) {
		// a link parameterbol csinal tombot
		$links = _ticket_search_get_default($links);
		// link ertekeivel felul irja az alapertelmezett ertekeket
		$def = array_merge($def, $links);
		if ( !is_array($def['date1']) ) {
			// datum szetdarabolasa
			list($y, $m, $d) = explode('-', $def['date1']);
			$def['date1'] = array();
			$def['date1']['y'] = $y;
			$def['date1']['m'] = $m;
			$def['date1']['d'] = $d;
		}
		if ( !is_array($def['date2']) ) {
			// datum szetdarabolasa
			list($y, $m, $d) = explode('-', $def['date2']);
			$def['date2'] = array();
			$def['date2']['y'] = $y;
			$def['date2']['m'] = $m;
			$def['date2']['d'] = $d;
		}
	}

	// kereses lehetseges ertekei
	$var = _ticket_search_attrib($u_id, $gid);
	// form elkeszitese
	_ticket_search_form($form, $var, $def);

	$form['src']['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Search')
	);

	// ha volt mar kereses
	if ( count($links) ) {
		$form['src']['#collapsed'] = TRUE;
		$links['u_id'] = $u_id;
		$links['gid'] = $gid;
		_ticket_search($links, $var);
		// kereses eredmenye
		list($table, $pager) = _ticket_list_table($u_id, $gid);
	}

	// kereses formja
	$search_form = drupal_get_form('ticket_search_form', $form);
	// kereses oldal megjelenitese
	return theme('ticket_list', $search_form, $table, $pager);
}

/**
 * _ticket_search: kereses a ticketek kozott
 * @param $links - linkbol atalakitott keresesi feltetelek
 * @param $var - kereses form ertekei
 */
function _ticket_search($links, $var) {
	$sql['from'] = array();
	$sql['where'] = array();
	$param[1] = $param[2] = $param[3] = $param[4] = $param[5] = NULL;
	$param[6] = $param[7] = $param[8] = $param[9] = $param[10] = NULL;
	$param[11] = $param[12] = $param[13] = $param[14] = $param[15] = NULL;
	$param[16] = $param[17] = $param[18] = $param[19] = $param[20] = NULL;
	$i = 1;

	// ha a kereses globalis akkor szerepelnek unitok is
	if ( isset($var['unit']) ) {
		// unitok hozza illesztese a kereseshez
		if ( isset($links['unit']) ) {
			if ( is_array($links['unit']) ) {
				$sql['where'][] = ' AND tg.u_id IN (%s) AND tg.gid = tt.gid';
				$param[$i] = implode(',', $links['unit']);
			} else {
				$sql['where'][] = ' AND tg.u_id = %d AND tg.gid = tt.gid';
				$param[$i] = $links['unit'];
			}
		} else {
			$sql['where'][] = ' AND tg.u_id IN (%s) AND tg.gid = tt.gid';
			$param[$i] = implode(',', array_slice(array_keys($var['unit']), 1));
		}
		$i++;
	}
	// ha a kereses globalis vagy uniton beluli akkor szerepelnek csoportok is
	if ( isset($var['group']) ) {
		$sql['from'][] = ', {ticket_group} tg';
		if ( isset($links['group']) ) {
			$links['gid'] = $links['group'];
		} else {
			$links['gid'] = array_slice(array_keys($var['group']), 1);
		}
	}

	$list = array('gid', 'uid');
	foreach ($list as $element) {
		// csoport es felhasznalo szerinti kereses
		if ( isset($links[$element]) ) {
			if ( is_array($links[$element]) ) {
				$sql['where'][] = ' AND tt.'.$element.' IN (%s)';
				$param[$i] = implode(',', $links[$element]);
			} else {
				$sql['where'][] = ' AND tt.'.$element.' = %d';
				$param[$i] = $links[$element];
			}
			$i++;
		}
	}

	// datum szerinti kereses, megadott datumanal ujabbakat keres
	if ( isset($links['date1']) ) {
		$sql['where'][] = " AND tt.start >= %d";
		$param[$i] = strtotime($links['date1']);
		$i++;
	}

	// datum szerinti kereses, megadott datumnal regebbieket keres
	if ( isset($links['date2']) ) {
		$sql['where'][] = " AND tt.start <= %d";
		$param[$i] = strtotime($links['date2']);
		$i++;
	}

	if ( !isset($var['group']) ) {
	// ha csoporton beluli a kereses
		$list = array('type', 'priority', 'scope', 'site', 'fixer');
		foreach ($list as $element) {
			if ( isset($links[$element]) ) {
				if ( is_array($links[$element]) ) {
					$sql['where'][] = ' AND tt.'.$element.'_id IN (%s)';
					$param[$i] = implode(',', $links[$element]);
				} else {
					$sql['where'][] = ' AND tt.'.$element.'_id = %d';
					$param[$i] = $links[$element];
				}
				$i++;
			}
		}
	} else {
	// ha tobb csoport kozott is kereseshet
		$run = 0;
		$list = array('type', 'priority', 'scope', 'site', 'fixer');
		foreach ($list as $element) {
			if ( isset($links[$element]) ) {
				$sql['from'][] = ', {ticket_'.$element.'} '.$element.'';
				$sql['where'][] = ' AND tt.gid = '.$element.'.gid';
				if ( is_array($links[$element]) ) {
					$sql['where'][] = ' AND '.$element.'.'.$element.'_id = tt.'.$element.'_id AND '.$element.'.'.$element.'_name IN ('.implode(',', array_map("_ticket_txt2db", $links[$element])).')';
				} else {
					$sql['where'][] = ' AND '.$element.'.'.$element.'_id = tt.'.$element.'_id AND '.$element.'.'.$element."_name = '%s'";
					$param[$i] = $links[$element];
					$i++;
				}
			}
		}
	}

	// Szoveges keresesi parameterek
	$list = array('summary', 'detail', 'affected', 'actions', 'time_to_fix', 'fix');
	foreach ($list as $element) {
		if ( isset($links[$element]) ) {
			$sql['where'][] = ' AND tt.'.$element." LIKE '%%%s%'";
			$param[$i] = str_replace('*', '%', $links[$element]);
			$i++;
		}
	}

	// tmp tablaba kerdezem le a kereses eredmenyeit
	$SQL = "CREATE TEMPORARY TABLE tmp_table ( SELECT tt.tid, COUNT(tt.tid) AS num, MAX(te.created) AS created";
	$SQL .= " FROM {ticket_ticket} tt, {ticket_event} te ".implode(' ', $sql['from']);
	$SQL .= " WHERE tt.tid = te.tid ".implode(' ', $sql['where']);
	$SQL .= " GROUP BY tt.tid )";
	db_query($SQL, $param[1], $param[2], $param[3], $param[4], $param[5], $param[6], $param[7], $param[8], $param[9], $param[10], $param[11], $param[12], $param[13], $param[14], $param[15], $param[16], $param[17], $param[18], $param[19], $param[20]);

	$sql['where'] = array();
	$param[1] = $param[2] = NULL;
	$i = 1;
	// keresett felelosok meghagyasa
	if ( isset($links['assigned']) ) {
		if ( is_array($links['assigned']) ) {
			$sql['where'][] = ' te.reassigned NOT IN (%s)';
			$param[$i] = implode(',', $links['assigned']);
		} else {
			$sql['where'][] = ' te.reassigned <> %d ';
			$param[$i] = $links['assigned'];
		}
		$i++;
	}

	if ( !isset($var['group']) ) {
	// ha csoporton beluli a kereses
		if ( isset($links['status']) ) {
			// keresett status meghagyasa
			if ( is_array($links['status']) ) {
				$sql['where'][] = ' te.status_id NOT IN (%s)';
				$param[$i] = implode(',', $links['status']);
			} else {
				$sql['where'][] = ' te.status_id <> %d ';
				$param[$i] = $links['status'];
			}
		}
		// ha kell akkor a hibas talalatok torlesre kerulnek
		if ( isset($links['status']) || isset($links['assigned']) ) {
			$SQL = "DELETE FROM {tmp_table} tmp USING {tmp_table} tmp, {ticket_event} te ";
			$SQL .= " WHERE tmp.tid = te.tid AND te.created = tmp.created AND";
			$SQL .= " (".implode(' OR ', $sql['where']).")";
			db_query($SQL, $param[1], $param[2]);
		}
	} else {
	// ha tobb csoport kozott is kereseshet
		if ( isset($links['status']) ) {
		// keresett felelosok meghagyasa
			if ( is_array($links['status']) ) {
				$sql['where'][] = " ts.status_name NOT IN (".implode(',', array_map("_ticket_txt2db", $links['status'])).")";
			} else {
				$sql['where'][] = " ts.status_name <> '%s' ";
				$param[$i] = $links['status'];
			}
		}
		// ha kell akkor a hibas talalatok torlesre kerulnek
		if ( isset($links['status']) || isset($links['assigned']) ) {
			$SQL = "DELETE FROM {tmp_table} tmp USING {tmp_table} tmp, {ticket_event} te , {ticket_status} ts ";
			$SQL .= " WHERE te.status_id = ts.status_id AND tmp.tid = te.tid AND te.created = tmp.created AND";
			$SQL .= " (".implode(' OR ', $sql['where']).")";
			db_query($SQL, $param[1], $param[2]);
		}
	}
}

/**
 * _ticket_search_attrib: kereses atributumai
 * @param $u_id - unit id
 * @param $gid - group id
 * @return $var - ertekek
 */
function _ticket_search_attrib($u_id = NULL, $gid = NULL) {
	global $user;

	$list = array('type', 'priority', 'scope', 'site', 'fixer', 'status');
	// csoporton beluli kereses
	if ( isset($u_id) && isset($gid) ) {
		// ticket tulajdonsagainak kigyujtese
		foreach ($list as $element) {
			$var[$element] = array();
			$SQL = "SELECT ".$element."_id, ".$element."_name FROM {ticket_".$element."} WHERE gid = %d ORDER BY ";
			if ($element == 'status') {
				$SQL .= "closed, ";
			}
			$SQL .= "weight, ".$element."_name";
			$result = db_query($SQL, $gid);
			if ( db_num_rows($result) ) {
				$var[$element][-1] = t('any');
				while ($row = db_fetch_array($result)) {
					$var[$element][$row[$element.'_id']] = $row[$element.'_name'];
				}
			}
		}
		// ticket karbantartoinak kigyujtese
		$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
		$SQL .= " WHERE ( ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0 ) OR tp.gid = %d) AND tp.role_id = p.rid AND";
		$SQL .= " p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
		$SQL .= " ORDER BY u.name";
		$result = db_query($SQL, $u_id, $gid);
	} elseif ( isset($u_id) ) {
	// uniton beluli kereses
		// azon csoportok kigyujtese ahol kereshet
		if ( ( ticket_access('ticket manager', $u_id, 0) ) || ( ticket_access('ticket reader', $u_id, 0) ) ) {
			$SQL = "SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d ORDER BY weight, group_name";
			$result = db_query($SQL, $u_id);
		} else {
			$SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
			$SQL .= " WHERE tp.u_id = %d AND ur.uid = %d AND tp.role_id = p.rid AND";
			$SQL .= " (p.perm LIKE '%ticket manager%' OR p.perm LIKE '%ticket reader%') AND ur.rid = p.rid AND tg.gid = tp.gid";
			$SQL .= " ORDER BY tg.group_name";
			$result = db_query($SQL, $u_id, $user->uid);
		}
		// csak ha van olyan csoport ahol kereshet akkor megy tovabb
		if ( db_num_rows($result) ) {
			$var['group'][-1] = t('any');
			while ($row = db_fetch_array($result)) {
				$var['group'][$row['gid']] = $row['group_name'];
				$groups[] = $row['gid'];
			}
			$groups = implode(',', $groups);
			// ticket tulajdonsagainak kigyujtese
			foreach ($list as $element) {
				$SQL = "SELECT ".$element."_name FROM {ticket_".$element."} ";
				$SQL .= ' WHERE gid IN (%s) GROUP BY '.$element.'_name ORDER BY ';
				if ($element == 'status') {
					$SQL .= "closed, ";
				}
				$SQL .= "weight, ".$element."_name";
				$result = db_query($SQL, $groups);
				if ( db_num_rows($result) ) {
					$var[$element][-1] = t('any');
					while ($row = db_fetch_array($result)) {
						$var[$element][$row[$element.'_name']] = $row[$element.'_name'];
					}
				}
			}
			// ticket karbantartoinak kigyujtese
			$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
			$SQL .= " WHERE ( (tp.u_id = %d OR tp.u_id = 0) AND (tp.gid IN (%s) OR tp.gid = 0)  ) AND tp.role_id = p.rid AND";
			$SQL .= " p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
			$SQL .= " ORDER BY u.name";
			$result = db_query($SQL, $u_id, $groups);
		}
	} else {
	// globalis kereses
		$var['unit'][-1] = t('any');
		$var['group'][-1] = t('any');
		if ( ( ticket_access('ticket manager', 0, 0) ) || ( ticket_access('ticket reader', 0, 0) ) ) {
			// osszes unit lekerdezese
			$SQL = "SELECT u_id, unit_name FROM {ticket_unit}";
			$result = db_query($SQL);
			while ($row = db_fetch_array($result)) {
				$var['unit'][$row['u_id']] = $row['unit_name'];
				$units[] = $row['u_id'];
			}
			$units = implode(',', $units);
			// osszes csoport lekerdezese
			$SQL = "SELECT gid, group_name FROM {ticket_group}";
			$result = db_query($SQL);
			while ($row = db_fetch_array($result)) {
				$var['group'][$row['gid']] = $row['group_name'];
				$groups[] = $row['gid'];
			}
		} else {
			// unitok lekerdezese amiben kereshet 
			$SQL = "SELECT tu.u_id, tu.unit_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_unit} tu";
			$SQL .= " WHERE tp.u_id = tu.u_id AND ur.uid = %d AND tp.role_id = p.rid AND ";
			$SQL .= " (p.perm LIKE '%ticket manager%' OR p.perm LIKE '%ticket reader%') AND ur.rid = p.rid";
			$SQL .= " GROUP BY tu.u_id, tu.unit_name ";
			$SQL .= " ORDER BY tu.unit_name";
			$result = db_query($SQL, $user->uid);
			while ($row = db_fetch_array($result)) {
				$var['unit'][$row['u_id']] = $row['unit_name'];
				$units[] = $row['u_id'];
			}
			$units = implode(',', $units);

			// csoportok lekerdezese amiben kereshet (amelyik unit osszes csoportjara vonatkozo joga van) 
			$SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
			$SQL .= " WHERE tp.u_id IN (%s) AND tp.gid = 0 AND tg.u_id = tp.u_id AND ur.uid = %d AND tp.role_id = p.rid AND ";
			$SQL .= " (p.perm LIKE '%ticket manager%' OR p.perm LIKE '%ticket reader%') AND ur.rid = p.rid";
			$SQL .= " GROUP BY tg.gid, tg.group_name ";
			$SQL .= " ORDER BY tg.group_name";
			$result = db_query($SQL, $units, $user->uid);
			while ($row = db_fetch_array($result)) {
				$var['group'][$row['gid']] = $row['group_name'];
				$groups[] = $row['gid'];
			}

			// csoportok lekerdezese amiben kereshet (amelyik unit nehany csoportjara vonatkozo joga van) 
			$SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
			$SQL .= " WHERE tp.u_id IN (%s) AND tp.gid <> 0 AND tp.gid = tg.gid AND tg.u_id = tp.u_id AND ur.uid = %d AND tp.role_id = p.rid AND ";
			$SQL .= " (p.perm LIKE '%ticket manager%' OR p.perm LIKE '%ticket reader%') AND ur.rid = p.rid";
			$SQL .= " GROUP BY tg.gid, tg.group_name ";
			$SQL .= " ORDER BY tg.group_name";
#MOD
			$result = db_query($SQL, $units, $user->uid);
			while ($row = db_fetch_array($result)) {
				$var['group'][$row['gid']] = $row['group_name'];
				$groups[] = $row['gid'];
			}
		}
		$groups = implode(',', $groups);
		// ticket tulajdonsagainak kigyujtese
		foreach ($list as $element) {
			$SQL = "SELECT ".$element."_name FROM {ticket_".$element."} ";
			$SQL .= ' WHERE gid IN (%s) GROUP BY '.$element.'_name ORDER BY ';
			if ($element == 'status') {
				$SQL .= "closed, ";
			}
			$SQL .= "weight, ".$element."_name";
			$result = db_query($SQL, $groups);
			if ( db_num_rows($result) ) {
				$var[$element][-1] = t('any');
				while ($row = db_fetch_array($result)) {
					$var[$element][$row[$element.'_name']] = $row[$element.'_name'];
				}
			}
		}
		// ticket karbantartoinak kigyujtese
		$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
		$SQL .= " WHERE ( (tp.u_id IN (%s) OR tp.u_id = 0) AND (tp.gid IN (%s) OR tp.gid = 0) ) AND tp.role_id = p.rid AND ";
		$SQL .= " p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
		$SQL .= " ORDER BY u.name";
		$result = db_query($SQL, $units, $groups);
	}

	// felelosok kigyujtese
	$var['assigned'] = array();
	if ( db_num_rows($result) ) {
		$var['assigned'][-1] = t('anybody');
		$var['assigned'][0] = _ticket_get_user(0);
		while ($row = db_fetch_array($result)) {
			$var['assigned'][$row['uid']] = $row['name'];
		}
	}

	$var['uid'] = $var['assigned'];

	// 2005-tol napjainkig
	$var['date']['y'][-1] = '*';
	for ( $i = 2005;$i <= date('Y') ;$i++ ) {
		$var['date']['y'][$i] = $i;
	}
	$var['date']['m'][-1] = '*';
	for ( $i = 1;$i <= 12 ;$i++ ) {
		if ( $i < 10 ) {
			$var['date']['m'][$i] = '0'.$i;
		} else {
			$var['date']['m'][$i] = $i;
		}
	}
	$var['date']['d'][-1] = '*';
	for ( $i = 1;$i <= 31 ;$i++ ) {
		if ( $i < 10 ) {
			$var['date']['d'][$i] = '0'.$i;
		} else {
			$var['date']['d'][$i] = $i;
		}
	}
	return $var;
}

/**
 * _ticket_search_link: Kitoltott form parametereibol linket keszit 
 * @param $values - form altal atadott ertekek
 * @return $link - a form ertekeibol keszitett linket adja vissza
 */
function _ticket_search_link($values) {
	foreach ($values as $key => $value) {
		if ( ($key !='submit') && ($key != 'form_id') && ($key !='u_id') && ($key != 'gid')) {
			if ( is_array($value) ) {
				if ( !isset($value['-1']) ) {
					$link .= '/'.$key.':';
					foreach ($value as $sub_value) {
						$link .= $sub_value.'+';
					}
					$link = trim($link, '+');
				}
			} else {
				if ( !(($value == '-1') || ($value == '')) ) {
					$link .= '/'.$key.':'.$value;
				}
			}
		}
	}
	return $link;
}

/** 
 * _ticket_search_get_default: alapertelemezett ertekek felul irasa a link
 * parameter alapjan
 * @param $def - alapertelmezett ertek megadasa, ha elter a megszokottol
 * @param $links - modositja az alapertelmezett ertekeket
 * @return form alapertelmezett elemeit adja vissza 
 */
function _ticket_search_get_default($links) {
	// alapertelemezett ertekek felul irasa a link parameter alapjan
	$def = array();
	if (count($links)) {
		$prev_key = '';
		foreach ($links as $value) {
			if ( strpos($value, ':') ) {
				list($key, $link) = explode(':', $value);
				if ( strpos($link, '+') ) {
					$link = explode('+', $link);
				}
				$def[$key] = $link;
				$prev_key = $key;
			} else {
				 $def[$prev_key] .= '/'.$value;
			}
		}
	}
	return $def;
}

/** 
 * _ticket_search_form: kereses form kiiratasa
 * @param $form - form
 * @param $var - form ertekei
 * @param $def - alapertelmezett form ertekek
 */
function _ticket_search_form(&$form, $var, $def) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

	$form['src'] = array(
		'#type' => 'fieldset',
		'#title' => t('Search'),
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	$form['src']['attrib'] = array(
		'#type' => 'fieldset',
		'#title' => t('Attributes'),
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);
	if ( count($var['unit']) && isset($def['unit']) ) {
		$form['src']['attrib']['unit'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Units'),
			'#options' => $var['unit'],
			'#default_value' => $def['unit'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['group']) && isset($def['group']) ) {
		$form['src']['attrib']['group'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Groups'),
			'#options' => $var['group'],
			'#default_value' => $def['group'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['uid']) && isset($def['uid']) ) {
		$form['src']['attrib']['uid'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Opened by'),
			'#options' => $var['uid'],
			'#default_value' => $def['uid'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['assigned']) && isset($def['assigned']) ) {
		$form['src']['attrib']['assigned'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Assigned to'),
			'#options' => $var['assigned'],
			'#default_value' => $def['assigned'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}


	$form['src']['t-attrib'] = array(
		'#type' => 'fieldset',
		'#title' => t('Ticket attributes'),
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	if ( count($var['type']) && isset($def['type']) ) {
		$form['src']['t-attrib']['type'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Type'),
			'#options' => $var['type'],
			'#default_value' => $def['type'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['priority']) && isset($def['priority']) ) {
		$form['src']['t-attrib']['priority'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Priority'),
			'#options' => $var['priority'],
			'#default_value' => $def['priority'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['scope']) && isset($def['scope']) ) {
		$form['src']['t-attrib']['scope'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Scope'),
			'#options' => $var['scope'],
			'#default_value' => $def['scope'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['site']) && isset($def['site']) ) {
		$form['src']['t-attrib']['site'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Site'),
			'#options' => $var['site'],
			'#default_value' => $def['site'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['fixer']) && isset($def['fixer']) ) {
		$form['src']['t-attrib']['fixer'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Fixer'),
			'#options' => $var['fixer'],
			'#default_value' => $def['fixer'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	if ( count($var['status']) && isset($def['status']) ) {
		$form['src']['t-attrib']['status'] = array(
			'#type' => 'select',
			'#multiple' => true,
			'#title' => t('Status'),
			'#options' => $var['status'],
			'#default_value' => $def['status'],
			'#prefix' => '<div class="ticket-form-multiple">',
			'#suffix' => '</div>',
		);
	}

	$form['src']['date'] = array(
		'#type' => 'fieldset',
		'#title' => t('Problem started'),
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	$form['src']['date']['date1-y'] = array(
		'#type' => 'select',
		'#title' => t('From'),
		'#options' => $var['date']['y'],
		'#default_value' => $def['date1']['y'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '<span class = "sep"> - </span></div>',
	);

	$form['src']['date']['date1-m'] = array(
		'#type' => 'select',
		'#title' => '',
		'#options' => $var['date']['m'],
		'#default_value' => $def['date1']['m'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '<span class = "sep"> - </span></div>',
	);

	$form['src']['date']['date1-d'] = array(
		'#type' => 'select',
		'#title' => '',
		'#options' => $var['date']['d'],
		'#default_value' => $def['date1']['d'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '</div>',
	);

	$form['src']['date']['date2-y'] = array(
		'#type' => 'select',
		'#title' => t('To'),
		'#options' => $var['date']['y'],
		'#default_value' => $def['date2']['y'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '<span class = "sep"> - </span></div>',
	);

	$form['src']['date']['date2-m'] = array(
		'#type' => 'select',
		'#title' => '',
		'#options' => $var['date']['m'],
		'#default_value' => $def['date2']['m'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '<span class = "sep"> - </span></div>',
	);

	$form['src']['date']['date2-d'] = array(
		'#type' => 'select',
		'#title' => '',
		'#options' => $var['date']['d'],
		'#default_value' => $def['date2']['d'],
		'#prefix' => '<div class="ticket-form-date">',
		'#suffix' => '</div>',
	);

	$form['src']['summary'] = array(
		'#type' => 'textfield',
		'#title' => t('Short summary'),
		'#default_value' => $def['summary'],
		'#maxlength' => '255',
		'#size' => '60',
		'#prefix' => '<div class="ticket-form-line">',
		'#suffix' => '</div>',
	);

	$form['src']['detail'] = array(
		'#type' => 'textarea',
		'#title' => t('Detail'),
		'#default_value' => $def['detail'],
		'#rows' => '2',
	);

	if ( isset($def['affected']) ) {
		$form['src']['affected'] = array(
			'#type' => 'textarea',
			'#title' => t('Affected'),
			'#default_value' => $def['affected'],
			'#rows' => '2',
		);
	}

	if ( isset($def['actions']) ) {
		$form['src']['actions'] = array(
			'#type' => 'textarea',
			'#title' => t('Actions'),
			'#default_value' => $def['actions'],
			'#rows' => '2',
		);
	}

	if ( isset($def['time_to_fix']) ) {
		$form['src']['time_to_fix'] = array(
			'#type' => 'textfield',
			'#title' => t('Time to fix'),
			'#default_value' => $def['time_to_fix'],
			'#maxlength' => '250', '#size' => '60',
		);
	}

	if ( isset($def['fix']) ) {
		$form['src']['fix'] = array(
			'#type' => 'textarea',
			'#title' => t('Fix'),
			'#default_value' => $def['fix'],
			'#rows' => '2',
		);
	}
	return $form;
}

/** 
 * _ticket_export: ticket exportalas
 * @param $u_id - unit id
 * @param $gid - group id
 * @param $field - azok a mezok amik az exportba irodnak
 * @param $mode - csv vagy web lesz a kimenet
 */
function _ticket_export($u_id, $gid, $field, $mode) {
	// valaszthato mezok
	$fields = array('unit_name', 'group_name', 'tid', 'uid', 'type_name', 'priority_name', 'scope_name', 'site_name', 'fixer_name', 'assigned', 'start', 'finish', 'length', 'summary', 'detail', 'affected', 'actions', 'time_to_fix', 'fix');
	if ( !is_array($field) ) {
		$t[] = $field;
		$field = $t;
	}
	$field = array_flip($field);

	// az adatbazis mezokhoz rendelt megjelenitesi nev
	$data = array(
		'unit_name' => t('Unit'),
		'group_name' => t('Group'),
		'tid' => t('Ticket ID'),
		'uid' => t('Opened by'),
		'type_name' => t('Type'),
		'priority_name' => t('Priority'),
		'scope_name' => t('Scope'),
		'site_name' => t('Site'),
		'fixer_name' => t('Fixer'),
		'assigned' => t('Assigned to'),
		'start' => t('Problem started'),
		'finish' => t('Problem fixed'),
		'length' => t('Problem length'),
		'summary' => t('Short summary'),
		'detail' => t('Detail'),
		'affected' => t('Affected'),
		'actions' => t('Actions'),
		'time_to_fix' => t('Time to fix'),
		'fix' => t('Fix'),
	);

	// kivalasztott mezok kigyujtese (adatbazis lekerdezeshez es kiiratashoz egyarant)
	$column = array();
	foreach ($fields as $f) {
		if ( isset($field[$f]) ) {
			$header[] = array('data' => $data[$f]);
			if ($f != 'tid') {
				if ( $f == 'length') {
					// a hosszhoz szukseg van kezdet es lezaras idopontjara
					if ( !isset($field['start']) ) {
						$column[] = 'start';
					}
					if ( !isset($field['finish']) ) {
						$column[] = 'finish';
					}
				} else {
					$column[] = $f;
				}
			}
		}
	}

	// adatok lekerdezese
	$SQL = "SELECT t.tid, t.gid, tg.u_id, tp.weight";
	if ( count($column) ) {
		$SQL .= ', '.implode(', ', $column);
	}
	$SQL .= " FROM {ticket_ticket} t, {ticket_priority} tp, {ticket_type} tt, {ticket_scope} tsc, {ticket_site} tsi,";
	$SQL .= " {ticket_fixer} tf, {ticket_unit} tu, {ticket_group} tg, {tmp_table} tmp";
	$SQL .= " WHERE tg.gid = t.gid AND t.tid=tmp.tid AND tg.u_id = tu.u_id ";
	$SQL .= " AND t.type_id = tt.type_id AND t.priority_id = tp.priority_id AND t.scope_id = tsc.scope_id ";
	$SQL .= " AND t.site_id = tsi.site_id AND t.fixer_id = tf.fixer_id";
	$result = db_query($SQL);

	$rows = array();
	$field = array_flip($field);
	// ha a ticket hossza ki van valasztva akkor $length = 1
	if ( array_search('length', $field) ) {
		$length = 1;
	} else {
		$length = 0;
	}
	
	while ($row = db_fetch_array($result)) {
		// ha weboldalra lesz kiiratva akkor a specialis karaktereket at kell alakitani ugy, hogy megjelenjenek az oldalon
		// ez azert lett kiemelve, mert a ticket id-bol link lesz, es akkor a summarynal hibas link keletkezne
		if ($mode != 'csv') {
			if ( isset($row['summary']) ) {
				$row['summary'] = l(htmlspecialchars($row['summary'], ENT_QUOTES, 'UTF-8'), 'ticket/'.$row['u_id'].'/'.$row['gid'].'/'.$row['tid']);
			}
			$row['tid'] = l($row['tid'], 'ticket/'.$row['u_id'].'/'.$row['gid'].'/'.$row['tid']);
		}

		if ($row['uid'] == 0) {
			$row['num'] = 0;
		}
		$line = array();
		// ticket hosszanak kiszamitasa
		if ( $length ) {
			if ( isset($row['finish']) ) {
				$finish = $row['finish'];
			} else {
				$finish = time();
			}
			$row['length'] = format_interval($finish - $row['start'], 3);
		}
		// a kivalasztott mezoket a megfelelo formara alakitjuk
		foreach ($field as $f) {
			switch ($f) {
				case 'detail':
				case 'affected':
				case 'actions':
				case 'time_to_fix':
				case 'fix':
					if ($mode == 'csv') {
					// ha csv-be lesz kiiratva akkor a sortores karaktereket kitorlesre kerulnek
						$row[$f] = str_replace(array("\n", "\r", "\r\n"), ' ', $row[$f]);
					// valamint a " jelbol ' keszul, es a tartalom "" koze kerul, igy szerepelhet a szovegben ; karakter is 
						$row[$f] = '"'.str_replace('"', "'", $row[$f]).'"';
					} else {
					// ha weboldalra lesz kiiratva akkor a specialis karaktereket at kell alakitani ugy, hogy megjelenjenek az oldalon
						$row[$f] = nl2br(htmlspecialchars($row[$f], ENT_QUOTES, 'UTF-8'));
					}
				break;

				// timestamp formatum atalakitasa rendes datumra
				case 'start':
					$row['start'] = format_date($row['start'], 'small');
				break;

				// timestamp formatum atalakitasa rendes datumra
				case 'finish':
					if ( isset($row['finish']) ) {
						$row['finish'] = format_date($row['finish'], 'small');
					}
				break;

				// felhasznalo azonositojat lecsereljuk a nevere
				case 'uid':
				case 'assigned':
					$row[$f] = _ticket_get_user($row[$f]);
				break;
			}

			// ha a mezonek nincs erteke akkor alapertelemzett ertek a: -
			if ( !isset($row[$f]) ) {
				$row[$f] = '-';
			}

			// prioritas szinezesre kerul ha webes feluletre lesz kiiratva
			if ( ($f == 'priority_name') && ($mode != 'csv') ) {
				$line[] = array('data' => $row[$f], 'class' => 'priority-'.$row['weight']);
			} else {
//				$line[] = array('data' => $row[$f]);
				$line[] = $row[$f];
			}
		}
		// csv eseten a mezok koze ; kerul beirasra
		if ($mode == 'csv') {
			$rows[] = implode(';', $line);
		} else {
			$rows[] = $line;
		}
	}
	// kiiratas, csv-nel fileba web-nel tablazatba
	if ($mode == 'csv') {
		$output = implode("\r\n", $rows);
	} else {
		$output = theme('ticket_table_list', $header, $rows);
	}
	return $output;
}

// SQL utasitas parameterenek szurese
function _ticket_txt2db($txt) {
	return "'".db_escape_string($txt)."'";
}

/********************************************************************
 ****************************** TICKET ******************************
 *******************************************************************/
/** 
 * ticket_user_help: ticket help
 */
function ticket_user_help() {
	if ( func_num_args() ) {
		$help = func_get_args();
		$help = implode('/', $help);
	} else {
		$help = NULL;
	}

	$output = '';
	switch ($help) {
		case 'ticket':
			drupal_set_title(t('Ticket help'));
			$output = t("<h1>Trouble ticket:</h1>\r\n<dl>\r\n<dt><b>Type:</b></dt>\r\n  <dd>Choose ticket type from the list!</dd>\r\n<dt><b>Priority:</b></dt>\r\n  <dd>Choose ticket priority from the list!</dd>\r\n<dt><b>Scope:</b></dt>\r\n  <dd>Choose ticket scope from the list! (does not always appear).</dd>\r\n<dt><b>Location:</b></dt>\r\n  <dd>Choose ticket location from the list! (does not always appear).</dd>\r\n<dt><b>Fixer:</b></dt>\r\n  <dd>Choose ticket fixer from the list! (does not always appear)</dd>\r\n<dt><b>Assigned to:</b></dt>\r\n  <dd>Choose someone to whom the ticket is assigned from the list!</dd>\r\n\r\n<dt><b>Start date:</b></dt>\r\n  <dd>The start date of the problem.</dd>\r\n<dt><b>End date:</b></dt>\r\n  <dd>The end date of the problem.</dd>\r\n<dt><b>Mail group:</b></dt>\r\n  <dd>Trouble ticket mails will be sent to these adresses.</dd>\r\n\r\n<dt><b>CC:</b></dt>\r\n  <dd>Trouble ticket mails will be sent to the following addresses (multiple adresses may be given separated by space or comma).</dd>\r\n<dt><b>Summary:</b></dt>\r\n  <dd>Brief problem description.</dd>\r\n<dt><b>Details:</b></dt>\r\n  <dd>Detailed problem description.</dd>\r\n\r\n<dt><b>Affected:</b></dt>\r\n  <dd>List of those who are affected by the problem.</dd>\r\n<dt><b>Actions:</b></dt>\r\n  <dd>Actions taken and need to be taken to solve the problem.</dd>\r\n<dt><b>Time to fix:</b></dt>\r\n  <dd>The amount of time needed to solve the problem.</dd>\r\n<dt><b>Fix:</b></dt>\r\n  <dd>Either methods or conclusions to solve the problem.</dd>\r\n\r\n<dt>Creating new tickets can be performed by clicking on the Save button. Updates can also be saved this way.</dt>\r\n\r\n<dt>In case of existing tickets a \"Close\" button appears. Before closing the ticket a closing status can also be selected.</dt>\r\n\r\n<dt>Parameters indicated by * are mandatory.</dt>\r\n</dl>");
		break;

		case 'queue':
			drupal_set_title(t('Ticket help'));
			$output = t("<h1>Trouble ticket:</h1>\r\n<dl>\r\n<dt><b>Scope:</b></dt>\r\n  <dd>Choose ticket scope from the list! (does not always appear).</dd>\r\n<dt><b>Location:</b></dt>\r\n  <dd>Choose ticket location from list! (does not always appear).</dd>\r\n<dt><b>Priority:</b></dt>\r\n  <dd>Choose ticket priority from the list!</dd>\r\n<dt><b>Summary:</b></dt>\r\n  <dd>Brief problem description.</dd>\r\n<dt><b>Details:</b></dt>\r\n  <dd>Detailed problem description.</dd>\r\n<dt>By clicking on \"Save\" button new tickets can be created.</dt>\r\n\r\n<dt>Parameters indicated by * are mandatory.</dt>\r\n</dl>");
		break;

		case 'event':
			drupal_set_title(t('Event Help'));
			$output = t("<h1>Adding new events to trouble ticket.</h1>\r\n<dl>\r\n<dt><b>Description:</b></dt>\r\n  <dd> Description of the event.</dd>\r\n<dt><b>Status:</b></dt>\r\n  <dd> Ticket status.</dd>\r\n<dt><b>Re-assigned to:</b></dt>\r\n  <dd> A new responsible can be assigned to the ticket.</dd>\r\n</dl>");
		break;

		case 'moveto':
			drupal_set_title(t('Move to help'));
			$output = t("A ticket can be moved to an another group.\r\n During this re-assignment data loss can occur due to the different group properties.");
		break;

		case 'default':
			drupal_goto('ticket');
		break;
	}
	return $output;
}

/**
 * ticket_info: ticket unitok es csoportok rovid ismertetoje
 * @param: $u_id - unit id
 */
function ticket_info($u_id = NULL) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');

	// a megjeleno menukhoz informacio lekerdezese
	$access_list = array('ticket reader', 'ticket outsider', 'ticket manager');
	$t_info = array();
	foreach ($access_list as $access) {
		$tmps = _ticket_unit_group_list($access, '', -1, 1, 1);
		if ( count($tmps) ) {
			if ( count($t_info) ) {
				// ha mar letezik a valtozo akkor hozza
				// fuzzuk azokat az elemeket amik meg nem talalhatok meg benne
				foreach ($tmps as $key => $tmp) {
					if ( isset($t_info[$key]) ) {
						foreach ($tmp as $sub_key => $sub_tmp) {
							if ( !isset($t_info[$key][$sub_key]) ) {
								$t_info[$key][$sub_key] = $sub_tmp;
							}
						}
					} else {
						$t_info[$key] = $tmp;
					}
				}
			} else {
				$t_info = $tmps;
			}
		}
	}

	if ( isset($u_id) ) {
		$t_info = array_intersect_key($t_info, array($u_id => ''));
	}
	return theme('ticket_info', $t_info);
}

/**
 * theme_ticket_info: ticket unitok es csoportok rovid ismertetoje
 * @param: $t_info - ticket unitok es csoportok rovid ismertetojet tartalmazza
 */
function theme_ticket_info($t_infos) {
	// lista kiiratasa
	$output = '<ul>';
	foreach ($t_infos as $key => $t_info) {
		// unit hozza adasa a listahoz
		$output .= '<li>'.l($t_info[0]['name'], 'ticket/'.$key).'<ul>';
		if ($t_info[0]['desc'] != '') {
			$output .= '<li class = "ticket_desc">'.$t_info[0]['desc'].'</li>';
		}
		// csoportok hozza adasa a listahoz
		foreach ($t_info as $sub_key => $info) {
			if ( $sub_key ) {
				$output .= '<li>'.l($info['name'], 'ticket/'.$key.'/'.$sub_key);

				// add menupont ha van hozza jogod
				if ( (ticket_access('ticket manager', $key, $sub_key)) || (ticket_access('ticket outsider', $key, $sub_key)) ) {
					$output .= ' ('.l(t('add ticket'), 'ticket/'.$key.'/'.$sub_key.'/add').')';
				}
				$output .= '<ul>';
				// leiras hozzaadasa a listahoz, ha van:)
				if ($info['desc'] != '') {
					$output .= '<li class = "ticket_desc">'.$info['desc'].'</li>';
				}
				$output .= '</ul></li>';
			}
		}
		$output .= '</ul></li>';
	}
	$output .= '</ul>';
	return $output;
}

/**
 * ticket_simple_list: egyszeru ticket lista
 * @param: $u_id - unit id
 * @param: $gid - group id
 */
function ticket_simple_list($u_id, $gid) {
	global $ticket_conf;

	if ( (ticket_access('ticket reader', $u_id, $gid)) ) {
		// oldal frissitesi ideje
#		drupal_set_header('Refresh: '.$ticket_conf['page_refresh'].';');
		drupal_set_html_head('<meta http-equiv="refresh" content="'.$ticket_conf['page_refresh'].'" />');

		theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
		// egy oldalra kerulo ticketek szama

		$SQL = "SELECT count(*) FROM {ticket_ticket} WHERE closed = 0 AND gid = %d";
		$result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $gid);

		$SQL = "CREATE TEMPORARY TABLE tmp_table ( SELECT tt.tid, COUNT(tt.tid) AS num, MAX(te.created) AS created";
		$SQL .= " FROM {ticket_ticket} tt, {ticket_event} te WHERE tt.gid = %d AND tt.tid = te.tid AND tt.closed = 0 GROUP BY tt.tid )";
		db_query($SQL, $gid);
		list($table, $pager) = _ticket_list_table($u_id, $gid);
		return theme('ticket_simple_list', $table, $pager);
	} else {
		$result = db_query('SELECT description FROM {ticket_group} WHERE gid = %d', $gid);
		$row = db_fetch_array($result);
		$output = $row['description'];
	}
	return $output;
}

/**
 * theme_ticket_simple_list: theme hook
 */
function theme_ticket_simple_list($table, $pager = NULL) {
	$output = $table;
	if ( isset($pager) ) {
		$output .= $pager;
	}
	return $output;
}

/**
 * ticket_add: ticket hozzaadas
 * @param: $u_id - unit id
 * @param: $gid - group id
 */
function ticket_add($u_id, $gid) {
	global $user;

	// jogosultsag ellenorzes
	if ( (ticket_access('ticket manager', $u_id, $gid)) ) {
		// alapertelmezett ertekek
		$def['assigned'] = $user->uid;
		$def['start'] = date('*Y-m-d H:i');
		$def['finish'] = '';
		$def['cc'] = '';
		$def['summary'] = '';
		$def['detail'] = '';
		$def['affected'] = '';
		$def['actions'] = '';
		$def['time_to_fix'] = '';
		$def['fix'] = '';

		// form elkeszitese
		$form = _ticket_form($u_id, $gid, $def);

		$form['u_id'] = array(
			'#type' => 'value',
			'#value' => $u_id,
		);

		$form['gid'] = array(
			'#type' => 'value',
			'#value' => $gid,
		);

		$form['submit'] = array(
			'#type' => 'submit',
			'#value' => t('Save'),
			'#prefix' => '<div class = "ticket-help">'.l(t('help'), 'ticket/help/ticket').'</div>',
		);

		$output = drupal_get_form('ticket_add', $form);
		return '<div id = "ticket">'.$output.'</div>';
	} else {
		drupal_access_denied();
		return;
	}
}

/**
 * ticket_add_validate: ticket hozzaadas ellenorzese
 */
function ticket_add_validate($form_id, $form) {
	// problem start mezoben levo datum ellenorzese
	// Validate the "authored on" field. As of PHP 5.1.0, strtotime returns FALSE instead of -1 upon failure.
	if (!empty($form['start']) && strtotime($form['start']) <= 0) {
		form_set_error('start', t('Non-date format.'));
	}
	// problem finish mezoben levo datum ellenorzese
	if (!empty($form['finish'])) {
		if (strtotime($form['finish']) <= 0) {
			form_set_error('finish', t('Non-date format.'));
		}
		if (strtotime($form['start']) > 0) {
			if (strtotime($form['start']) > strtotime($form['finish'])) {
				form_set_error('finish', t('Date is earlier than Problem started!'));
			}
		}
	}
	// cc mezoben levo mail cim(ek) ellenorzese
	if ($form['cc'] != '') {
		if ( !_ticket_chk_emails($form['cc']) ) {
			form_set_error('cc', t('Faulty e-mail adddress(es).'));
		}
	}
}

/**
 * ticket_add_submit: ticket hozzaadas submit
 */
function ticket_add_submit($form_id, $form, $goto = 1) {
	global $user;

	// kezdo idopont ellenorzese, ha nem volt megadva az aktualis idovel valo feltoltese.
	$form['start'] = strtotime($form['start']);
	// ha van megadva finish ido akkor annak megfelelo formaba hozasa, es az SQL kiegeszitese.
	if (!empty($form['finish'])) {
		$form['finish'] = strtotime($form['finish']);
		$sql_param = ", %d";
	} else {
		$form['finish'] = 'NULL';
		$sql_param = ", %s";
	}
	// ticket hozza adasa.
	$tid = db_next_id('{ticket_ticket}_tid');
	$SQL = "INSERT INTO {ticket_ticket} (tid, uid, gid, priority_id, type_id, scope_id, site_id, fixer_id,";
	$SQL .= " assigned, cc, summary, detail, affected, actions, time_to_fix, fix, created, start, finish)";
	$SQL .= " VALUES (%d, %d, %d, %d, %d, %d, %d, %d, %d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', %d, %d".$sql_param.")";
	db_query($SQL, $tid, $user->uid, $form['gid'], $form['priority'], $form['type'], $form['scope'], $form['site'], $form['fixer'], $form['assigned'], $form['cc'], $form['summary'], $form['detail'], $form['affected'], $form['actions'], $form['time_to_fix'], $form['fix'], time(), $form['start'], $form['finish']);

	// ures event hozza adasa
	$result = db_query('SELECT status_id FROM {ticket_status} WHERE gid = %d AND closed = 0 AND def = 1', $form['gid']);
	$row = db_fetch_array($result);

	$eid = db_next_id('{ticket_event}_eid');
	db_query("INSERT INTO {ticket_event} (eid, tid, reassigned, created, status_id) VALUES (%d, %d, %d, %d, %d)", $eid, $tid, $form['assigned'], time(), $row['status_id']);

	if ( count($form['mail']) ) {
		$form['mail'] = array_diff($form['mail'], array(0));
	}
	// mail id - ticket id parok letrehozasa
	if ( count($form['mail']) ) {
		foreach ($form['mail'] as $key => $mail_id) {
			db_query("INSERT INTO {ticket_rel_ticket_mail} (tid, mail_id) VALUES (%d, %d)", $tid, $key);
		}
	}
	_ticket_mail_send($form['gid'], $tid);
	if ( $goto ) {
		drupal_goto('ticket/'.$form['u_id'].'/'.$form['gid']);
	}
}

/**
 * ticket_add_queue: ticket hozzaadasa kulsosokkel
 */
function ticket_add_queue($u_id, $gid) {
	global $user;
	// jogosultsag ellenorzes
	if ( (ticket_access('ticket outsider', $u_id, $gid)) ) {
		$def['created'] = '';
		$def['summary'] = '';
		$def['detail'] = '';

		// form elkeszitese
		$form = _ticket_queue_form($gid, $def);
	
		$form['gid'] = array(
			'#type' => 'value',
			'#value' => $gid,
		);
		$form['u_id'] = array(
			'#type' => 'value',
			'#value' => $u_id,
		);

		$form['submit'] = array(
			'#type' => 'submit',
			'#value' => t('Save'),
			'#prefix' => '<div class = "ticket-help">'.l(t('help'), 'ticket/help/queue').'</div>',
		);

		$output = drupal_get_form('ticket_add_queue', $form);
		return $output;
	} else {
		drupal_access_denied();
		return;
	}
}

/**
 * ticket_add_queue_submit: ticket hozzaadasa a queue-hoz
 */
function ticket_add_queue_submit($form_id, $form) {
	global $user;

	// ticket hozza adasa az adatbazishoz
	$qid = db_next_id('{ticket_queue}_qid');
	$SQL = "INSERT INTO {ticket_queue} (qid, uid, gid, priority_id, scope_id, site_id, created, summary, detail)";
	$SQL .= " VALUES (%d, %d, %d, %d, %d, %d, %d, '%s', '%s')";
	db_query($SQL, $qid, $user->uid, $form['gid'], $form['priority'], $form['scope'], $form['site'], time(), $form['summary'], $form['detail']);
	drupal_goto('ticket/'.$form['u_id'].'/'.$form['gid']);
}

/**
 * ticket_queue: queue list and queue 2 ticket
 */
function ticket_queue($u_id, $gid, $qid = NULL) {
	global $ticket_conf;

	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	// ha konkret hibajelentest kell elbiralni
	if ( isset($qid) ) {
		$result = db_query("SELECT * FROM {ticket_queue} WHERE qid = %d", $qid);
		if ( $row = db_fetch_array($result) ) {
			drupal_set_title(t('Queue').' - '.$row['summary']);
			$def['priority_id'] = $row['priority_id'];
			$def['scope_id'] = $row['scope_id'];
			$def['site_id'] = $row['site_id'];
			$def['start'] = format_date($row['created'], 'small');
			$def['summary'] = $row['summary'];
			$def['detail'] = $row['detail'];

			// form letrehozasa
			$form = _ticket_form($u_id, $gid, $def);

			$form['u_id'] = array(
				'#type' => 'value',
				'#value' => $u_id,
			);

			$form['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form['qid'] = array(
				'#type' => 'value',
				'#value' => $qid,
			);

			$form['uid'] = array(
				'#type' => 'value',
				'#value' => $row['uid'],
			);

			$form['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save')
			);

			$form['delete'] = array(
				'#type' => 'submit',
				'#value' => t('Delete')
			);

			$output .= drupal_get_form('ticket_queue2ticket', $form);
		}
	} else {
	// elbiralasra varo hibajelentesek listaja
		$SQL = "SELECT tq.qid, tp.weight, tp.priority_name, tsc.scope_name, tsi.site_name, tq.created, tq.summary ";
		$SQL .= " FROM {ticket_queue} tq, {ticket_priority} tp, {ticket_scope} tsc, {ticket_site} tsi";
		$SQL .= " WHERE tq.gid = %d AND tq.priority_id = tp.priority_id AND tq.scope_id = tsc.scope_id";
		$SQL .= " AND tq.site_id = tsi.site_id ORDER BY tq.created DESC";

		// egy oldalra kerulo sorok szama
		$result = pager_query($SQL, $ticket_conf['limit'], 0, NULL, $gid);

		while ( $row = db_fetch_array($result) ) {
			$rows[] = array(
				array('data' => l($row['summary'], $_GET['q'].'/'.$row['qid'])),
				array('data' => $row['priority_name'], 'class' => 'priority-'.$row['weight']),
				array('data' => $row['scope_name']),
				array('data' => $row['site_name']),
				array('data' => format_date($row['created'], 'small') ),
			);
		}
		// tablazat kiirasa
		$output = theme('ticket_queue_list', $rows);
	}
	return $output;
}

/**
 * theme_ticket_queue_list: queue list theme hook
 */
function theme_ticket_queue_list($rows) {
	drupal_set_title(t('Queue'));

	$header = array(
		array('data' => t('Summary')),
		array('data' => t('Priority')),
		array('data' => t('Scope')),
		array('data' => t('Site')),
		array('data' => t('Created')),
	);
	$output = '<div id = "ticket">';
	$output .= theme('table', $header, $rows);
	$output .= '</div>';

	return $output;
}

/**
 * ticket_queue2ticket_validate: validalas ticket add szerint ha nem torlunk
 */
function ticket_queue2ticket_validate($form_id, $form) {
	if ($_POST['op'] != t('Delete')) {
		ticket_add_validate($form_id, $form);
	}
}

/**
 * ticket_queue2ticket_submit: queue torlese, vagy queue elembol ticket
 * letrehozas
 */
function ticket_queue2ticket_submit($form_id, $form) {
	if ($_POST['op'] != t('Delete')) {
		ticket_add_submit($form_id, $form, 0);
	}
	db_query("DELETE FROM {ticket_queue} WHERE qid = %d", $form['qid']);
	$url = 'ticket/'.$form['u_id'].'/'.$form['gid'];
	$result = db_query("SELECT count(*) AS count FROM {ticket_queue} WHERE gid = %d GROUP BY gid", arg(2));
	if ( $row = db_fetch_array($result) ) {
		$url .= '/queue';
	}
	drupal_goto($url);
}

/**
 * ticket_ticket: ticket view and edit
 * @param: $u_id - unit id
 * @param: $gid - group id
 * @param: $tid - ticket id
 */
function ticket_ticket($u_id, $gid, $tid) {
	global $user;
	// jogosultsagok lekerdezese, eroforras takarekossag miatt
	$access['reader'] = ticket_access('ticket reader', $u_id, $gid);
	$access['manager'] = ticket_access('ticket manager', $u_id, $gid);
	$creator = $ticket = $move = $events = $event = $closed = NULL;

	// megtortent esemenyek lekerdezese
	if ( ($access['manager']) || ($access['reader']) ) {
		$result = db_query("SELECT e.created, e.description, e.uid, e.reassigned, ts.status_name, ts.stage FROM {ticket_event} e, {ticket_status} ts WHERE e.uid > 0 AND e.status_id = ts.status_id AND tid = %d ORDER BY e.created", $tid);
		// tablazat fejlece
		$events['header'] = array(
			array('data' => t('Created')),
			array('data' => t('Description')),
			array('data' => t('Added by')),
			array('data' => t('Assigned to')),
			array('data' => t('Status')),
		);
		// esemenyek tablazatba irasa
		while ($row = db_fetch_array($result)) {
			$events['rows'][] = array(
				array('data' => format_date($row['created'], 'small') ),
				array('data' => nl2br(htmlspecialchars($row['description'], ENT_QUOTES, 'UTF-8'))),
				array('data' => _ticket_get_user($row['uid'])),
				array('data' => _ticket_get_user($row['reassigned'])),
				array('data' => $row['status_name'], 'class' => 'stage-'.$row['stage']),
			);
		}
		// hibajegy keszitojenek es lezart allapotanak lekerdezese
		$result = db_query("SELECT uid, closed FROM {ticket_ticket} WHERE tid = %d", $tid);
		$row = db_fetch_array($result);
		$creator = _ticket_get_user($row['uid']);
	}

	// ha szerkesztheto a hibajegy es a jogosultsag is megvan hozza
	if ( ($access['manager']) && !($row['closed']) ) {
		drupal_add_js('modules/ticket/ticket.js');
		// ticket lekerdezese
		$result = db_query("SELECT * FROM {ticket_ticket} tt, {ticket_group} tg WHERE tt.gid = tg.gid AND tg.u_id = %d AND tt.gid = %d AND tt.tid = %d", $u_id, $gid, $tid);
		// lekerdezes erteke adja a form alapertelmezett ertekeit
		if ( $def = db_fetch_array($result) ) {
			// levelezo palytasok kigyujtese
			$def['mail_id'] = array();
			$result = db_query("SELECT mail_id FROM {ticket_rel_ticket_mail} WHERE tid = %d", $tid);
			while ($row = db_fetch_array($result)) {
				$def['mail_id'][] = $row['mail_id'];
			}
			// datum formazasa timestamp -> normal datum forma
			$def['start'] = format_date($def['start'], 'custom', 'Y-m-d H:i');
			if ( !isset($def['finish']) ) {
				$def['finish'] = date('*Y-m-d H:i');
			} else {
				$def['finish'] = format_date($def['finish'], 'custom', 'Y-m-d H:i');
			}

			// ticket form elkeszitese
			$form_ticket['sub'] = array(
				'#type' => 'fieldset',
				'#title' => t('Ticket'),
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_ticket['sub'][] = _ticket_form($u_id, $gid, $def);

			$form_ticket['u_id'] = array(
				'#type' => 'value',
				'#value' => $u_id,
			);

			$form_ticket['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_ticket['tid'] = array(
				'#type' => 'value',
				'#value' => $tid,
			);

			$form_ticket['sub']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save'),
				'#prefix' => '<div class = "ticket-help">'.l(t('help'), 'ticket/help/ticket').'</div><div class="ticket-line">',
				'#suffix' => '</div>',
			);
			$SQL = 'SELECT status_id, status_name, def FROM {ticket_status} WHERE gid = %d AND active = 1 AND closed = 1 ORDER BY weight, status_name';
			$result = db_query($SQL, $gid);
			while ($row = db_fetch_array($result)) {
				$closed[$row['status_id']] = $row['status_name'];
				if ( ($row['def']) && ( !isset($def['status_id']) ) ) {
					$def['status_id'] = $row['status_id'];
				}
			}

			// ticket lezarashoz status valasztas 
			if ( count($closed) ) {
				$form_ticket['sub']['status'] = array(
					'#type' => 'select',
					'#title' => t('Status'),
					'#options' => $closed,
					'#default_value' => $def['status_id'],
					'#prefix' => '<div class="ticket-line">',
					'#suffix' => '</div>',
					'#required' => true,
				);
				$form_ticket['sub']['close'] = array(
					'#type' => 'submit',
					'#value' => t('Close'),
					'#prefix' => '<div class="ticket-line">',
					'#suffix' => '</div>',
				);
			}

			// hibajegy form legeneralasa
			$ticket = drupal_get_form('ticket_edit', $form_ticket);

			// hibajegy mozgatasa olyan csoportba ahol a felhasznalo ticket managger joggal rendelkezik
			$SQL = "SELECT count(*) AS count FROM {ticket_permission} tp, {users_roles} ur, {permission} p";
			$SQL .= " WHERE ur.uid = %d AND p.perm LIKE '%%%s%' AND tp.role_id = ur.rid AND tp.role_id = p.rid AND ( (tp.u_id = 0 OR tp.u_id = %d) AND tp.gid = 0)";
			$result = db_query($SQL, $user->uid, 'ticket manager', $u_id);
			$row = db_fetch_array($result);
			if ( $row['count'] ) {
				$SQL = "SELECT gid, group_name FROM {ticket_group} WHERE u_id = %d ORDER BY group_name";
				$result = db_query($SQL, $u_id);
			} else {
				$SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {users_roles} ur, {permission} p, {ticket_group} tg";
				$SQL .= " WHERE tp.u_id = %d AND ur.uid = %d AND p.perm LIKE '%%%s%' AND tp.role_id = ur.rid AND tp.role_id = p.rid AND tg.gid = tp.gid";
				$SQL .= " ORDER BY tg.group_name";
				$result = db_query($SQL, $u_id, $user->uid, 'ticket manager');
			}
			$groups = array();
			while ($row = db_fetch_array($result)) {
				$groups[$row['gid']] = $row['group_name'];
			}

			// mozgatas form
			$form_move['move'] = array(
				'#type' => 'fieldset',
				'#title' => t('Move to'),
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_move['move']['group'] = array(
				'#type' => 'select',
				'#title' => t('Group'),
				'#options' => $groups,
				'#default_value' => $gid,
				'#prefix' => '<div class="ticket-form-line">',
				'#suffix' => '</div>',
			);
			$form_move['u_id'] = array(
				'#type' => 'value',
				'#value' => $u_id,
			);

			$form_move['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_move['tid'] = array(
				'#type' => 'value',
				'#value' => $tid,
			);

			$form_move['move']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Move to'),
				'#prefix' => '<div class = "ticket-help">'.l(t('help'), 'ticket/help/moveto').'</div>',
			);

			// mozgatas form legeneralasa
			$move = drupal_get_form('ticket_move', $form_move);

			// esemeny form elkeszitese
			$form_event['sub'] = array(
				'#type' => 'fieldset',
				'#title' => t('Add event'),
				'#collapsible' => TRUE,
				'#collapsed' => false,
			);

			$form_event['sub']['description'] = array(
				'#type' => 'textarea',
				'#title' => t('Description'),
				'#rows' => '6',
				'#required' => true,
			);

			// statusok levalogatasa, szinezese, a legutolso status lesz az alapertelmezett
			$SQL = 'SELECT status_id, status_name, stage, def FROM {ticket_status} WHERE gid = %d AND active = 1 AND closed = 0 ORDER BY weight, status_name';
			$result = db_query($SQL, $gid);
			while ($row = db_fetch_array($result)) {
				$status[$row['status_id']] = $row['status_name'];
				$status_stage[$row['status_id']] = 'stage-'.$row['stage'];
				if ( ($row['def']) && ( !isset($def['status_id']) ) ) {
					$def['status_id'] = $row['status_id'];
				}
			}
			# ha van felveve esemeny akkor az utolso statuszat allitja be
			$SQL = 'SELECT status_id FROM {ticket_event} WHERE tid = %d AND uid > 0 ORDER BY created DESC';
			$result = db_query_range($SQL, $tid, 0, 1);
			if ($row = db_fetch_array($result)) {
				$def['status_id'] = $row['status_id'];
			}

			if ( count($status) ) {
				$form_event['sub']['status'] = array(
					'#input' => TRUE,
					'#type' => 'selectcolor',
					'#title' => t('Status'),
					'#options' => $status,
					'#class' => $status_stage,
					'#default_value' => $def['status_id'],
					'#prefix' => '<div class="ticket-form-line">',
					'#suffix' => '</div>',
					'#required' => true,
				);
			}

			// hibafelelosok kigyujtese, a legutoso felelos beallitasa alapertelmezettnek
			$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
			$SQL .= " WHERE tp.gid = %d AND tp.role_id = p.rid AND p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
			$SQL .= " ORDER BY u.name";

			$result = db_query($SQL, $gid);
			while ($row = db_fetch_array($result)) {
				$assigned[$row['uid']] = $row['name'];
			}
			$result = db_query_range("SELECT reassigned, created FROM {ticket_event} WHERE tid = %d ORDER BY created DESC", $tid, 0, 1);
			$row = db_fetch_array($result);
			$def['reassigned'] = $row['reassigned'];

			if ( count($assigned) ) {
				$form_event['sub']['assigned'] = array(
					'#type' => 'select',
					'#title' => t('Re-assigned to'),
					'#options' => $assigned,
					'#default_value' => $def['reassigned'],
					'#prefix' => '<div class="ticket-form-line">',
					'#suffix' => '</div>',
					'#required' => true,
				);
			}

			$form_event['tid'] = array(
				'#type' => 'value',
				'#value' => $tid,
			);

			$form_event['u_id'] = array(
				'#type' => 'value',
				'#value' => $u_id,
			);

			$form_event['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form_event['sub']['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Save'),
				'#prefix' => '<div class = "ticket-help">'.l(t('help'), 'ticket/help/event').'</div>',
			);

			// esemeny form elkeszitese
			$event = drupal_get_form('ticket_add_event', $form_event);
		} else {
		// ha nem letezik a ticket akkor vissza ugrik a csoportra, ha az sem akkor a unitra
			$result = db_query("SELECT * FROM {ticket_group} tg WHERE u_id = %d AND gid = %d", $u_id, $gid);
			if ( $row = db_fetch_array($result) ) {
				drupal_goto('ticket/'.$u_id.'/'.$gid);
			} else {
				drupal_goto('ticket/'.$u_id);
			}
		}
	} elseif ( ($access['reader']) || ( ($access['manager']) && ($row['closed']) ) ) {
	// ticket kiiratasa
		$sql['list'] = array();
		$sql['table'] = array();
		$sql['where'] = array();

		// ha az alabbi ertekek definialva vannak ehhez a hibajegy csoporthoz akkor beillesztesre kerul a lekerdezesbe
		foreach ( array('fixer', 'scope', 'site') as $table) {
			$result = db_query("SELECT count(*) AS count FROM {ticket_ticket} tt, {ticket_".$table."} tvar WHERE tt.tid = %d AND tt.gid = tvar.gid", $tid);
			$row = db_fetch_array($result);
			if ( $row['count'] ) {
				$sql['list'][] = ', ticket_'.$table.'.'.$table.'_name';
				$sql['table'][] = ', {ticket_'.$table.'}';
				$sql['where'][] = 'AND t.'.$table.'_id = ticket_'.$table.'.'.$table.'_id';
			}
		}

		// ha hibajegy szerkeszto vagy akkor lathatod kinek lett elkuldve levelben
		if ( $access['manager'] ) {
			$sql['list'][] = ', t.cc';
		}
		$SQL = "SELECT tt.type_name, tp.weight, tp.priority_name, t.assigned, t.start, t.finish, t.summary, t.detail, t.affected, t.actions,";
		$SQL .= " t.time_to_fix, t.fix, u.name".implode('', $sql['list']);
		$SQL .= " FROM {ticket_ticket} t, {ticket_priority} tp, {ticket_type} tt, {users} u".implode('', $sql['table']);
		$SQL .= " WHERE t.tid = %d AND t.priority_id = tp.priority_id ".implode(' ', $sql['where']);
		$SQL .= " AND t.type_id = tt.type_id AND t.assigned = u.uid";

		$result = db_query($SQL, $tid);
		$ticket = db_fetch_array($result);
		if ( $access['manager'] ) {
		// ha hibajegy szerkeszto vagy akkor lathatod kinek lett elkuldve levelben
			$SQL = "SELECT tm.mail_name FROM {ticket_rel_ticket_mail} t_rel_m, {ticket_mail} tm";
			$SQL .= " WHERE t_rel_m.tid = %d AND t_rel_m.mail_id = tm.mail_id ORDER BY tm.mail_name";
			$result = db_query($SQL, $tid);
			$rows = array();
			while ($row = db_fetch_array($result)) {
				$rows[] = $row['mail_name'];
			}
			$ticket['sent_mail'] = implode(', ', $rows);

			// ujra megnyitashoz szukseges form 
			$form['gid'] = array(
				'#type' => 'value',
				'#value' => $gid,
			);

			$form['tid'] = array(
				'#type' => 'value',
				'#value' => $tid,
			);

			$form['assigned'] = array(
				'#type' => 'value',
				'#value' => $ticket['assigned'],
			);

			$form['submit'] = array(
				'#type' => 'submit',
				'#value' => t('Reopen')
			);
			$move = drupal_get_form('ticket_reopen', $form);
		}
	} else {
		drupal_access_denied();
		return;
	}
	// kiiratas
	return theme('ticket_ticket', $creator, $ticket, $events, $event, $move);
}

/**
 * theme_ticket_ticket: theme hook
 */
function theme_ticket_ticket($creator, $ticket, $events = NULL, $event = NULL, $move = NULL) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	drupal_set_title(t('Created by: %name', array('%name' => $creator)));

	$output = '<div id = "ticket">';
	// ha szerkesztheto a hibajegy akkor a form kerul kiiratasra
	if ( isset($event) ) {
		$output .= $ticket;
	} else {
	// hibajegy tablazatos kiiratasa
		$output .= '<table class = "view">'."\n";
		$output .= '<tr><td class="head">'.t('Type').': </td> <td>'.$ticket['type_name'].'</td> <td class="head">'.t('Priority').':  </td> <td class="priority-'.$ticket['weight'].'">'.$ticket['priority_name'].'</td></tr>'."\n";
		$i = 0;
		if ( isset($ticket['scope_name']) ) {
			$output .= '<tr><td class="head">'.t('Scope').':  </td> <td>'.$ticket['scope_name'].'</td>';
			$i++;
		}

		if ( isset($ticket['site_name']) ) {
			if ( $i%2 ) {
				$output .= ' <td class="head">'.t('Site').':  </td> <td>'.$ticket['site_name'].'</td></tr>'."\n";
			} else {
				$output .= '<tr><td class="head">'.t('Site').':  </td> <td>'.$ticket['site_name'].'</td>';
			} 
			$i++;
		}

		if ( isset($ticket['fixer_name']) ) {
			if ( $i%2 ) {
				$output .= ' <td class="head">'.t('Fixer').':  </td> <td>'.$ticket['fixer_name'].'</td></tr>'."\n";
			} else {
				$output .= '<tr><td class="head">'.t('Fixer').':  </td> <td>'.$ticket['fixer_name'].'</td>';
			} 
			$i++;
		}

		if ( $i%2 ) {
			$output .= ' <td class="head">'.t('Assigned to').':  </td> <td>'.$ticket['name'].'</td></tr>'."\n";
		} else {
			$output .= '<tr><td class="head">'.t('Assigned to').':  </td> <td>'.$ticket['name'].'</td> <td></td><td></td></tr>'."\n";
		} 

		$output .= '<tr><td class="head">'.t('Problem started').':  </td> <td>'.format_date($ticket['start'], 'small').'</td> <td class="head">'.t('Problem finish').':  </td> <td>'.format_date($ticket['finish'], 'small').'</td></tr>'."\n";
		$output .= '</table>'."\n";

		if ( isset($ticket['sent_mail']) && ($ticket['sent_mail'] != '') ) {
			$output .= '<div class="head">'.t('Sent mail').":</div>\n";
			$output .= '<div class="data">'.$ticket['sent_mail']."</div>\n";
		}
		if ( isset($ticket['cc']) && ($ticket['cc'] != '') ) {
			$output .= '<div class="head">'.t('CC').":</div>\n";
			$output .= '<div class="data">'.$ticket['cc']."</div>\n";
		}

		$output .= '<div class="head">'.t('Short summary').":</div>\n";
		$output .= '<div class="data">'.htmlspecialchars($ticket['summary'], ENT_QUOTES, 'UTF-8')."</div>\n";
		$output .= '<div class="head">'.t('Detail').":</div>\n";
		$output .= '<div class="data">'.nl2br(htmlspecialchars($ticket['detail'], ENT_QUOTES, 'UTF-8'))."</div>\n";
		if ($ticket['affected'] != '') {
			$output .= '<div class="head">'.t('Affected').":</div>\n";
			$output .= '<div class="data">'.nl2br(htmlspecialchars($ticket['affected'], ENT_QUOTES, 'UTF-8'))."</div>\n";
		}
		if ($ticket['action'] != '') {
			$output .= '<div class="head">'.t('Action').":</div>\n";
			$output .= '<div class="data">'.nl2br(htmlspecialchars($ticket['action'], ENT_QUOTES, 'UTF-8'))."</div>\n";
		}
		if ($ticket['time_to_fix'] != '') {
			$output .= '<div class="head">'.t('Time to fix').":</div>\n";
			$output .= '<div class="data">'.htmlspecialchars($ticket['time_to_fix'], ENT_QUOTES, 'UTF-8')."</div>\n";
		}
		if ($ticket['fix'] != '') {
			$output .= '<div class="head">'.t('Fix').":</div>\n";
			$output .= '<div class="data">'.nl2br(htmlspecialchars($ticket['fix'], ENT_QUOTES, 'UTF-8'))."</div>\n";
		}
	}
	$output .= '</div>';

	// esemenyek kiiratasa
	if ( isset($events) ) {
		if ( count($events['rows']) ) {
			$output .= '<div id="events">';
			if ( isset($event) ) {
				$output .= '<fieldset class=" collapsible"><legend>'.t('Events').'</legend>';
			} else {
				$output .= '<div class="head">'.t('Events').':</div>';
			}
			$output .= theme('table', $events['header'], $events['rows']);
			if ( isset($event) ) {
				$output .= '</fieldset>';
			}
			$output .= '</div>';
		}
	}

	// esemeny form kiiratasa
	if ( isset($event) ) {
		$output .= '<div id="event">';
		$output .= $event;
		$output .= '</div>';
	}

	// mozgatas form kiiratasa
	if ( isset($move) ) {
		$output .= '<div id="move">';
		$output .= $move;
		$output .= '</div>';
	}
	return $output;
}

/**
 * ticket_edit_validate: ticket modositas ellenorzese
 */
function ticket_edit_validate($form_id, $form) {
	// problem start mezoben levo datum ellenorzese
	// Validate the "authored on" field. As of PHP 5.1.0, strtotime returns FALSE instead of -1 upon failure.
	if (!empty($form['start']) && strtotime($form['start']) <= 0) {
		form_set_error('start', t('Non-date format.'));
	}
	// problem finish mezoben levo datum ellenorzese
	if ( (!empty($form['finish']) && ( drupal_substr($form['finish'], 0, 1) != '*' ) ) || ($_POST['op'] == t('Close')) ) {
		if (strtotime($form['finish']) <= 0) {
			form_set_error('finish', t('Non-date format.'));
		}
		if (strtotime($form['start']) > 0) {
			if (strtotime($form['start']) > strtotime($form['finish'])) {
				form_set_error('finish', t('Date is earlier than Problem started!'));
			}
		}
	}

	if (!$form['assigned']) {
		form_set_error('assigned', t("No tickets can be assigned to user \"%anonym\"!", array('%anonym' =>  variable_get('anonymous', 'Anonymous')) ) );
	}

	// cc mezoben levo mail cim(ek) ellenorzese
	if ($form['cc'] != '') {
		if ( !_ticket_chk_emails($form['cc']) ) {
			form_set_error('cc', t('Faulty e-mail adddress(es).'));
		}
	}
}

/**
 * ticket_edit_submit: ticket modositas submit
 */
function ticket_edit_submit($form_id, $form) {
	global $user;

	$form['cc'] = preg_replace(array('/ +/', '/ ,+/'), array(' ', ','), $form['cc']);
	
	// kezdo idopont ellenorzese, ha nem volt megadva az aktualis idovel valo feltoltese.
	$form['start'] = strtotime($form['start']);
	// ha van megadva finish ido akkor annak megfelelo formaba hozasa, es az SQL kiegeszitese.
	if ( ( !empty($form['finish']) ) && ( drupal_substr($form['finish'], 0, 1) != '*' ) ) {
		$form['finish'] = strtotime($form['finish']);
		$sql_extra = ", finish = %d";
	} else {
		$form['finish'] = 'NULL';
		$sql_extra = ", finish = %s";
	}

	// ticket modositasa.
	$SQL = "UPDATE {ticket_ticket} SET priority_id = %d, type_id = %d, scope_id = %d, site_id = %d, fixer_id = %d, cc = '%s',";
	$SQL .= " summary = '%s', detail = '%s', affected = '%s', actions = '%s', time_to_fix = '%s', fix = '%s', start = %d".$sql_extra;
	$SQL .= " WHERE tid = %d";
	db_query($SQL, $form['priority'], $form['type'], $form['scope'], $form['site'], $form['fixer'], $form['cc'], $form['summary'], $form['detail'], $form['affected'], $form['actions'], $form['time_to_fix'], $form['fix'], $form['start'], $form['finish'], $form['tid']);

	$SQL = "UPDATE {ticket_ticket} SET assigned = %d WHERE tid = %d AND assigned = 0";
	db_query($SQL, $form['assigned'], $form['tid']);

	$SQL = "UPDATE {ticket_event} SET reassigned = %d WHERE tid = %d AND reassigned = 0 AND uid = 0";
	db_query($SQL, $form['assigned'], $form['tid']);

	// ticket id - mail id parok torlese
	db_query("DELETE FROM {ticket_rel_ticket_mail} WHERE tid = %d", $form['tid']);
	if ( count($form['mail']) ) {
		$form['mail'] = array_diff($form['mail'], array(0));
	}
	// az uj mail id - ticket id parok letrehozasa
	if ( count($form['mail']) ) {
		foreach ($form['mail'] as $key => $mail_id) {
			db_query("INSERT INTO {ticket_rel_ticket_mail} (tid, mail_id) VALUES (%d, %d)", $form['tid'], $key);
		}
	}
	// hibajegy lezarasa
	if ($_POST['op'] == t('Close')) {
		$result = db_query("SELECT eid FROM {ticket_event} WHERE uid = 0 AND tid = %d", $form['tid']);
		// ha ez az elso esemeny akkor az ures esemenyt updatelni kell
		if (db_num_rows($result)) {
			$row = db_fetch_array($result);
			$eid = $row['eid'];
			$SQL = "UPDATE {ticket_event} SET tid = %d, uid = %d, reassigned = %d, created = %d, description = '%s', status_id = %d WHERE eid = %d";
		} else {
			$eid = db_next_id('{ticket_event}_eid');
			$SQL = 'INSERT INTO {ticket_event} (tid, uid, reassigned, created, description, status_id, eid)';
			$SQL .= " VALUES (%d, %d, %d, %d, '%s', %d, %d)";
		}
		db_query($SQL, $form['tid'], $user->uid, $form['assigned'], time(), t('Closed.'), $form['status'], $eid);
		db_query("UPDATE {ticket_ticket} SET closed = 1 WHERE tid = %d", $form['tid']);
		// level kuldes
		_ticket_mail_send($form['gid'], $form['tid'], 2);
	}
}

/**
 * ticket_add_event_submit: ticket event hozzaadas submit
 */
function ticket_add_event_submit($form_id, $form) {
	global $user;

	$result = db_query("SELECT eid FROM {ticket_event} WHERE uid = 0 AND tid = %d", $form['tid']);
	// ha ez az elso esemeny akkor az ures esemenyt updatelni kell
	if (db_num_rows($result)) {
		$row = db_fetch_array($result);
		$eid = $row['eid'];
		$SQL = "UPDATE {ticket_event} SET tid = %d, uid = %d, reassigned = %d, created = %d, description = '%s', status_id = %d WHERE eid = %d";
	} else {
		$eid = db_next_id('{ticket_event}_eid');
		$SQL = 'INSERT INTO {ticket_event} (tid, uid, reassigned, created, description, status_id, eid)';
		$SQL .= " VALUES (%d, %d, %d, %d, '%s', %d, %d)";
	}
	db_query($SQL, $form['tid'], $user->uid, $form['assigned'], time(), $form['description'], $form['status'], $eid);
	// level kuldes
	_ticket_mail_send($form['gid'], $form['tid'], 1);
}

/**
 * ticket_reopen_submit: ticket ujranyitasa
 */
function ticket_reopen_submit($form_id, $form) {
	global $user;

	$result = db_query('SELECT status_id FROM {ticket_status} WHERE gid = %d AND def = 1', $form['gid']);
	if ( $row = db_fetch_array($result) ) {
		$eid = db_next_id('{ticket_event}_eid');
		$SQL = 'INSERT INTO {ticket_event} (eid, tid, uid, reassigned, created, description, status_id)';
		$SQL .= " VALUES (%d, %d, %d, %d, %d, '%s', %d)";
		db_query($SQL, $eid, $form['tid'], $user->uid, $form['assigned'], time(), t('Reopen.'), $row['status_id']);
		db_query("UPDATE {ticket_ticket} SET closed = 0 WHERE tid = %d", $form['tid']);
	}
}

/**
 * ticket_move_submit: mozgatasa
 */
function ticket_move_submit($form_id, $form) {
	global $user;
	$SQL = "SELECT tp.priority_name, tt.type_name, tsc.scope_name, tsi.site_name, tf.fixer_name ";
	$SQL .= " FROM {ticket_ticket} t, {ticket_priority} tp, {ticket_type} tt, {ticket_scope} tsc, {ticket_site} tsi, {ticket_fixer} tf";
	$SQL .= " WHERE t.tid = %d AND t.priority_id = tp.priority_id AND t.type_id = tt.type_id AND t.scope_id = tsc.scope_id AND t.site_id = tsi.site_id AND t.fixer_id = tf.fixer_id";
	$result = db_query($SQL, $form['tid']);
	if ($row = db_fetch_array($result)) {
		// azonos nevu tulajdonsagok keresese
		$list = array('type', 'priority', 'scope', 'site', 'fixer');
		foreach ($list as $element) {
			$SQL = "SELECT ".$element."_id FROM {ticket_".$element."} ";
			$SQL .= " WHERE gid = %d AND ".$element."_name = '%s' ORDER BY def";
			$rs = db_query($SQL, $form['group'], $row[$element.'_name']);
			// ha van egyezo akkor frissitunk arra
			if ($re = db_fetch_array($rs)) {
				db_query("UPDATE {ticket_ticket} SET ".$element."_id = %d WHERE tid = %d", $re[$element.'_id'], $form['tid']);
			} else {
				// alapertelmezett tulajdonsag kikeresese, ha nincs akkor 0
				$SQL = "SELECT ".$element."_id FROM {ticket_".$element."} ";
				$SQL .= ' WHERE gid = %d AND def = 1 ORDER BY def';
				$rs = db_query($SQL, $form['group']);
				if ($re = db_fetch_array($rs)) {
					db_query("UPDATE {ticket_ticket} SET ".$element."_id = %d WHERE tid = %d", $re[$element.'_id'], $form['tid']);
				} else {
					db_query("UPDATE {ticket_ticket} SET ".$element."_id = 0 WHERE tid = %d", $form['tid']);
				}
			}
		}
	}

	// levelezo "partnerek" atvitele
	$result = db_query("SELECT tm.mailto FROM {ticket_rel_ticket_mail} tr, {ticket_mail} tm WHERE tr.tid = %d AND tr.mail_id = tm.mail_id", $form['tid']);
	$mail = array();
	while ($row = db_fetch_array($result)) {
		$mail[] = $row['mailto'];
	}
	if ( count($mail) ) {
		$SQL = "SELECT mail_id FROM {ticket_mail} WHERE gid = %d AND mailto IN (".implode(',', array_map("_ticket_txt2db", $mail)).') ORDER BY def';
		$result = db_query($SQL, $form['group']);
		db_query("DELETE FROM {ticket_rel_ticket_mail} WHERE tid = %d", $form['tid']);
		if ( db_num_rows($result) ) {
			while ($row = db_fetch_array($result)) {
				db_query("INSERT INTO {ticket_rel_ticket_mail} (tid, mail_id) VALUES (%d, %d)", $form['tid'], $row['mail_id']);
			}
		} else {
			$SQL = 'SELECT mail_id FROM {ticket_mail} WHERE gid = %d AND def = 1 ORDER BY def';
			$result = db_query($SQL, $form['group']);
			while ($row = db_fetch_array($result)) {
				db_query("INSERT INTO {ticket_rel_ticket_mail} (tid, mail_id) VALUES (%d, %d)", $form['tid'], $row['mail_id']);
			}
		}
	}

	// Esemeny mozgatasa, vagy uj esemeny hozzafuzese.
	$SQL = "SELECT te.eid, te.uid, te.tid, te.reassigned, ts.status_name FROM {ticket_event} te, {ticket_status} ts";
	$SQL .= " WHERE te.tid = %d AND te.status_id = ts.status_id ORDER BY te.created DESC ";
	$result = db_query($SQL, $form['tid']);
	if ($row = db_fetch_array($result)) {
		$SQL = "SELECT status_id FROM {ticket_status} WHERE gid = %d AND status_name = '%s' ORDER BY def";
		$rs = db_query($SQL, $form['group'], $row['status_name']);
		// ha van egyezo akkor frissitunk arra
		if ($s_row = db_fetch_array($rs)) {
			db_query("UPDATE {ticket_event} SET status_id = %d WHERE eid = %d", $s_row['status_id'], $row['eid']);
		} else {
			$SQL = 'SELECT status_id FROM {ticket_status} WHERE gid = %d AND def = 1 ORDER BY def';
			$rs = db_query($SQL, $form['group']);
			if ($s_row = db_fetch_array($rs)) {
				if ($row['uid'] == 0) {
				// ha nem volt meg esemeny akkor az alapertelmezettre modositjuk az allapot jelzot
					db_query("UPDATE {ticket_event} SET status_id = %d WHERE eid = %d", $s_row['status_id'], $row['eid']);
				} else {
				// ha volt mar esemeny akkor, uj esemeny hozza fuzese
					$eid = db_next_id('{ticket_event}_eid');
					$SQL = "INSERT INTO {ticket_event} (eid, tid, uid, reassigned, created, description, status_id) VALUES (%d, %d, %d, %d, %d, '%s', %d)";
					db_query($SQL, $eid, $row['tid'], $user->uid, $row['reassigned'], time(), t('Reloacted.'), $s_row['status_id']);
				}
			}
		}
		
	}	
	// ugras az uj cimere
	db_query("UPDATE {ticket_ticket} SET gid = %d WHERE tid = %d", $form['group'], $form['tid']);
	drupal_goto('ticket/'.$form['u_id'].'/'.$form['group'].'/'.$form['tid']);
}

/**
 * ticket_list: ticket list
 */
function ticket_list($u_id, $gid) {
	global $ticket_conf, $user;
	// js ami eltunteti a submit gombot es a select ertekvaltasra automatikusan submitol
	drupal_add_js('modules/ticket/ticket.js');
#	drupal_set_header('Refresh: '.$ticket_conf['page_refresh'].';');
	drupal_set_html_head('<meta http-equiv="refresh" content="'.$ticket_conf['page_refresh'].'" />');

	// listazas parameterei, ha meg nem nezte ezt a listat akkor beallitja az alapertelmezett ertekeket
	if ( empty($_SESSION['ticket_list_'.$u_id.'_'.$gid]) ) {
		$def['sstatus'] = -1;
		$def['status'] = -1;
		$def['type'] = -1;
		$def['assigned'] = -1;
	} else {
		$def = $_SESSION['ticket_list_'.$u_id.'_'.$gid];
	}
	$sstatus = array('-1' => t('any'), '0' => t('open'), '1' => t('closed'));
	$status['-1'] = t('any');
	$type['-1'] = t('any');
	$assigned['-1'] = t('anybody');

	// valaszthato tulajdonsagok ertekeinek listaja  
	if ($gid) {
	// egy csoport listaja
		$SQL = 'SELECT status_id, status_name, def FROM {ticket_status} WHERE gid = %d AND active = 1 ORDER BY weight, status_name';
		$result = db_query($SQL, $gid);
		while ($row = db_fetch_array($result)) {
			$status[$row['status_id']] = $row['status_name'];
		}

		$SQL = 'SELECT type_id, type_name, def FROM {ticket_type} WHERE gid = %d AND active = 1 ORDER BY weight, type_name';
		$result = db_query($SQL, $gid);
		while ($row = db_fetch_array($result)) {
			$type[$row['type_id']] = $row['type_name'];
		}

		$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
		$SQL .= " WHERE ( (tp.u_id = %d OR tp.u_id = 0) AND (tp.gid = %d OR tp.gid = 0) ) AND tp.role_id = p.rid AND p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
		$result = db_query($SQL, $u_id, $gid);
		while ($row = db_fetch_array($result)) {
			$assigned[$row['uid']] = $row['name'];
		}
	} else {
	// egy unit listaja
		if ( ( ticket_access('ticket manager', $u_id, 0) ) || ( ticket_access('ticket reader', $u_id, 0) ) ) {
			$SQL = "SELECT gid FROM {ticket_group} WHERE u_id = %d ORDER BY weight, group_name";
			$result = db_query($SQL, $u_id);
		} else {
			$SQL = "SELECT tg.gid, tg.group_name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {ticket_group} tg";
			$SQL .= " WHERE tp.u_id = %d AND ur.uid = %d AND tp.role_id = p.rid AND";
			$SQL .= " (p.perm LIKE '%ticket manager%' OR p.perm LIKE '%ticket reader%') AND ur.rid = p.rid AND tg.gid = tp.gid";
			$SQL .= " ORDER BY tg.group_name";
			$result = db_query($SQL, $u_id, $user->uid);
		}
	
		if ( db_num_rows($result) ) {
			while ($row = db_fetch_array($result)) {
				$groups[] = $row['gid'];
			}
		}
		$groups = implode(',', $groups);

		$SQL = "SELECT ts.status_name FROM {ticket_group} tg, {ticket_status} ts";
		$SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND tg.gid = ts.gid AND ts.active = 1 GROUP BY ts.status_name ORDER BY ts.weight, ts.status_name";
		$result = db_query($SQL, $u_id, $groups);
		while ($row = db_fetch_array($result)) {
			$status[$row['status_name']] = $row['status_name'];
		}

		$SQL = "SELECT tt.type_name FROM {ticket_group} tg, {ticket_type} tt";
		$SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND tg.gid = tt.gid AND tt.active = 1 GROUP BY tt.type_name ORDER BY tt.weight, tt.type_name";
		$result = db_query($SQL, $u_id, $groups);
		while ($row = db_fetch_array($result)) {
			$type[$row['type_name']] = $row['type_name'];
		}

		$SQL = "SELECT u.uid, u.name FROM {ticket_permission} tp, {permission} p, {users_roles} ur, {users} u ";
		$SQL .= " WHERE (tp.u_id = %d OR tp.u_id = 0) AND tp.role_id = p.rid AND p.perm LIKE '%ticket manager%' AND ur.rid = p.rid AND ur.uid = u.uid";
		$result = db_query($SQL, $u_id);
		while ($row = db_fetch_array($result)) {
			$assigned[$row['uid']] = $row['name'];
		}		
	}

	$form['sstatus'] = array(
		'#type' => 'select',
		'#title' => t('Simple status'),
		'#options' => $sstatus,
		'#default_value' => $def['sstatus'],
		'#prefix' => '<div class = "ticket-line">',
		'#suffix' => '</div>',
		'#required' => true,
	);

	// form elkeszitese
	if ( count($status) ) {
		$form['status'] = array(
			'#type' => 'select',
			'#title' => t('Status'),
			'#options' => $status,
			'#default_value' => $def['status'],
			'#prefix' => '<div class = "ticket-line">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	if ( count($type) ) {
		$form['type'] = array(
			'#type' => 'select',
			'#title' => t('Type'),
			'#options' => $type,
			'#default_value' => $def['type'],
			'#prefix' => '<div class = "ticket-line">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	if ( count($assigned) ) {
		$form['assigned'] = array(
			'#type' => 'select',
			'#title' => t('Assigned to'),
			'#options' => $assigned,
			'#default_value' => $def['assigned'],
			'#prefix' => '<div class = "ticket-line">',
			'#suffix' => '</div>',
			'#required' => true,
		);
	}

	$form['u_id'] = array(
		'#type' => 'value',
		'#value' => $u_id,
	);

	$form['gid'] = array(
		'#type' => 'value',
		'#value' => $gid,
	);

	$form['submit'] = array(
		'#type' => 'submit',
		'#attributes' => array('id' => 'refresh-submit'),
		'#value' => t('Refresh')
	);

	$list_form = drupal_get_form('ticket_list_form', $form);
	$param[0] = $param[1] = NULL;
	$sql['table'] = $sql['where'] = array();
	$i = 0;

	// csoporton beluli lista elkeszitese
	if ($gid) {
		if ( $def['type'] != -1 ) {
			$sql['where'][] = 'AND type_id = %d';
			$param[0] = $def['type'];
			$i++;
		}
		if ( $def['sstatus'] != -1 ) {
			$sql['where'][] = 'AND closed = %d';
			$param[$i] = $def['sstatus'];
		}


		// lista lekerdezese az adatbazisbol
		$SQL = "CREATE TEMPORARY TABLE tmp_table ( SELECT tt.tid, COUNT(tt.tid) AS num, MAX(te.created) AS created";
		$SQL .= " FROM {ticket_ticket} tt, {ticket_event} te ";
		$SQL .= "WHERE tt.gid = %d AND tt.tid = te.tid ".implode(' ', $sql['where']);
		$SQL .= " GROUP BY tt.tid )";
		db_query($SQL, $gid, $param[0], $param[1]);

		$i = 0;
		// listabol a feltetelnek nem megfelelo adatok kitorlese 
		if ( ($def['status'] != -1) || ($def['assigned'] != -1) ) {
			$sql['where'] = array();
			if ( $def['status'] == -1 ) {
				$sql['where'][] = 0;
			} else {
				$sql['where'][] = ' te.status_id <> %d ';
				$param[0] = $def['status'];
				$i++;
			}

			if ( $def['assigned'] == -1 ) {
				$sql['where'][] = 0;
			} else {
				$sql['where'][] = ' te.reassigned <> %d ';
				$param[$i] = $def['assigned'];
			}

			$SQL = "DELETE FROM {tmp_table} tmp USING {tmp_table} tmp, {ticket_event} te ";
			$SQL .= " WHERE tmp.tid = te.tid AND te.created = tmp.created AND";
			$SQL .= " (".implode(' OR ', $sql['where']).")";
			db_query($SQL, $param[0], $param[1]);
		}
	} else {
	// uniton beluli lista elkeszitese
		if ( $def['type'] != -1 ) {
			$sql['table'][] = ', {ticket_type} ttype';
			$sql['where'][] = "AND tt.type_id = ttype.type_id AND ttype.type_name = '%s'";
			$param[0] = $def['type'];
			$i++;
		}
		if ( $def['sstatus'] != -1 ) {
			$sql['where'][] = 'AND closed = %d';
			$param[$i] = $def['sstatus'];
		}

		// lista lekerdezese az adatbazisbol
		$SQL = "CREATE TEMPORARY TABLE tmp_table ( SELECT tt.tid, COUNT(tt.tid) AS num, MAX(te.created) AS created";
		$SQL .= " FROM {ticket_group} tg, {ticket_ticket} tt, {ticket_event} te ".implode(', ', $sql['table']);
		$SQL .= " WHERE tg.u_id = %d AND tg.gid IN (%s) AND tg.gid = tt.gid AND tt.tid = te.tid ".implode(' ', $sql['where']);
		$SQL .= " GROUP BY tt.tid )";
		db_query($SQL, $u_id, $groups, $param[0], $param[1]);

		$i = 0;
		// listabol a feltetelnek nem megfelelo adatok kitorlese 
		if ( ($def['status'] != -1) || ($def['assigned'] != -1) ) {
			$sql['where'] = array();
			if ( $def['status'] == -1 ) {
				$sql['where'][] = 0;
			} else {
				$sql['where'][] = " ts.status_name <> '%s' ";
				$param[0] = $def['status'];
				$i++;
			}

			if ( $def['assigned'] == -1 ) {
				$sql['where'][] = 0;
			} else {
				$sql['where'][] = ' te.reassigned <> %d ';
				$param[$i] = $def['assigned'];
			}

			$SQL = "DELETE FROM {tmp_table} tmp USING {tmp_table} tmp, {ticket_event} te , {ticket_status} ts ";
			$SQL .= " WHERE te.status_id = ts.status_id AND tmp.tid = te.tid AND te.created = tmp.created AND";
			$SQL .= " (".implode(' OR ', $sql['where']).")";
			db_query($SQL, $param[0], $param[1]);
		}
	}

	// tablazat es lapozo elkeszitese
	list($table, $pager) = _ticket_list_table($u_id, $gid);

	return theme('ticket_list', $list_form, $table, $pager);
}

/**
 * theme_ticket_list: theme hook
 */
function theme_ticket_list($list_form, $table = NULL, $pager = NULL) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	$output = '';
	$output .= '<div id = "ticket_header">';
	$output .= $list_form;
	$output .= '</div>';

	if ( isset($table) ) {
		$output .= '<div id = "ticket_table">';
		$output .= $table;
		$output .= '</div>';
	}
	if ( isset($pager) ) {
		$output .= '<div id = "ticket_footer">';
		$output .= $pager;
		$output .= '</div>';
	}
	return $output;
}

/**
 * ticket_list_form_submit: ticket list submit
 */
function ticket_list_form_submit($form_id, $form) {
	$def['sstatus'] = $form['sstatus'];
	$def['type'] = $form['type'];
	$def['status'] = $form['status'];
	$def['assigned'] = $form['assigned'];
	// sessionbe menti az alapertelmezett beallitasokat
	$_SESSION['ticket_list_'.$form['u_id'].'_'.$form['gid']] = $def;
}

/**
 * ticket_search_tid: hibajegy azonosito alapjan keres
 */
function ticket_search_tid() {
	$form['tid'] = array(
		'#type' => 'textfield',
		'#title' => t('Ticket ID'),
		'#maxlength' => '20',
		'#size' => '20',
	);

	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Search')
	);

	return drupal_get_form('ticket_search_tid', $form);
}

/**
 * ticket_search_tid_validate: ticket search tid form validate
 */
function ticket_search_tid_validate($form_id, $form) {
	$error = ticket_ticketid($form['tid']);
	form_set_error('', $error);
}

/**
 * ticket_search_simple: ticket simple search
 */
function ticket_search_simple($u_id = NULL, $gid = NULL) {
	$def['priority'] = $def['site'] = -1;
	$def['status'] = $def['uid'] = $def['assigned'] = -1;
	$def['date1']['y'] = $def['date1']['m'] = $def['date1']['d'] = -1;
	$def['date2']['y'] = $def['date2']['m'] = $def['date2']['d'] = -1;
	$def['ssum'] = $def['detail'] = '';

	$links = func_get_args();
	return _ticket_search_base($def, $links, $u_id, $gid);
}

/**
 * ticket_search_advanced: ticket advanced search
 */
function ticket_search_advanced($u_id = NULL, $gid = NULL) {
	$def['type'] = $def['priority'] = $def['scope'] = $def['site'] = -1;
	$def['fixer'] = $def['status'] = $def['uid'] = $def['assigned'] = -1;
	$def['date1']['y'] = $def['date1']['m'] = $def['date1']['d'] = -1;
	$def['date2']['y'] = $def['date2']['m'] = $def['date2']['d'] = -1;
	$def['ssum'] = $def['detail'] = $def['affected'] = '';
	$def['actions'] = $def['time_to_fix'] = $def['fix'] = '';

	$links = func_get_args();
	return _ticket_search_base($def, $links, $u_id, $gid);
}

/**
 * ticket_search_form_submit: ticket search submit hook
 */
function ticket_search_form_submit($form_id, $form) {
	// datum darabok ossze illesztese
	if ($form['date1-y'] != '-1') {
		$date = $form['date1-y'].'-';
		if ($form['date1-m'] != '-1') {
			$date .= $form['date1-m'].'-';
		} else {
			$date .= '01-';
		}
		if ($form['date1-d'] != '-1') {
			$date .= $form['date1-d'];
		} else {
			$date .= '01';
		}
		$form['date1'] = $date;
	}
	unset($form['date1-y'], $form['date1-m'], $form['date1-d']);

	// datum darabok ossze illesztese
	if ($form['date2-y'] != '-1') {
		$date = $form['date2-y'].'-';
		if ($form['date2-m'] != '-1') {
			$date .= $form['date2-m'].'-';
		} else {
			$date .= '01-';
		}
		if ($form['date2-d'] != '-1') {
			$date .= $form['date2-d'];
		} else {
			$date .= '01';
		}
		$form['date2'] = $date;
	}
	unset($form['date2-y'], $form['date2-m'], $form['date2-d']);

	// keresesi parameterekbol url keszitese
	$url = 'ticket';
	if (isset($form['u_id']) && !is_array($form['u_id'])) {
		$url .= '/'.$form['u_id'];
		if (isset($form['gid']) && !is_array($form['gid'])) {
			$url .= '/'.$form['gid'];
		}
	}
	if (isset($form['affected'])) {
		$url .= '/search/advanced';
	} else {
		$url .= '/search/simple';
	}

	$url .= _ticket_search_link($form);
	// visszateres a cimmel, alapesetben ugras arra az oldalra
	return $url;
}

/**
 * ticket_export: ticket export
 */
function ticket_export($u_id = NULL, $gid = NULL) {
	$def['type'] = $def['priority'] = $def['scope'] = $def['site'] = -1;
	$def['fixer'] = $def['status'] = $def['uid'] = $def['assigned'] = -1;
	$def['date1']['y'] = $def['date1']['m'] = $def['date1']['d'] = -1;
	$def['date2']['y'] = $def['date2']['m'] = $def['date2']['d'] = -1;
	$def['ssum'] = $def['detail'] = $def['affected'] = '';
	$def['actions'] = $def['time_to_fix'] = $def['fix'] = '';
	$def['field'] = array('tid', 'uid', 'type_name', 'priority_name', 'scope_name', 'site_name',
							'fixer_name', 'assigned', 'start', 'finish', 'length', 'summary');

	$form = array();
	if ( isset($u_id) ) {
		$form['u_id'] = array(
			'#type' => 'value',
			'#value' => $u_id,
		);
	} else {
		$def['unit'] = -1;
	}

	if ( isset($gid) ) {
		$form['gid'] = array(
			'#type' => 'value',
			'#value' => $gid,
		);
	} else {
		$def['group'] = -1;
	}

	$links = func_get_args();
	unset($links[0], $links[1]);
	// ha tortent exportalas
	if ( count($links) ) {
		// a link parameterbol csinal tombot
		$links = _ticket_search_get_default($links);
		// link ertekeivel felul irja az alapertelmezett ertekeket
		$def = array_merge($def, $links);
		if ( !is_array($def['date1']) ) {
			// datum szetdarabolasa
			list($y, $m, $d) = explode('-', $def['date1']);
			$def['date1'] = array();
			$def['date1']['y'] = $y;
			$def['date1']['m'] = $m;
			$def['date1']['d'] = $d;
		}
		if ( !is_array($def['date2']) ) {
			// datum szetdarabolasa
			list($y, $m, $d) = explode('-', $def['date2']);
			$def['date2'] = array();
			$def['date2']['y'] = $y;
			$def['date2']['m'] = $m;
			$def['date2']['d'] = $d;
		}
	}

	// kereses lehetseges ertekei
	$var = _ticket_search_attrib($u_id, $gid);
	// form elkeszitese
	_ticket_search_form($form, $var, $def);

	// form export resze
	$form['export'] = array(
		'#type' => 'fieldset',
		'#title' => t('Export'),
		'#collapsible' => TRUE,
		'#collapsed' => false,
	);

	// valaszthato mezok listaja
	$field = array(
		'unit_name' => t('Unit'),
		'group_name' => t('Group'),
		'tid' => t('Ticket ID'),
		'uid' => t('Opened by'),
		'type_name' => t('Type'),
		'priority_name' => t('Priority'),
		'scope_name' => t('Scope'),
		'site_name' => t('Site'),
		'fixer_name' => t('Fixer'),
		'assigned' => t('Assigned to'),
		'start' => t('Problem started'),
		'finish' => t('Problem fixed'),
		'length' => t('Problem length'),
		'summary' => t('Short summary'),
		'detail' => t('Detail'),
		'affected' => t('Affected'),
		'actions' => t('Actions'),
		'time_to_fix' => t('Time to fix'),
		'fix' => t('Fix'),
	);

	$form['export']['field'] = array(
		'#type' => 'checkboxes',
		'#title' => t('Export fields'),
		'#options' => $field,
		'#default_value' => $def['field'],
		'#required' => true,
	);
	$mode = array(
		'csv' => t('CSV'),
		'web' => t('Web'),
	);

	$form['export']['mode'] = array(
		'#type' => 'select',
		'#title' => t('Export format'),
		'#options' => $mode,
		'#default_value' => $links['mode'],
		'#prefix' => '<div class="ticket-form-line-select">',
		'#suffix' => '</div>',
	);

	$form['submit'] = array(
		'#type' => 'submit',
		'#value' => t('Export'),
	);

	// ha volt mar exportalas
	if ( count($links) ) {
		$form['src']['#collapsed'] = TRUE;
		$form['export']['#collapsed'] = TRUE;
		$links['u_id'] = $u_id;
		$links['gid'] = $gid;
		_ticket_search($links, $var);
		$table = _ticket_export($u_id, $gid, $links['field'], $links['mode']);
	}

	// exportalas tipusa
	if ($links['mode'] == 'csv') {
		$output = NULL;
		// csv fileba kuldes
		drupal_set_header('Content-Type: text/comma-separated-values');
		drupal_set_header('Content-Disposition: attachment;filename="ticket-export.csv'.'";');
		echo $table;
	} else {
		$search_form = drupal_get_form('ticket_export', $form);
		$output = theme('ticket_export_web', $search_form, $table);
	}
	return $output;
}

/**
 * ticket_export_submit: ticket export submit
 */
function ticket_export_submit($form_id, $form) {
	// van mar keresesunk akkor hasznaljuk
	$url = ticket_search_form_submit($form_id, $form);
	// url atalakitasa nekunk tetszore
	$url = str_replace(array('search/advanced', '+0'), array('export', ''), $url);
	return $url;
}

/**
 * theme_ticket_export_web: theme hook
 */
function theme_ticket_export_web($export_form, $table = NULL) {
	theme_add_style($path = 'modules/ticket/style.css', $media = 'all');
	$output = '';
	$output .= '<div id = "ticket_header">';
	$output .= $export_form;
	$output .= '</div>';

	if ( isset($table) ) {
		$output .= '<div id = "ticket_export">';
		$output .= $table;
		$output .= '</div>';
	}
	return $output;
}
?>